unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Drawing.Drawing2D,
  System.Drawing.Imaging;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    Panel1: System.Windows.Forms.Panel;
    TabControl1: System.Windows.Forms.TabControl;
    TabPage1: System.Windows.Forms.TabPage;
    TabPage2: System.Windows.Forms.TabPage;
    Button1: System.Windows.Forms.Button;
    rbtnRound: System.Windows.Forms.RadioButton;
    rbtnRoundAnc: System.Windows.Forms.RadioButton;
    rbtnSq: System.Windows.Forms.RadioButton;
    rbtnSqAnc: System.Windows.Forms.RadioButton;
    rbtnFlat: System.Windows.Forms.RadioButton;
    TabPage3: System.Windows.Forms.TabPage;
    rbBevel: System.Windows.Forms.RadioButton;
    rbMiter: System.Windows.Forms.RadioButton;
    rbRound: System.Windows.Forms.RadioButton;
    rbMiterClipped: System.Windows.Forms.RadioButton;
    TabPage4: System.Windows.Forms.TabPage;
    TrackBar1: System.Windows.Forms.TrackBar;
    Label1: System.Windows.Forms.Label;
    rbtnCardinal: System.Windows.Forms.RadioButton;
    rbtnBSR2: System.Windows.Forms.RadioButton;
    rbtnBSR1: System.Windows.Forms.RadioButton;
    rbtnBSC: System.Windows.Forms.RadioButton;
    rbtnBSL: System.Windows.Forms.RadioButton;
    TabPage5: System.Windows.Forms.TabPage;
    lbxShapes: System.Windows.Forms.ListBox;
    cbxFillShape: System.Windows.Forms.CheckBox;
    lbxFillStyle: System.Windows.Forms.ListBox;
    TrackBar2: System.Windows.Forms.TrackBar;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
    procedure Panel1_Paint(sender: System.Object; e: System.Windows.Forms.PaintEventArgs);
    procedure TrackBar2_MouseDown(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
    procedure TrackBar2_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    MyGraphics: Graphics;
    MyPen: Pen;
    ClearOK: Boolean;

    function DrawAngle(aGraphics: Graphics; aPen: Pen;
      aFromPt: Point; aLength: Integer; aTheta: Double): Point;
    procedure ClearCanvas;

    procedure PaintLines;
    procedure PaintLineCaps;
    procedure PaintLineJoins;
    procedure PaintCurves;
    procedure PaintShapes;
    procedure paintCardinal;
    procedure paintBezier;

  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
type
  TSystem_ObjectArray = array of System.Object;
begin
  Self.Panel1 := System.Windows.Forms.Panel.Create;
  Self.TabControl1 := System.Windows.Forms.TabControl.Create;
  Self.TabPage1 := System.Windows.Forms.TabPage.Create;
  Self.TabPage2 := System.Windows.Forms.TabPage.Create;
  Self.rbtnFlat := System.Windows.Forms.RadioButton.Create;
  Self.rbtnSqAnc := System.Windows.Forms.RadioButton.Create;
  Self.rbtnSq := System.Windows.Forms.RadioButton.Create;
  Self.rbtnRoundAnc := System.Windows.Forms.RadioButton.Create;
  Self.rbtnRound := System.Windows.Forms.RadioButton.Create;
  Self.TabPage3 := System.Windows.Forms.TabPage.Create;
  Self.rbMiterClipped := System.Windows.Forms.RadioButton.Create;
  Self.rbRound := System.Windows.Forms.RadioButton.Create;
  Self.rbMiter := System.Windows.Forms.RadioButton.Create;
  Self.rbBevel := System.Windows.Forms.RadioButton.Create;
  Self.TabPage4 := System.Windows.Forms.TabPage.Create;
  Self.rbtnBSL := System.Windows.Forms.RadioButton.Create;
  Self.rbtnBSC := System.Windows.Forms.RadioButton.Create;
  Self.rbtnBSR1 := System.Windows.Forms.RadioButton.Create;
  Self.rbtnBSR2 := System.Windows.Forms.RadioButton.Create;
  Self.rbtnCardinal := System.Windows.Forms.RadioButton.Create;
  Self.Label1 := System.Windows.Forms.Label.Create;
  Self.TrackBar1 := System.Windows.Forms.TrackBar.Create;
  Self.TabPage5 := System.Windows.Forms.TabPage.Create;
  Self.TrackBar2 := System.Windows.Forms.TrackBar.Create;
  Self.lbxFillStyle := System.Windows.Forms.ListBox.Create;
  Self.cbxFillShape := System.Windows.Forms.CheckBox.Create;
  Self.lbxShapes := System.Windows.Forms.ListBox.Create;
  Self.Button1 := System.Windows.Forms.Button.Create;
  Self.TabControl1.SuspendLayout;
  Self.TabPage2.SuspendLayout;
  Self.TabPage3.SuspendLayout;
  Self.TabPage4.SuspendLayout;
  (System.ComponentModel.ISupportInitialize(Self.TrackBar1)).BeginInit;
  Self.TabPage5.SuspendLayout;
  (System.ComponentModel.ISupportInitialize(Self.TrackBar2)).BeginInit;
  Self.SuspendLayout;
  // 
  // Panel1
  // 
  Self.Panel1.Anchor := (System.Windows.Forms.AnchorStyles(((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Right)));
  Self.Panel1.Location := System.Drawing.Point.Create(8, 144);
  Self.Panel1.Name := 'Panel1';
  Self.Panel1.Size := System.Drawing.Size.Create(624, 280);
  Self.Panel1.TabIndex := 0;
  Include(Self.Panel1.Paint, Self.Panel1_Paint);
  // 
  // TabControl1
  // 
  Self.TabControl1.Controls.Add(Self.TabPage1);
  Self.TabControl1.Controls.Add(Self.TabPage2);
  Self.TabControl1.Controls.Add(Self.TabPage3);
  Self.TabControl1.Controls.Add(Self.TabPage4);
  Self.TabControl1.Controls.Add(Self.TabPage5);
  Self.TabControl1.Location := System.Drawing.Point.Create(8, 0);
  Self.TabControl1.Name := 'TabControl1';
  Self.TabControl1.SelectedIndex := 0;
  Self.TabControl1.Size := System.Drawing.Size.Create(624, 136);
  Self.TabControl1.TabIndex := 2;
  Include(Self.TabControl1.Click, Self.Button1_Click);
  Include(Self.TabControl1.SelectedIndexChanged, Self.Button1_Click);
  // 
  // TabPage1
  // 
  Self.TabPage1.Location := System.Drawing.Point.Create(4, 22);
  Self.TabPage1.Name := 'TabPage1';
  Self.TabPage1.Size := System.Drawing.Size.Create(616, 110);
  Self.TabPage1.TabIndex := 0;
  Self.TabPage1.Text := 'Lines';
  // 
  // TabPage2
  // 
  Self.TabPage2.Controls.Add(Self.rbtnFlat);
  Self.TabPage2.Controls.Add(Self.rbtnSqAnc);
  Self.TabPage2.Controls.Add(Self.rbtnSq);
  Self.TabPage2.Controls.Add(Self.rbtnRoundAnc);
  Self.TabPage2.Controls.Add(Self.rbtnRound);
  Self.TabPage2.Location := System.Drawing.Point.Create(4, 22);
  Self.TabPage2.Name := 'TabPage2';
  Self.TabPage2.Size := System.Drawing.Size.Create(616, 110);
  Self.TabPage2.TabIndex := 1;
  Self.TabPage2.Text := 'Line Caps';
  Include(Self.TabPage2.Click, Self.Button1_Click);
  // 
  // rbtnFlat
  // 
  Self.rbtnFlat.Checked := True;
  Self.rbtnFlat.Location := System.Drawing.Point.Create(288, 16);
  Self.rbtnFlat.Name := 'rbtnFlat';
  Self.rbtnFlat.TabIndex := 4;
  Self.rbtnFlat.TabStop := True;
  Self.rbtnFlat.Text := 'Flat';
  Include(Self.rbtnFlat.Click, Self.Button1_Click);
  // 
  // rbtnSqAnc
  // 
  Self.rbtnSqAnc.Location := System.Drawing.Point.Create(152, 56);
  Self.rbtnSqAnc.Name := 'rbtnSqAnc';
  Self.rbtnSqAnc.TabIndex := 3;
  Self.rbtnSqAnc.Text := 'Square Anchor';
  Include(Self.rbtnSqAnc.Click, Self.Button1_Click);
  // 
  // rbtnSq
  // 
  Self.rbtnSq.Location := System.Drawing.Point.Create(152, 16);
  Self.rbtnSq.Name := 'rbtnSq';
  Self.rbtnSq.TabIndex := 2;
  Self.rbtnSq.Text := 'Square';
  Include(Self.rbtnSq.Click, Self.Button1_Click);
  // 
  // rbtnRoundAnc
  // 
  Self.rbtnRoundAnc.Location := System.Drawing.Point.Create(16, 56);
  Self.rbtnRoundAnc.Name := 'rbtnRoundAnc';
  Self.rbtnRoundAnc.TabIndex := 1;
  Self.rbtnRoundAnc.Text := 'Round Anchor';
  Include(Self.rbtnRoundAnc.Click, Self.Button1_Click);
  // 
  // rbtnRound
  // 
  Self.rbtnRound.Location := System.Drawing.Point.Create(16, 16);
  Self.rbtnRound.Name := 'rbtnRound';
  Self.rbtnRound.TabIndex := 0;
  Self.rbtnRound.Text := 'Round';
  Include(Self.rbtnRound.Click, Self.Button1_Click);
  // 
  // TabPage3
  // 
  Self.TabPage3.Controls.Add(Self.rbMiterClipped);
  Self.TabPage3.Controls.Add(Self.rbRound);
  Self.TabPage3.Controls.Add(Self.rbMiter);
  Self.TabPage3.Controls.Add(Self.rbBevel);
  Self.TabPage3.Location := System.Drawing.Point.Create(4, 22);
  Self.TabPage3.Name := 'TabPage3';
  Self.TabPage3.Size := System.Drawing.Size.Create(616, 110);
  Self.TabPage3.TabIndex := 2;
  Self.TabPage3.Text := 'Line Join';
  // 
  // rbMiterClipped
  // 
  Self.rbMiterClipped.Location := System.Drawing.Point.Create(144, 16);
  Self.rbMiterClipped.Name := 'rbMiterClipped';
  Self.rbMiterClipped.TabIndex := 3;
  Self.rbMiterClipped.Text := 'Miter Clipped';
  Include(Self.rbMiterClipped.Click, Self.Button1_Click);
  // 
  // rbRound
  // 
  Self.rbRound.Location := System.Drawing.Point.Create(24, 72);
  Self.rbRound.Name := 'rbRound';
  Self.rbRound.TabIndex := 2;
  Self.rbRound.Text := 'Round';
  Include(Self.rbRound.Click, Self.Button1_Click);
  // 
  // rbMiter
  // 
  Self.rbMiter.Location := System.Drawing.Point.Create(24, 43);
  Self.rbMiter.Name := 'rbMiter';
  Self.rbMiter.TabIndex := 1;
  Self.rbMiter.Text := 'Miter';
  Include(Self.rbMiter.Click, Self.Button1_Click);
  // 
  // rbBevel
  // 
  Self.rbBevel.Checked := True;
  Self.rbBevel.Location := System.Drawing.Point.Create(24, 16);
  Self.rbBevel.Name := 'rbBevel';
  Self.rbBevel.TabIndex := 0;
  Self.rbBevel.TabStop := True;
  Self.rbBevel.Text := 'Bevel';
  Include(Self.rbBevel.Click, Self.Button1_Click);
  // 
  // TabPage4
  // 
  Self.TabPage4.Controls.Add(Self.rbtnBSL);
  Self.TabPage4.Controls.Add(Self.rbtnBSC);
  Self.TabPage4.Controls.Add(Self.rbtnBSR1);
  Self.TabPage4.Controls.Add(Self.rbtnBSR2);
  Self.TabPage4.Controls.Add(Self.rbtnCardinal);
  Self.TabPage4.Controls.Add(Self.Label1);
  Self.TabPage4.Controls.Add(Self.TrackBar1);
  Self.TabPage4.Location := System.Drawing.Point.Create(4, 22);
  Self.TabPage4.Name := 'TabPage4';
  Self.TabPage4.Size := System.Drawing.Size.Create(616, 110);
  Self.TabPage4.TabIndex := 3;
  Self.TabPage4.Text := 'Curves';
  // 
  // rbtnBSL
  // 
  Self.rbtnBSL.Location := System.Drawing.Point.Create(416, 80);
  Self.rbtnBSL.Name := 'rbtnBSL';
  Self.rbtnBSL.Size := System.Drawing.Size.Create(168, 24);
  Self.rbtnBSL.TabIndex := 6;
  Self.rbtnBSL.Text := 'Bezier Spline Loop';
  Include(Self.rbtnBSL.Click, Self.Button1_Click);
  // 
  // rbtnBSC
  // 
  Self.rbtnBSC.Location := System.Drawing.Point.Create(416, 8);
  Self.rbtnBSC.Name := 'rbtnBSC';
  Self.rbtnBSC.Size := System.Drawing.Size.Create(168, 24);
  Self.rbtnBSC.TabIndex := 5;
  Self.rbtnBSC.Text := 'Bezier Spline Simple Curve';
  Include(Self.rbtnBSC.Click, Self.Button1_Click);
  // 
  // rbtnBSR1
  // 
  Self.rbtnBSR1.Location := System.Drawing.Point.Create(416, 32);
  Self.rbtnBSR1.Name := 'rbtnBSR1';
  Self.rbtnBSR1.Size := System.Drawing.Size.Create(168, 24);
  Self.rbtnBSR1.TabIndex := 4;
  Self.rbtnBSR1.Text := 'Bezier Spline Recurve 1';
  Include(Self.rbtnBSR1.Click, Self.Button1_Click);
  // 
  // rbtnBSR2
  // 
  Self.rbtnBSR2.Location := System.Drawing.Point.Create(416, 56);
  Self.rbtnBSR2.Name := 'rbtnBSR2';
  Self.rbtnBSR2.Size := System.Drawing.Size.Create(168, 24);
  Self.rbtnBSR2.TabIndex := 3;
  Self.rbtnBSR2.Text := 'Bezier Spline Recurve 2';
  Include(Self.rbtnBSR2.Click, Self.Button1_Click);
  // 
  // rbtnCardinal
  // 
  Self.rbtnCardinal.Checked := True;
  Self.rbtnCardinal.Location := System.Drawing.Point.Create(144, 8);
  Self.rbtnCardinal.Name := 'rbtnCardinal';
  Self.rbtnCardinal.TabIndex := 2;
  Self.rbtnCardinal.TabStop := True;
  Self.rbtnCardinal.Text := 'Cardinal Spline';
  Include(Self.rbtnCardinal.Click, Self.Button1_Click);
  // 
  // Label1
  // 
  Self.Label1.Location := System.Drawing.Point.Create(24, 24);
  Self.Label1.Name := 'Label1';
  Self.Label1.TabIndex := 1;
  Self.Label1.Text := 'Tension';
  // 
  // TrackBar1
  // 
  Self.TrackBar1.Location := System.Drawing.Point.Create(24, 48);
  Self.TrackBar1.Maximum := 50;
  Self.TrackBar1.Name := 'TrackBar1';
  Self.TrackBar1.Size := System.Drawing.Size.Create(288, 45);
  Self.TrackBar1.TabIndex := 0;
  Self.TrackBar1.Value := 10;
  Include(Self.TrackBar1.MouseUp, Self.TrackBar2_MouseUp);
  Include(Self.TrackBar1.ValueChanged, Self.Button1_Click);
  Include(Self.TrackBar1.MouseDown, Self.TrackBar2_MouseDown);
  // 
  // TabPage5
  // 
  Self.TabPage5.Controls.Add(Self.TrackBar2);
  Self.TabPage5.Controls.Add(Self.lbxFillStyle);
  Self.TabPage5.Controls.Add(Self.cbxFillShape);
  Self.TabPage5.Controls.Add(Self.lbxShapes);
  Self.TabPage5.Location := System.Drawing.Point.Create(4, 22);
  Self.TabPage5.Name := 'TabPage5';
  Self.TabPage5.Size := System.Drawing.Size.Create(616, 110);
  Self.TabPage5.TabIndex := 4;
  Self.TabPage5.Text := 'Shapes';
  // 
  // TrackBar2
  // 
  Self.TrackBar2.Location := System.Drawing.Point.Create(280, 48);
  Self.TrackBar2.Maximum := 360;
  Self.TrackBar2.Name := 'TrackBar2';
  Self.TrackBar2.Size := System.Drawing.Size.Create(280, 45);
  Self.TrackBar2.TabIndex := 3;
  Self.TrackBar2.TickFrequency := 5;
  Self.TrackBar2.Value := 45;
  Include(Self.TrackBar2.MouseUp, Self.TrackBar2_MouseUp);
  Include(Self.TrackBar2.ValueChanged, Self.Button1_Click);
  Include(Self.TrackBar2.MouseDown, Self.TrackBar2_MouseDown);
  // 
  // lbxFillStyle
  // 
  Self.lbxFillStyle.Items.AddRange(TSystem_ObjectArray.Create('Solid', 'Texture', 
          'Linear Gradient'));
  Self.lbxFillStyle.Location := System.Drawing.Point.Create(144, 40);
  Self.lbxFillStyle.Name := 'lbxFillStyle';
  Self.lbxFillStyle.Size := System.Drawing.Size.Create(120, 56);
  Self.lbxFillStyle.TabIndex := 2;
  Include(Self.lbxFillStyle.SelectedIndexChanged, Self.Button1_Click);
  // 
  // cbxFillShape
  // 
  Self.cbxFillShape.Location := System.Drawing.Point.Create(144, 0);
  Self.cbxFillShape.Name := 'cbxFillShape';
  Self.cbxFillShape.TabIndex := 1;
  Self.cbxFillShape.Text := 'Fill Shape';
  Include(Self.cbxFillShape.Click, Self.Button1_Click);
  // 
  // lbxShapes
  // 
  Self.lbxShapes.DisplayMember := '0';
  Self.lbxShapes.Items.AddRange(TSystem_ObjectArray.Create('Rectangle', 'Ellipses', 
          'Polygons', 'Pies'));
  Self.lbxShapes.Location := System.Drawing.Point.Create(8, 8);
  Self.lbxShapes.Name := 'lbxShapes';
  Self.lbxShapes.Size := System.Drawing.Size.Create(120, 95);
  Self.lbxShapes.TabIndex := 0;
  Include(Self.lbxShapes.SelectedIndexChanged, Self.Button1_Click);
  // 
  // Button1
  // 
  Self.Button1.Location := System.Drawing.Point.Create(552, 440);
  Self.Button1.Name := 'Button1';
  Self.Button1.TabIndex := 3;
  Self.Button1.Text := 'Draw';
  Include(Self.Button1.Click, Self.Button1_Click);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.BackColor := System.Drawing.SystemColors.Control;
  Self.ClientSize := System.Drawing.Size.Create(640, 470);
  Self.Controls.Add(Self.Button1);
  Self.Controls.Add(Self.TabControl1);
  Self.Controls.Add(Self.Panel1);
  Self.FormBorderStyle := System.Windows.Forms.FormBorderStyle.FixedSingle;
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  Include(Self.Activated, Self.Button1_Click);
  Self.TabControl1.ResumeLayout(False);
  Self.TabPage2.ResumeLayout(False);
  Self.TabPage3.ResumeLayout(False);
  Self.TabPage4.ResumeLayout(False);
  (System.ComponentModel.ISupportInitialize(Self.TrackBar1)).EndInit;
  Self.TabPage5.ResumeLayout(False);
  (System.ComponentModel.ISupportInitialize(Self.TrackBar2)).EndInit;
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  ClearOK := True;
  InitializeComponent;
  Panel1.BackColor := Color.White;

  MyGraphics := Graphics.FromHwnd(Panel1.Handle);
  MyPen := Pen.Create(Color.Black);
  lbxShapes.SelectedIndex := 0;
  lbxFillStyle.SelectedIndex := 0;
end;

procedure TWinForm.TrackBar2_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
  ClearOK := True;
end;

procedure TWinForm.TrackBar2_MouseDown(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
  ClearOK := False;
end;

procedure TWinForm.Panel1_Paint(sender: System.Object; e: System.Windows.Forms.PaintEventArgs);
begin
  Button1_Click(sender, e);
end;


procedure TWinForm.Button1_Click(sender: System.Object; e: System.EventArgs);
begin
  if ClearOK then
    ClearCanvas;
  case TabControl1.SelectedTab.TabIndex of
    0: PaintLines;
    1: PaintLineCaps;
    2: PaintLineJoins;
    3: PaintCurves;
    4: PaintShapes;
  end; // case
end;

procedure TWinForm.PaintLines;
var
  wdth: Integer;
  yPos: integer;
  lgBrush: LinearGradientBrush;
  txBrush: TextureBrush;
  img: Image;
begin
  MyPen.Color := Color.Red;
  yPos := 10;

  // draw different sized of lines.
  for wdth := 1 to 5 do
  begin
    MyPen.Width := wdth;
    MyGraphics.DrawLine(MyPen, 10, yPos, Panel1.Width-10, yPos);
    inc(yPos, 20);
  end;

  // draw a line using a different brush
  MyPen.Width := 20;
  lgBrush := LinearGradientBrush.Create(Point.Create(0, yPos),
     Point.Create(Panel1.Width-10, 10), Color.Black, Color.Yellow);
  MyPen.Brush := lgBrush;
  MyGraphics.DrawLine(MyPen, 10, yPos, Panel1.Width-10, yPos);


  // draw a line using a pattern
  yPos := yPos + 40;
  img := Image.FromFile('Stucco.bmp');
  txBrush := TextureBrush.Create(img);
  MyPen.Brush := txBrush;
  MyGraphics.DrawLine(MyPen, 10, yPos, Panel1.Width-10, yPos);
end;

procedure TWinForm.PaintLineCaps;
var
  endPoint: Point;
begin
  MyPen.Color := Color.Black;
  MyPen.Width := 15;

  if rbtnFlat.Checked then MyPen.EndCap := LineCap.Flat
  else if rbtnSq.Checked then MyPen.EndCap := LineCap.Square
  else if rbtnSqAnc.Checked then MyPen.EndCap := LineCap.SquareAnchor
  else if rbtnRound.Checked then MyPen.EndCap := LineCap.Round
  else if rbtnRoundAnc.Checked then MyPen.EndCap := LineCap.RoundAnchor;

  endPoint := DrawAngle(MyGraphics, MyPen, Point.Create(10,
    Panel1.Height-10),  200, 45.0);
  endPoint := DrawAngle(MyGraphics, MyPen, endPoint, 200, 315.0);
  endPoint := DrawAngle(MyGraphics, MyPen, endPoint, 200, 45.0);
  endPoint := DrawAngle(MyGraphics, MyPen, endPoint, 200, 315.0);
end;

procedure TWinForm.ClearCanvas;
var
  MyGraphics: Graphics;
begin
  MyGraphics := Graphics.FromHwnd(Panel1.Handle);
  MyGraphics.FillRectangle(Brushes.White, Panel1.ClientRectangle);
  MyPen.DashStyle := DashStyle.Solid;
  MyPen.Color := Color.Black;
  MyPen.StartCap := LineCap.Flat;
  MyPen.EndCap   := LineCap.Flat;
  MyPen.Width := 10;
end;

function TWinForm.DrawAngle(aGraphics: Graphics; aPen: Pen;
   aFromPt: Point; aLength: Integer; aTheta: Double): Point;
var
  ToX, ToY: Integer;
begin
  // convert degrees to radians
  aTheta := -aTheta*Math.PI/180;

  // calculate points along a circle at radius R
  ToX := aFromPt.X + Convert.ToInt32(aLength * Math.Cos(aTheta));
  ToY := aFromPt.Y + Convert.ToInt32(aLength * Math.Sin(aTheta));

  Result := Point.Create(ToX, ToY);
  aGraphics.DrawLine(aPen, aFromPt, Result);
end;

procedure TWinForm.PaintLineJoins;
var
  MyPath: GraphicsPath;
begin
  MyPath := GraphicsPath.Create;
  MyPen.Color := Color.Black;
  MyPen.Width := 10;

  MyPath.AddLine(10, 10, 300, 10);
  MyPath.AddLine(300, 10, 10, 200);
  MyPath.AddLine(10, 200, 300, 200);

  if rbBevel.Checked then MyPen.LineJoin := LineJoin.Bevel
  else if rbMiter.Checked then MyPen.LineJoin := LineJoin.Miter
  else if rbRound.Checked then MyPen.LineJoin := LineJoin.Round
  else if rbMiterClipped.Checked then MyPen.LineJoin :=
    LineJoin.MiterClipped;

  MyGraphics.DrawPath(MyPen, MyPath);
end;

procedure TWinForm.PaintCurves;
begin
  TrackBar1.Enabled := rbtnCardinal.Checked;
  if rbtnCardinal.Checked then
    PaintCardinal
  else
    PaintBezier;
end;

procedure TWinForm.PaintShapes;
  procedure DrawRectangle(aBrush: Brush);
  var
    MyRect: Rectangle;
  begin
    MyPen.Width := 5;
    MyRect := Rectangle.Create(10, 10, 500, 250);
    MyGraphics.DrawRectangle(MyPen, MyRect);
    if Assigned(aBrush) then
      MyGraphics.FillRectangle(aBrush, MyRect);
  end;

  procedure DrawEllipse(aBrush: Brush);
  var
    MyRect: Rectangle;
  begin
    MyPen.Width := 5;
    MyRect := Rectangle.Create(10, 10, 500, 250);
    MyGraphics.DrawEllipse(MyPen, MyRect);
    if Assigned(aBrush) then
      MyGraphics.FillEllipse(aBrush, MyRect);
  end;

  procedure DrawPolygon(aBrush: Brush);
  var
    MyPointAry: array[0..6] of Point;
  begin
    MyPen.Width := 5;
    MyPointAry[0] := Point.Create(200, 50);
    MyPointAry[1] := Point.Create(250, 100);
    MyPointAry[2] := Point.Create(250, 150);
    MyPointAry[3] := Point.Create(200, 200);
    MyPointAry[4] := Point.Create(150, 150);
    MyPointAry[5] := Point.Create(150, 100);
    MyPointAry[6] := Point.Create(200, 50);
    MyGraphics.DrawPolygon(MyPen, MyPointAry);
    if Assigned(aBrush) then
      MyGraphics.FillPolygon(aBrush, MyPointAry);
  end;

  procedure DrawPie(aBrush: Brush);
  var
    MyRect: Rectangle;
  begin
    MyPen.Width := 5;
    MyRect := Rectangle.Create(10, 10, 250, 250);
    // top right
    MyGraphics.DrawPie(MyPen, MyRect, 0, -90);
    // bottom right
    MyGraphics.DrawPie(MyPen, MyRect, -270, -90);
    // bottom left
    MyGraphics.DrawPie(MyPen, MyRect, -180, -90);
    // top left
    MyGraphics.DrawPie(MyPen, MyRect, -90, -90);

    if Assigned(ABrush) then
      MyGraphics.FillPie(aBrush, MyRect, 0, -90);
  end;

var
  B: Brush;
begin
  B := nil;
  lbxFillStyle.Enabled := cbxFillShape.Checked;
  TrackBar2.Enabled := cbxFillShape.Checked and
    (lbxFillStyle.SelectedIndex = 2);

  if cbxFillShape.Checked then
    case lbxFillStyle.SelectedIndex of
      0: B := SolidBrush.Create(Color.Blue);
      1: B := HatchBrush.Create(HatchStyle.DiagonalBrick, Color.Blue,
                Color.BlanchedAlmond);
      2: B := LinearGradientBrush.Create(Panel1.ClientRectangle,
        Color.Blue, Color.Crimson, TrackBar2.Value);
    end; // case

  case lbxShapes.SelectedIndex of
    0: DrawRectangle(B);
    1: DrawEllipse(B);
    2: DrawPolygon(B);
    3: DrawPie(B);
  end; // case
end;

procedure TWinForm.paintBezier;
var
  MyPointsAry: array[0..4] of Point;
begin
  if rbtnBSC.Checked then // Simple curve
  begin
    MyPointsAry[0] := Point.Create(10, 200);
    MyPointsAry[1] := Point.Create(100,100);
    MyPointsAry[2] := Point.Create(250, 100);
    MyPointsAry[3] := Point.Create(500, 200);
  end
  else if rbtnBSR1.Checked then // Recurve 1
  begin
    MyPointsAry[0] := Point.Create(10, 200);
    MyPointsAry[1] := Point.Create(500, 10);
    MyPointsAry[2] := Point.Create(10, 180);
    MyPointsAry[3] := Point.Create(500, 200);
  end
  else if rbtnBSR2.Checked then // Recurve 2
  begin
    MyPointsAry[0] := Point.Create(10, 150);
    MyPointsAry[1] := Point.Create(250, 10);
    MyPointsAry[2] := Point.Create(200, 265);
    MyPointsAry[3] := Point.Create(450, 100);
  end
  else if rbtnBSL.Checked then // Loop
  begin
    MyPointsAry[0] := Point.Create(10, 10);
    MyPointsAry[1] := Point.Create(500, 265);
    MyPointsAry[2] := Point.Create(10, 200);
    MyPointsAry[3] := Point.Create(80, 15);
  end;

  MyPen.Color := Color.Blue;
  MyPen.Width := 8;

  // Draw the curve
  MyGraphics.DrawBezier(MyPen, MyPointsAry[0], MyPointsAry[1],
    MyPointsAry[2], MyPointsAry[3]);

  // draw a lines to show the begin..end and control points.
  MyPen.Width := 4;
  MyPen.Color := Color.Red;
  MyPen.DashStyle := DashStyle.DashDotDot;
  MyPen.StartCap := LineCap.RoundAnchor;
  MyPen.EndCap := LineCap.ArrowAnchor;
  MyGraphics.DrawLine(MyPen, MyPointsAry[0], MyPointsAry[1]);

  MyPen.Color := Color.Green;
  MyPen.StartCap := LineCap.RoundAnchor;
  MyPen.EndCap := LineCap.ArrowAnchor;
  MyGraphics.DrawLine(MyPen, MyPointsAry[3], MyPointsAry[2]);
end;

procedure TWinForm.paintCardinal;
var
  MyPointsAry: array[0..2] of Point;
begin
  MyPen.Color := Color.Blue;
  MyPen.Width := 1;

  MyPointsAry[0] := Point.Create(100, 200);
  MyPointsAry[1] := Point.Create(250, 75);
  MyPointsAry[2] := Point.Create(500, 200);
  MyGraphics.DrawCurve(MyPen, MyPointsAry, TrackBar1.Value / 20)
end;

end.


