unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Drawing.Imaging,
  System.Drawing.Drawing2D;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnCreatePath: System.Windows.Forms.Button;
    Panel1: System.Windows.Forms.Panel;
    StatusBar1: System.Windows.Forms.StatusBar;
    StatusBarPanel1: System.Windows.Forms.StatusBarPanel;
    cbPathClosed: System.Windows.Forms.CheckBox;
    cbPathFilled: System.Windows.Forms.CheckBox;
    btnCreateRegion: System.Windows.Forms.Button;
    ListBox1: System.Windows.Forms.ListBox;
    btnClipRegion: System.Windows.Forms.Button;
    btnClipString: System.Windows.Forms.Button;
    cbxExclude: System.Windows.Forms.CheckBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnCreatePath_Click(sender: System.Object; e: System.EventArgs);
    procedure Panel1_MouseMove(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
    procedure btnCreateRegion_Click(sender: System.Object; e: System.EventArgs);
    procedure btnClipRegion_Click(sender: System.Object; e: System.EventArgs);
    procedure btnClipString_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    MyGraphics: Graphics;
    procedure ClearCanvas;
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
type
  TSystem_Windows_Forms_StatusBarPanelArray = array of System.Windows.Forms.StatusBarPanel;
  TSystem_ObjectArray = array of System.Object;
begin
  Self.btnCreatePath := System.Windows.Forms.Button.Create;
  Self.Panel1 := System.Windows.Forms.Panel.Create;
  Self.StatusBar1 := System.Windows.Forms.StatusBar.Create;
  Self.StatusBarPanel1 := System.Windows.Forms.StatusBarPanel.Create;
  Self.cbPathClosed := System.Windows.Forms.CheckBox.Create;
  Self.cbPathFilled := System.Windows.Forms.CheckBox.Create;
  Self.btnCreateRegion := System.Windows.Forms.Button.Create;
  Self.ListBox1 := System.Windows.Forms.ListBox.Create;
  Self.btnClipRegion := System.Windows.Forms.Button.Create;
  Self.btnClipString := System.Windows.Forms.Button.Create;
  Self.cbxExclude := System.Windows.Forms.CheckBox.Create;
  (System.ComponentModel.ISupportInitialize(Self.StatusBarPanel1)).BeginInit;
  Self.SuspendLayout;
  // 
  // btnCreatePath
  // 
  Self.btnCreatePath.Location := System.Drawing.Point.Create(8, 376);
  Self.btnCreatePath.Name := 'btnCreatePath';
  Self.btnCreatePath.Size := System.Drawing.Size.Create(120, 23);
  Self.btnCreatePath.TabIndex := 0;
  Self.btnCreatePath.Text := 'Create A Path';
  Include(Self.btnCreatePath.Click, Self.btnCreatePath_Click);
  // 
  // Panel1
  // 
  Self.Panel1.BackColor := System.Drawing.Color.White;
  Self.Panel1.Dock := System.Windows.Forms.DockStyle.Top;
  Self.Panel1.Location := System.Drawing.Point.Create(0, 0);
  Self.Panel1.Name := 'Panel1';
  Self.Panel1.Size := System.Drawing.Size.Create(624, 368);
  Self.Panel1.TabIndex := 1;
  Include(Self.Panel1.MouseMove, Self.Panel1_MouseMove);
  // 
  // StatusBar1
  // 
  Self.StatusBar1.Location := System.Drawing.Point.Create(0, 480);
  Self.StatusBar1.Name := 'StatusBar1';
  Self.StatusBar1.Panels.AddRange(TSystem_Windows_Forms_StatusBarPanelArray.Create(Self.StatusBarPanel1));
  Self.StatusBar1.Size := System.Drawing.Size.Create(624, 22);
  Self.StatusBar1.SizingGrip := False;
  Self.StatusBar1.TabIndex := 2;
  Self.StatusBar1.Text := 'StatusBar1';
  // 
  // StatusBarPanel1
  // 
  Self.StatusBarPanel1.Text := 'StatusBarPanel1';
  // 
  // cbPathClosed
  // 
  Self.cbPathClosed.Location := System.Drawing.Point.Create(16, 400);
  Self.cbPathClosed.Name := 'cbPathClosed';
  Self.cbPathClosed.Size := System.Drawing.Size.Create(72, 24);
  Self.cbPathClosed.TabIndex := 3;
  Self.cbPathClosed.Text := 'Closed';
  Include(Self.cbPathClosed.Click, Self.btnCreatePath_Click);
  // 
  // cbPathFilled
  // 
  Self.cbPathFilled.Location := System.Drawing.Point.Create(16, 432);
  Self.cbPathFilled.Name := 'cbPathFilled';
  Self.cbPathFilled.Size := System.Drawing.Size.Create(72, 24);
  Self.cbPathFilled.TabIndex := 4;
  Self.cbPathFilled.Text := 'Filled';
  Include(Self.cbPathFilled.Click, Self.btnCreatePath_Click);
  // 
  // btnCreateRegion
  // 
  Self.btnCreateRegion.Location := System.Drawing.Point.Create(152, 376);
  Self.btnCreateRegion.Name := 'btnCreateRegion';
  Self.btnCreateRegion.Size := System.Drawing.Size.Create(120, 23);
  Self.btnCreateRegion.TabIndex := 5;
  Self.btnCreateRegion.Text := 'Create A Region';
  Include(Self.btnCreateRegion.Click, Self.btnCreateRegion_Click);
  // 
  // ListBox1
  // 
  Self.ListBox1.Items.AddRange(TSystem_ObjectArray.Create('None', 'Intersect', 
          'Union', 'Xor', 'Compliment', 'Exclude'));
  Self.ListBox1.Location := System.Drawing.Point.Create(152, 400);
  Self.ListBox1.Name := 'ListBox1';
  Self.ListBox1.Size := System.Drawing.Size.Create(120, 69);
  Self.ListBox1.TabIndex := 7;
  Include(Self.ListBox1.SelectedIndexChanged, Self.btnCreateRegion_Click);
  // 
  // btnClipRegion
  // 
  Self.btnClipRegion.Location := System.Drawing.Point.Create(288, 376);
  Self.btnClipRegion.Name := 'btnClipRegion';
  Self.btnClipRegion.Size := System.Drawing.Size.Create(96, 23);
  Self.btnClipRegion.TabIndex := 8;
  Self.btnClipRegion.Text := 'Clip a Region';
  Include(Self.btnClipRegion.Click, Self.btnClipRegion_Click);
  // 
  // btnClipString
  // 
  Self.btnClipString.Location := System.Drawing.Point.Create(288, 408);
  Self.btnClipString.Name := 'btnClipString';
  Self.btnClipString.Size := System.Drawing.Size.Create(96, 23);
  Self.btnClipString.TabIndex := 9;
  Self.btnClipString.Text := 'String Clip';
  Include(Self.btnClipString.Click, Self.btnClipString_Click);
  // 
  // cbxExclude
  // 
  Self.cbxExclude.Location := System.Drawing.Point.Create(288, 440);
  Self.cbxExclude.Name := 'cbxExclude';
  Self.cbxExclude.TabIndex := 10;
  Self.cbxExclude.Text := 'Exclude';
  Include(Self.cbxExclude.Click, Self.btnClipString_Click);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(624, 502);
  Self.Controls.Add(Self.cbxExclude);
  Self.Controls.Add(Self.btnClipString);
  Self.Controls.Add(Self.btnClipRegion);
  Self.Controls.Add(Self.ListBox1);
  Self.Controls.Add(Self.btnCreateRegion);
  Self.Controls.Add(Self.cbPathFilled);
  Self.Controls.Add(Self.cbPathClosed);
  Self.Controls.Add(Self.StatusBar1);
  Self.Controls.Add(Self.Panel1);
  Self.Controls.Add(Self.btnCreatePath);
  Self.FormBorderStyle := System.Windows.Forms.FormBorderStyle.FixedSingle;
  Self.Name := 'TWinForm';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'WinForm';
  (System.ComponentModel.ISupportInitialize(Self.StatusBarPanel1)).EndInit;
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  InitializeComponent;
  MyGraphics := Graphics.FromHwnd(Panel1.Handle);
end;

procedure TWinForm.btnClipString_Click(sender: System.Object;
  e: System.EventArgs);
var
  gp: GraphicsPath;
begin
  ClearCanvas;
  gp := GraphicsPath.Create;
  gp.AddString('Delphi 8', FontFamily.Create('Comic Sans MS'),
    Integer(FontStyle.Bold or FontStyle.Italic), 144,
    Point.Create(10, 20), StringFormat.GenericTypographic);

  MyGraphics.DrawPath(Pens.Black, gp);
  if cbxExclude.Checked then
    MyGraphics.SetClip(gp, CombineMode.Exclude)
  else
    MyGraphics.SetClip(gp);
  MyGraphics.DrawImage(Bitmap.Create('USFlag.gif'),
    Panel1.ClientRectangle);
end;

procedure TWinForm.btnClipRegion_Click(sender: System.Object;
  e: System.EventArgs);
var
  gp: GraphicsPath;
  r: Rectangle;
begin
  ClearCanvas;
  gp := GraphicsPath.Create;
  r := Rectangle.Create(20, 40, 400, 200);
  gp.AddEllipse(r);
  MyGraphics.DrawPath(Pens.Black, gp);
  MyGraphics.SetClip(gp, CombineMode.Replace);
  MyGraphics.DrawString('Delphi 8',
    System.Drawing.Font.Create('Comic Sans MS',124),
    Brushes.Red, Point.Create(20, 20), StringFormat.GenericTypographic);
end;

procedure TWinForm.btnCreateRegion_Click(sender: System.Object;
  e: System.EventArgs);
var
  r: Rectangle;
  r2: Rectangle;
  MyPen: Pen;
  rg: System.Drawing.Region;
begin
  ClearCanvas;
  MyPen := Pen.Create(Color.Black, 2);
  r := Rectangle.Create(20, 40, 400, 50);
  r2 := Rectangle.Create(100, 10, 50, 200);
  rg := System.Drawing.Region.Create(r);

  case ListBox1.SelectedIndex of
    1: rg.Intersect(r2);
    2: rg.Union(r2);
    3: rg.&Xor(r2);
    4: rg.Complement(r2);
    5: rg.Exclude(r2);
  end; // case

  MyGraphics.FillRegion(Brushes.Indigo, rg);
  MyGraphics.DrawRectangle(Pens.Black, r);
  MyGraphics.DrawRectangle(Pens.Black, r2);
end;

procedure TWinForm.Panel1_MouseMove(sender: System.Object;
  e: System.Windows.Forms.MouseEventArgs);
begin
  StatusBar1.Text := System.String.Format('X: {0}  Y: {1}', [e.X, e.Y]);
end;

procedure TWinForm.btnCreatePath_Click(sender: System.Object;
  e: System.EventArgs);
var
  gp: GraphicsPath;
  MyPen: Pen;
begin
  ClearCanvas;
  MyPen := Pen.Create(Color.Black, 2);
  gp := GraphicsPath.Create;
  gp.AddLine(10, 200, 50, 300);
  gp.AddLine(50, 300, 500, 250);
  gp.AddLine(500, 250, 260, 80);

  gp.StartFigure;
  gp.AddLine(400, 10, 400, 60);
  gp.AddLine(400, 60, 450, 60);
  gp.AddLine(450, 60, 450, 10);

  gp.StartFigure;
  gp.AddBezier(10, 50, 10, 55, 300, 70, 300, 250);
  if cbPathClosed.Checked then
    gp.CloseAllFigures;
  if cbPathFilled.Checked then
    MyGraphics.FillPath(Brushes.Bisque, gp);
  MyGraphics.DrawPath(MyPen, gp);
end;

procedure TWinForm.ClearCanvas;
var
  br: SolidBrush;
begin
  br := SolidBrush.Create(Color.White);
  MyGraphics.FillRectangle(br, Panel1.ClientRectangle);
end;

end.
