unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    ListBox1: System.Windows.Forms.ListBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure TWinForm_Paint(sender: System.Object; e: System.Windows.Forms.PaintEventArgs);
    procedure ListBox1_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
    procedure DrawBasicTransform(g: Graphics);
    procedure DrawUsingInches(g: Graphics);
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
type
  TSystem_ObjectArray = array of System.Object;
begin
  Self.ListBox1 := System.Windows.Forms.ListBox.Create;
  Self.SuspendLayout;
  // 
  // ListBox1
  // 
  Self.ListBox1.Items.AddRange(TSystem_ObjectArray.Create('Transform', 'Inches'));
  Self.ListBox1.Location := System.Drawing.Point.Create(408, 304);
  Self.ListBox1.Name := 'ListBox1';
  Self.ListBox1.Size := System.Drawing.Size.Create(120, 160);
  Self.ListBox1.TabIndex := 0;
  Include(Self.ListBox1.SelectedIndexChanged, Self.ListBox1_SelectedIndexChanged);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.BackColor := System.Drawing.Color.White;
  Self.ClientSize := System.Drawing.Size.Create(544, 486);
  Self.Controls.Add(Self.ListBox1);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  Include(Self.Paint, Self.TWinForm_Paint);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  Listbox1.SelectedIndex := 0;
end;

procedure TWinForm.TWinForm_Paint(sender: System.Object;
  e: System.Windows.Forms.PaintEventArgs);
begin
  e.Graphics.FillRectangle(Brushes.White, ClientRectangle);
  case ListBox1.SelectedIndex of
    0: DrawBasicTransForm(e.Graphics);
    1: DrawUsingInches(e.Graphics);
  end;
end;

procedure TWinForm.DrawBasicTransform(g: Graphics);
var
  MyPen: Pen;
begin
  MyPen := Pen.Create(Color.Black, 3);
  g.DrawLine(MyPen, 50, 50, 300, 50);
  g.DrawLine(MyPen, 50, 50, 50, 300);

  g.TranslateTransform(100, 100);
  g.DrawLine(MyPen, 50, 50, 300, 50);
  g.DrawLine(MyPen, 50, 50, 50, 300);
  g.ResetTransform;
end;

procedure TWinForm.DrawUsingInches(g: Graphics);
var
  MyPen: Pen;
begin
  MyPen := Pen.Create(Color.Black, (1/g.DpiX)*3);
  g.PageUnit := GraphicsUnit.Inch;
  g.DrawLine(myPen, 1, 1, 1, 3);
end;

procedure TWinForm.ListBox1_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
begin
  Invalidate;
end;


end.

