unit WinForm;

interface

uses
  System.Drawing, System.Collections,
  System.ComponentModel, System.Windows.Forms, System.Data,
  System.Drawing.Imaging;

type

  TSpriteDirection  = (sdLeft, sdRight, sdUp, sdDown);
  TSpriteDirections = set of TSpriteDirection;

  TSprite = class
  private
  public
    Width: integer;
    Height: integer;
    Left: integer;
    Top: integer;
    Saucer: Bitmap;
    Direction: TSpriteDirections;
  public
    constructor Create;
  end;

  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    components: System.ComponentModel.IContainer;
    Timer1: System.Windows.Forms.Timer;
    StatusBar1: System.Windows.Forms.StatusBar;
    Button1: System.Windows.Forms.Button;
    Button2: System.Windows.Forms.Button;
    Button3: System.Windows.Forms.Button;
    Button4: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure Timer1_Tick(sender: System.Object; e: System.EventArgs);
    procedure TWinForm_Load(sender: System.Object; e: System.EventArgs);
    procedure Step1_Click1(sender: System.Object; e: System.EventArgs);
    procedure Step2_Click(sender: System.Object; e: System.EventArgs);
    procedure ClearSky_Click(sender: System.Object; e: System.EventArgs);
    procedure Animate_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
    procedure MoveSaucer;

    procedure ClearSky;
    procedure Step1_Erase(aDemo: Boolean);
    procedure Step2_DrawSaucerTrans(aDemo: Boolean);
    procedure Step3_DrawSaucerPos(aDemo: Boolean);

  private
    { Private Declarations }
    // Drawing is done to FSkyImage
    FSkyImage: Bitmap;
    // FClearSkyImage retains the clean sky
    FClearSkyImage: Bitmap;
    // FSkyGraphic is refers to FSkyImages
    FSkyGraphic: Graphics;
    // CanvasGraphic refers to the form
    CanvasGraphic: Graphics;

    FSaucer: TSprite;
    FAnimate: Boolean;
    FStep: Integer;
    public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.components := System.ComponentModel.Container.Create;
  Self.Timer1 := System.Windows.Forms.Timer.Create(Self.components);
  Self.StatusBar1 := System.Windows.Forms.StatusBar.Create;
  Self.Button1 := System.Windows.Forms.Button.Create;
  Self.Button2 := System.Windows.Forms.Button.Create;
  Self.Button3 := System.Windows.Forms.Button.Create;
  Self.Button4 := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // Timer1
  // 
  Self.Timer1.Enabled := True;
  Self.Timer1.Interval := 5;
  Include(Self.Timer1.Tick, Self.Timer1_Tick);
  // 
  // StatusBar1
  // 
  Self.StatusBar1.Location := System.Drawing.Point.Create(0, 470);
  Self.StatusBar1.Name := 'StatusBar1';
  Self.StatusBar1.Size := System.Drawing.Size.Create(728, 24);
  Self.StatusBar1.TabIndex := 0;
  Self.StatusBar1.Text := 'StatusBar1';
  // 
  // Button1
  // 
  Self.Button1.Location := System.Drawing.Point.Create(16, 432);
  Self.Button1.Name := 'Button1';
  Self.Button1.Size := System.Drawing.Size.Create(112, 23);
  Self.Button1.TabIndex := 1;
  Self.Button1.Text := 'Step 1 - Erase';
  Include(Self.Button1.Click, Self.Step1_Click1);
  // 
  // Button2
  // 
  Self.Button2.Location := System.Drawing.Point.Create(136, 432);
  Self.Button2.Name := 'Button2';
  Self.Button2.Size := System.Drawing.Size.Create(120, 23);
  Self.Button2.TabIndex := 2;
  Self.Button2.Text := 'Step 2 - Draw Saucer';
  Include(Self.Button2.Click, Self.Step2_Click);
  // 
  // Button3
  // 
  Self.Button3.Location := System.Drawing.Point.Create(264, 432);
  Self.Button3.Name := 'Button3';
  Self.Button3.Size := System.Drawing.Size.Create(152, 23);
  Self.Button3.TabIndex := 3;
  Self.Button3.Text := 'Clear Sky';
  Include(Self.Button3.Click, Self.ClearSky_Click);
  // 
  // Button4
  //
  Self.Button4.Location := System.Drawing.Point.Create(424, 432);
  Self.Button4.Name := 'Button4';
  Self.Button4.Size := System.Drawing.Size.Create(104, 23);
  Self.Button4.TabIndex := 4;
  Self.Button4.Text := 'Animate';
  Include(Self.Button4.Click, Self.Animate_Click);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(728, 494);
  Self.Controls.Add(Self.Button4);
  Self.Controls.Add(Self.Button3);
  Self.Controls.Add(Self.Button2);
  Self.Controls.Add(Self.Button1);
  Self.Controls.Add(Self.StatusBar1);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  Include(Self.Load, Self.TWinForm_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

procedure TWinForm.Step1_Click1(sender: System.Object;
  e: System.EventArgs);
begin
  Step1_Erase(True);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  InitializeComponent;

  FAnimate := False;

  FSkyImage := Bitmap.Create('sky2.bmp');
  FSkyImage.SetResolution(72, 72);
  FSkyGraphic := Graphics.FromImage(FSkyImage);

  FStep := 2;
  FClearSkyImage := FSkyImage.Clone(Rectangle.Create(0, 0,
    FSkyImage.Width,  FSkyImage.Height), PixelFormat.Format32bppArgb);
  FClearSkyImage.SetResolution(72, 72);

  FSaucer := TSprite.Create;
  CanvasGraphic := Graphics.FromHwnd(Handle);
end;

procedure TWinForm.Animate_Click(sender: System.Object;
  e: System.EventArgs);
begin
  FAnimate := not FAnimate;
  if FAnimate then
    Button4.Text := 'Stop'
  else
    Button4.Text := 'Animate';
end;

procedure TWinForm.ClearSky_Click(sender: System.Object;
  e: System.EventArgs);
begin
  ClearSky;
end;

procedure TWinForm.Step2_Click(sender: System.Object;
  e: System.EventArgs);
begin
  MoveSaucer;
  Step2_DrawSaucerTrans(True);
end;

procedure TWinForm.Timer1_Tick(sender: System.Object;
  e: System.EventArgs);
begin
  if FAnimate then
  begin
    Step1_Erase(false);
    MoveSaucer;
    Step2_DrawSaucerTrans(false);
    Step3_DrawSaucerPos(false);
  end;
end;

procedure TWinForm.TWinForm_Load(sender: TObject; e: System.EventArgs);
begin
end;

procedure TWinForm.MoveSaucer;
begin
  // Save the old values
  if (sdLeft in FSaucer.Direction) then
    if FSaucer.Left > 0 then
      FSaucer.Left := FSaucer.Left - FStep
    else
      FSaucer.Direction := FSaucer.Direction - [sdLeft] + [sdRight];

  if (sdDown in FSaucer.Direction) then
    if FSaucer.Top+FSaucer.Height < FSkyImage.Height then
      FSaucer.Top := FSaucer.Top + FStep
    else
      FSaucer.Direction := FSaucer.Direction - [sdDown] + [sdUp];

  if (sdUp in FSaucer.Direction) then
    if FSaucer.Top > 0 then
      FSaucer.Top := FSaucer.Top - FStep
    else
      FSaucer.Direction := FSaucer.Direction - [sdUp] + [sdDown];

  if (sdRight in FSaucer.Direction) then
    if FSaucer.Left+FSaucer.Width < FSkyImage.Width then
      FSaucer.Left := FSaucer.Left + FStep
    else
      FSaucer.Direction := FSaucer.Direction - [sdRight] + [sdLeft];
end;

procedure TWinForm.ClearSky;
begin
  FSkyGraphic.DrawImage(FClearSkyImage, 0, 0);
  CanvasGraphic.DrawImageUnScaled(FSkyImage, 0, 0);
end;

procedure TWinForm.Step1_Erase(aDemo: Boolean);
begin
  // Copy portion of the stored sky to the in-mem image
  FSkyGraphic.DrawImage(FClearSkyImage,
    Rectangle.Create(FSaucer.Left-2, FSaucer.Top-2, FSaucer.Width+2,
    FSaucer.Height+2), FSaucer.Left-2, FSaucer.Top-2, FSaucer.Width+2,
    FSaucer.Height+2, GraphicsUnit.Pixel);

  if aDemo then
    CanvasGraphic.DrawImageUnscaled(FSkyImage, 0, 0);
end;

procedure TWinForm.Step2_DrawSaucerTrans(aDemo: Boolean);
var
  imAttr: ImageAttributes;
begin
  ImAttr := ImageAttributes.Create;
  ImAttr.SetColorKey(Color.Black, Color.Black, ColorAdjustType.Default);
  FSkyGraphic.DrawImage(FSaucer.Saucer, Rectangle.Create(FSaucer.Left,
    FSaucer.Top, FSaucer.Width, FSaucer.Height), 0, 0,
    FSaucer.Width, FSaucer.Height, GraphicsUnit.Pixel, imAttr);
  if aDemo then
    CanvasGraphic.DrawImageUnScaled(FSkyImage, 0, 0);
end;

procedure TWinForm.Step3_DrawSaucerPos(aDemo: Boolean);
begin
  CanvasGraphic.DrawImageUnscaled(FSkyImage, 0, 0);


  (*  CanvasGraphic.DrawImage(FSkyImage,
    Rectangle.Create(FSaucer.Left, FSaucer.Top, FSaucer.Width,
      FSaucer.Height),
    Rectangle.Create(FSaucer.Left, FSaucer.Top, FSaucer.Width,
      FSaucer.Height),
    GraphicsUnit.Pixel, imAttr);
*)
end;

{ TSprite }

constructor TSprite.Create;
begin
  inherited;
  Saucer  := Bitmap.Create('saucer2.bmp');
  Saucer.SetResolution(72, 72);
  Left := 0;
  Top := 0;

  Height := Saucer.Height;
  Width  := Saucer.Width;

  Direction := [sdRight, sdDown];
end;

end.

