program d4dnStack;
{$APPTYPE CONSOLE}

uses
  System.Collections;

procedure ShowCollection(Collection: IEnumerable);
var
  enumMyStack: IEnumerator;
begin
  enumMyStack := Collection.GetEnumerator;
  System.Console.WriteLine;
  while enumMyStack.MoveNext do
    System.Console.Write(enumMyStack.Current.ToString+'    ');
  System.Console.WriteLine;
end;

var
  MyStack: Stack;
  i: integer;
begin
  // Initialize and populate the Stack
  MyStack := Stack.Create;
  for i := 1 to 5 do
    MyStack.Push('Item '+i.ToString);
  ShowCollection(MyStack);

  // Pop the topmost item
  System.Console.Write('Pop:  '+MyStack.Pop.ToString);
  ShowCollection(MyStack);

  // Peek at the topmost item
  System.Console.Write('Peek: '+MyStack.Peek.ToString);
  ShowCollection(MyStack);

  // Pop the two topmost items
  System.Console.WriteLine('Pop:  '+MyStack.Pop.ToString);
  System.Console.Write('Pop:  '+MyStack.Pop.ToString);
  ShowCollection(MyStack);

  // Push another item
  System.Console.Write('Push: Item 6');
  MyStack.Push('Item 6');
  ShowCollection(MyStack);

  // Clear the stack
  MyStack.Clear;
  System.Console.WriteLine('Stack cleared');

  // Push another item
  System.Console.Write('Push: Item 7');
  MyStack.Push('Item 7');
  ShowCollection(MyStack);

  System.Console.Readline;
end.
