program d4dnArrayList;
{$APPTYPE CONSOLE}

uses
  System.Collections;

var
  ClassicCars: ArrayList;
  SubList: ArrayList;
  SubList2: ArrayList;

procedure ShowArrayListItems(aName: String; aArrayList: ArrayList);
var
  i: integer;
begin
  System.Console.WriteLine;
  System.Console.Write(aName+': ');
   for i := 0 to aArrayList.Count - 1 do
     System.Console.Write(' {0}', [aArrayList[i].ToString]);
  System.Console.WriteLine;
end;

begin
  // Initialize and populate the arraylist
  ClassicCars := ArrayList.Create;
  ClassicCars.Add('Camaro');
  ClassicCars.Add('Mustang');
  ClassicCars.Add('Chevelle');
  ClassicCars.Add('Nova');
  ClassicCars.Add('Corvette');
  ClassicCars.Add('Thunderbird');
  ClassicCars.Add('Firebird');
  ClassicCars.Add('Satellite');

  ShowArrayListItems('ClassicCars', ClassicCars);

  // sort the arraylist
  ClassicCars.Sort;
  ShowArrayListItems('ClassicCars', ClassicCars);

  // reverse the ArrayList
  ClassicCars.Reverse;
  ShowArrayListItems('ClassicCars', ClassicCars);

  // retrieve a range of items, but leave them in the original ArrayList
  SubList := ClassicCars.GetRange(2,3);
  ShowArrayListItems('SubList', SubList);
  ShowArrayListItems('ClassicCars', ClassicCars);

  // create a new arraylist and add it to ClassicCars
  SubList2 := ArrayList.Create(3);
  SubList2.Add('GTO');
  SubList2.Add('Malibu');
  SubList2.Add('El-Camino');
  ClassicCars.AddRange(SubList2);
  ShowArrayListItems('ClassicCars', ClassicCars);

  // re-sort the arraylist
  ClassicCars.Sort;
  ShowArrayListItems('ClassicCars', ClassicCars);

  // Output the count and capacity
  System.Console.WriteLine('ClassicCars count: {0}',
    [ClassicCars.Count.ToString]);
  System.Console.WriteLine('ClassicCars capacity: {0}',
    [ClassicCars.Capacity.ToString]);

  // Trim to size
  ClassicCars.TrimToSize;
  // Output the count and capacity
  System.Console.WriteLine('After trimmed---');
  System.Console.WriteLine('ClassicCars count: {0}',
    [ClassicCars.Count.ToString]);
  System.Console.WriteLine('ClassicCars capacity: {0}',
    ClassicCars.Capacity.ToString);
  System.Console.ReadLine;

end.
