unit HVObjectToStringTest;

interface

uses Messages, HVObjectToString;

type
  TMyObject = class
  private
    FMyName: string;
    procedure WMGetTextLength(var Message: TWMGetTextLength); message WM_GETTEXTLENGTH;
    procedure WMGetText(var Message: TWMGetText); message WM_GETTEXT;
  public
    property MyName: string read FMyName write FMyName;
  end;

  TObjectStr = class
  private
    procedure WMGetTextLength(var Message: TWMGetTextLength); message WM_GETTEXTLENGTH;
    procedure WMGetText(var Message: TWMGetText); message WM_GETTEXT;
  public
    function ToString: string; virtual;
  end;

  TMyObject2 = class(TObjectStr)
  private
    FMyName: string;
  public
    function ToString: string; override;
    property MyName: string read FMyName write FMyName;
  end;

  TObjectToStr = class
  private
    procedure WMToString(var Message: TWMToString); message WM_TOSTRING;
  public
    function ToString: string; virtual;
  end;

  TMyObject3 = class(TObjectToStr)
  public
    function ToString: string; override;
  end;

  TMyObject4 = class(TObjectEx)
  public
    function ToString: string; override;
  end;

implementation

uses Math, SysUtils;

{ TMyObject }

procedure TMyObject.WMGetText(var Message: TWMGetText);
begin
  Message.Result := Min(Length(MyName), Message.TextMax-1);
  Move(Pointer(MyName)^, Message.Text^, Message.Result+1);
end;

procedure TMyObject.WMGetTextLength(var Message: TWMGetTextLength);
begin
  Message.Result := Length(MyName);
end;

{ TObjectStr }

procedure TObjectStr.WMGetText(var Message: TWMGetText);
var
  S: String;
begin
  S := ToString;
  Message.Result := Min(Length(S), Message.TextMax-1);
  Move(Pointer(S)^, Message.Text^, Message.Result+1);
end;

procedure TObjectStr.WMGetTextLength(var Message: TWMGetTextLength);
begin
  Message.Result := Length(ToString);
end;

function TObjectStr.ToString: string;
begin
  Result := ClassName;
end;

{ TMyObject2 }

function TMyObject2.ToString: string;
begin
  Result := MyName;
end;

{ TObjectToStr }

function TObjectToStr.ToString: string;
begin
  Result := 'TObjectToStr.ToString';
end;

procedure TObjectToStr.WMToString(var Message: TWMToString);
begin
  Message.ToString := ToString;
end;

{ TMyObject3 }

function TMyObject3.ToString: string;
begin
  Result := TimeToStr(Time);
end;

{ TMyObject4 }

function TMyObject4.ToString: string;
begin
  Result := DateToStr(Date);
end;

end.

