program HVStringBuilderTest;

{.$DEFINE SUPPORT_APPENDFORMAT}    // AppendFormat is not .NET compatible
{.$DEFINE STRINGBUILDEREXTENSIONS} // Class helpers may not be the right tool for this... ;)
{.$DEFINE TOBJECT_TOSTRING}        // HVObjectToString is experimental

{$APPTYPE CONSOLE}

{$IFDEF CLR}
uses
  System.Threading,
  System.Globalization,
  System.Text,
{$IFDEF TOBJECT_TOSTRING}
  HVObjectToString,
{$ENDIF}
  HVStringBuilder;
{$ELSE}
uses
  SysUtils,
  HVStringBuilder,
{$IFDEF TOBJECT_TOSTRING}
  HVObjectToString,
  HVToStringHooks,
  HVObjectToStringTest,
{$ENDIF}
  StdCtrls,
  Forms;
{$ENDIF}

var
  SB: StringBuilder;
  i: integer;
  A: TObject;
{$IFNDEF CLR}
{$IFDEF TOBJECT_TOSTRING}
  Button: TButton;
  Form: TForm;
  MyObject: TMyObject;
  MyObject2: TMyObject2;
  MyObject3: TMyObject3;
  MyObject4: TMyObject4;
{$ENDIF}
{$ENDIF}
begin
  writeln({$IFDEF CLR}'CLR'{$ELSE}'Win32'{$ENDIF});
{$IFDEF CLR}
  Thread.CurrentThread.CurrentCulture := System.Globalization.CultureInfo.Create('en-US');
{$ELSE}
  DecimalSeparator := '.';
{$ENDIF}
  SB := StringBuilder.Create;
  for i := 1 to 5 do
  begin
    SB.Append('Item ');
    SB.Append(i);
    SB.Append(', ');
  end;
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Item 1, Item 2, Item 3, Item 4, Item 5, ');
  for i := 1 to 5 do
    SB.Append(i);
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Item 1, Item 2, Item 3, Item 4, Item 5, 12345');
  SB.Replace('m', 'C', 0, SB.Length div 2);
  Writeln(SB.ToString);
  Assert(SB.ToString = 'IteC 1, IteC 2, IteC 3, Item 4, Item 5, 12345');
  SB.Replace('IteC', 'Case');
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Case 1, Case 2, Case 3, Item 4, Item 5, 12345');
  SB.Insert(5, true);
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Case True1, Case 2, Case 3, Item 4, Item 5, 12345');
  SB.Insert(5, 3.14);
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Case 3.14True1, Case 2, Case 3, Item 4, Item 5, 12345');
  SB.Insert(5, 'x', 20);
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Case xxxxxxxxxxxxxxxxxxxx3.14True1, Case 2, Case 3, Item 4, Item 5, 12345');
  SB.Replace('xxx', 'yes ', 5, 10);
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Case yes yes yes xxxxxxxxxxx3.14True1, Case 2, Case 3, Item 4, Item 5, 12345');
  SB.Replace('xxx', 'nope ');
  Writeln(SB.ToString);
  Assert(SB.ToString = 'Case yes yes yes nope nope nope xx3.14True1, Case 2, Case 3, Item 4, Item 5, 12345');
{$IFDEF STRINGBUILDEREXTENSIONS}
  SB.Reverse;
  Writeln(SB.ToString);
  Assert(SB.ToString = '54321 ,5 metI ,4 metI ,3 esaC ,2 esaC ,1eurT41.3xx epon epon epon sey sey sey esaC');
{$ENDIF}
{$IFDEF TOBJECT_TOSTRING}
  A := TObject.Create;
  Writeln('A = ', ObjectToString(A));
{$ENDIF}
{$IFNDEF CLR}
{$IFDEF TOBJECT_TOSTRING}
  Form := TForm.Create(nil);
  Form.Caption := 'Test';
  Writeln('Form = ', ObjectToString(Form));
  Button := TButton.Create(nil);
  Button.Caption := 'Hello';
  Writeln('Button = ', ObjectToString(Button));
  MyObject := TMyObject.Create;
  MyObject.MyName := 'Hallvard';
  Writeln('MyObject = ', ObjectToString(MyObject));
  MyObject2 := TMyObject2.Create;
  MyObject2.MyName := 'Vassbotn';
  Writeln('MyObject2 = ', ObjectToString(MyObject2));
  MyObject3 := TMyObject3.Create;
  Writeln('MyObject3 = ', ObjectToString(MyObject3));
  MyObject4 := TMyObject4.Create;
  Writeln('MyObject4 = ', ObjectToString(MyObject4));
{$ENDIF}
{$IFDEF STRINGBUILDEREXTENSIONS}
  SB.Clear;
{$ENDIF}
{$IFDEF SUPPORT_APPENDFORMAT}
{$IFDEF OBJECT_TOSTRING}
  SB.AppendFormat2('A=%s, Form=%s, Button=%s, MyObject=%s, MyObject2=%s, MyObject3=%s, MyObject4=%s',
    [A, Form, Button, MyObject, MyObject2, MyObject3, MyObject4]);
  Writeln(SB.ToString);
{$ENDIF}
{$ENDIF}
{$ENDIF}
  SB.Free;
  readln;
end.



