unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.IO, System.Threading;

type

  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    Button1: System.Windows.Forms.Button;
    ListBox1: System.Windows.Forms.ListBox;
    TextBox1: System.Windows.Forms.TextBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    procedure MyCallback(result: IAsyncResult);
  public
    constructor Create;
  end;

  TByteArray = array of Byte;

  TFileState = class(System.Object)
  public
    FFilePath: String;
    FByteArray: TByteArray;
    FFStream: FileStream;
  public
    constructor Create(aFilePath: String; aByteArraySize: Integer;
      aFileStream: FileStream);
    property FilePath: String read FFilePath;
    property FStream: FileStream read FFStream;
    property ByteArray: TByteArray read FByteArray;
  end;

implementation

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.Button1 := System.Windows.Forms.Button.Create;
  Self.ListBox1 := System.Windows.Forms.ListBox.Create;
  Self.TextBox1 := System.Windows.Forms.TextBox.Create;
  Self.SuspendLayout;
  // 
  // Button1
  // 
  Self.Button1.Location := System.Drawing.Point.Create(8, 344);
  Self.Button1.Name := 'Button1';
  Self.Button1.TabIndex := 0;
  Self.Button1.Text := 'Button1';
  Include(Self.Button1.Click, Self.Button1_Click);
  //
  // ListBox1
  //
  Self.ListBox1.Location := System.Drawing.Point.Create(248, 24);
  Self.ListBox1.Name := 'ListBox1';
  Self.ListBox1.Size := System.Drawing.Size.Create(200, 277);
  Self.ListBox1.TabIndex := 2;
  //
  // TextBox1
  //
  Self.TextBox1.Location := System.Drawing.Point.Create(8, 24);
  Self.TextBox1.Multiline := True;
  Self.TextBox1.Name := 'TextBox1';
  Self.TextBox1.Size := System.Drawing.Size.Create(224, 272);
  Self.TextBox1.TabIndex := 3;
  Self.TextBox1.Text := 'TextBox1';
  //
  // TWinForm
  //
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(464, 390);
  Self.Controls.Add(Self.TextBox1);
  Self.Controls.Add(Self.ListBox1);
  Self.Controls.Add(Self.Button1);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  InitializeComponent;
end;

procedure TWinForm.Button1_Click(sender: System.Object;
  e: System.EventArgs);
var
  MyFileStream: FileStream;
  MyFileState: TFileState;
  MyFileInfo: FileInfo;
begin
  MyFileStream := FileStream.Create('c:\ddgdemo.txt', FileMode.Open,
    FileAccess.Read, FileShare.Read, 1, True);
  try
    MyFileInfo := FileInfo.Create('c:\ddgdemo.txt');
    MyFileState := TFileState.Create('c:\ddgdemo.txt', MyFileInfo.Length,
      MyFileStream);
    MyFileStream.BeginRead(MyFileState.ByteArray, 0, MyFileInfo.Length,
      MyCallBack, MyFileState);
  finally
    MyFileStream.Close;
  end;
end;

procedure TWinForm.MyCallback(result: IAsyncResult);
var
  MyState: TFileState;
  i: integer;
begin
  MyState := result.AsyncState as TFileState;
  for i := 1 to 10 do
  begin
    ListBox1.Items.Add(System.String.Format('In callback for File {0}',
      [MyState.FilePath]));
    Thread.Sleep(1500);
  end;
  MyState.FStream.Close;
end;

{ TFileState }

constructor TFileState.Create(aFilePath: String; aByteArraySize: Integer;
  aFileStream: FileStream);
begin
   inherited Create;
   FFilePath := aFilePath;
   SetLength(FByteArray, aByteArraySize);
   FFStream := aFileStream;
end;

end.
