program Serialize;

{$APPTYPE CONSOLE}

{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Runtime.Serialization.Formatters.Soap.dll'}

uses
  SysUtils,
  System.IO,
  System.Runtime.Serialization.Formatters.Soap,
  System.Runtime.Serialization.Formatters.Binary;

type

  [Serializable]
  TClassicCar = class(System.Object)
  public
    FCarName: String;
    [NonSerialized]
    FManufacturer: String;
    FYearIntroduced: DateTime;
  public
    constructor Create(aCar, aMan: String; aYearIntro: DateTime); override;
    property YearIntroduced: DateTime read FYearIntroduced;
    property CarName: String read FCarName;
    property Manufacturer: String read FManufacturer;
  end;

  TClassicCarArray = array[1..2] of TClassicCar;

{ TClassicCar }

constructor TClassicCar.Create(aCar, aMan: String; aYearIntro: DateTime);
begin
  inherited Create;
  FCarName := aCar;
  FManufacturer := aMan;
  FYearIntroduced := aYearIntro;
end;

const
  carOutput = 'Model: {0}, Mfg: {1}, Year: {2}';
var
  MyFileStream: FileStream;
  MySoFormatter: SoapFormatter;
  MyClassicCar: TClassicCar;
  MyClassicCarArray: TClassicCarArray;
  i: integer;
begin
  // Add one classic car
  MyClassicCar := TClassicCar.Create('Camaro', 'Chevrolet',
    EncodeDate(1967, 1, 1));
  MyClassicCarArray[1] := MyClassicCar;

  // Add another classic car
  MyClassicCar := TClassicCar.Create('Mustang', 'Ford',
    EncodeDate(1964, 1, 1));
  MyClassicCarArray[2] := MyClassicCar;

  MyFileStream := FileStream.Create('c:\car.xml', FileMode.Create);
  try
    MySoFormatter := SoapFormatter.Create;
    MySoFormatter.Serialize(MyFileStream, MyClassicCarArray);
  finally
    MyFileStream.Close;
  end;

  // Read back the serialized object
  MyFileStream := System.IO.File.OpenRead('c:\car.xml');
  try
    MySoFormatter := SoapFormatter.Create;
    MyClassicCarArray :=
      TClassicCarArray(MySoFormatter.Deserialize(MyFileStream));
    for i := Low(MyClassicCarArray) to High(MyClassicCarArray) do
      Console.WriteLine(System.String.Format(carOutput,
        [MyClassicCarArray[i].CarName, MyClassicCarArray[i].Manufacturer,
         MyClassicCarArray[i].YearIntroduced]));
  finally
    MyFileStream.Close;
  end;

  Console.ReadLine;
end.
