unit d8dg.SolarSystem;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel;

type
  Planets = class(System.ComponentModel.Component)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    // Array property access methods
    function GetPlanetName(AIndex: Integer): string;
    function GetPlanetPosition(APlanetName: string): Integer;
  public
    constructor Create; overload;
    constructor Create(Container: System.ComponentModel.IContainer); overload;
    // Array property indexed by an integer value. This will be the default
    // array property.
    property PlanetName[AIndex: Integer]: string read GetPlanetName; default;
    // Array property index by a string value
    property PlanetPosition[APlantetName: string]: Integer read GetPlanetPosition;
  end;

implementation

uses
  System.Globalization;

const
  // Declare a constant array containing planet names
  PlanetNames: array[1..9] of string =
   ('Mercury', 'Venus', 'Earth', 'Mars', 'Jupiter', 'Saturn',
    'Uranus', 'Neptune', 'Pluto');

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure Planets.InitializeComponent;
begin
  Self.Components := System.ComponentModel.Container.Create;
end;
{$ENDREGION}

constructor Planets.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

constructor Planets.Create(Container: System.ComponentModel.IContainer);
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  Container.Add(Self);
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure Planets.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

function Planets.GetPlanetName(AIndex: Integer): string;
var
  LowP, HighP: Integer;
begin
  LowP := Low(PlanetNames);
  HighP := High(PlanetNames);
  // Return the name of the planet specified by Index. If Index is
  //  out of the range, then raise an exception
  if (AIndex < LowP) or (AIndex > HighP) then
    raise Exception.Create(System.String.Format(
      'Wrong Planet number, enter a number {0}-{1}',
      TObject(LowP), TObject(HighP)))
  else
    Result := PlanetNames[AIndex];
end;

function Planets.GetPlanetPosition(APlanetName: string): Integer;
var
  I: Integer;
begin
  { Compare PName to each planet name and return the index of the
    appropriate position where PName appears in the constant array.
    Otherwise return zero. }
  Result := 0;
  for I := Low(PlanetNames) to High(PlanetNames) do
  begin
    if  System.String.Compare(APlanetName, PlanetNames[I], True) = 0 then
    begin
      Result := I;
      Break;
    end;
  end;
end;

end.
