program instancethreads;
{$APPTYPE CONSOLE}

//
// This example demonstrates how to use native .NET methods to create a thread on
// a class with an instance method.
//

uses
  System.Threading;

type
  D4DNInstanceThread = class
  private
    FStartNumber : integer;
  public
    // ThreadMePlease will be executed on a different thread
    procedure ThreadMePlease;
    property StartNumber : integer write FStartNumber;
  end;

procedure D4DNInstanceThread.ThreadMePlease;
var
  stop : integer;
  curNum : integer;
begin
  curNum := FStartNumber;
  stop := FStartNumber + 10;
  while curNum < stop do
  begin
    writeln('Thread ', System.Threading.Thread.CurrentThread.Name ,
            ' current value is ',curNum);
    inc(curNum);
    Thread.Sleep(3);
  end;
end;

var
  ThreadWork1 : D4DNInstanceThread;
  ThreadWork2 : D4DNInstanceThread;
  Thread1 : Thread;
  Thread2 : Thread;
begin
  writeln('Starting threading instance method example...');

  // Create D4DNInstanceThread instance
  ThreadWork1 := D4DNInstanceThread.Create;
  ThreadWork1.StartNumber := 10;

  // Create the thread, specifying the instance method to execute
  Thread1 := Thread.Create(@ThreadWork1.ThreadMePlease);
  Thread1.Name := 'one';

  // Create another instance of D4DNInstanceThread
  ThreadWork2 := D4DNInstanceThread.Create;
  ThreadWork2.StartNumber := 100;

  // Create the second thread, specifying the instance method to execute
  Thread2 := Thread.Create(@ThreadWork2.ThreadMePlease);
  Thread2.Name := 'two';

  // Finally start the threads
  Thread1.Start;
  Thread2.Start;

  // Wait for the two threads to finish
  Thread1.Join;
  Thread2.Join;

  // Wait for the user to see the results
  writeln('Done');
  readln;
end.

