program staticthreads;
{$APPTYPE CONSOLE}
//
// This example demonstrates how to use native .NET methods to create a thread on
// a class with a static class method.
//
uses
  System.Threading;

type
  D4DNStaticThread = class
  public
    // method to execute on a secondary thread
    class procedure ThreadMePlease; static;
  end;

class procedure D4DNStaticThread.ThreadMePlease;
var
  stop   : integer;
  curNum : integer;
  rnd    : System.Random;
begin
  rnd    := System.Random.Create;
  curNum := rnd.Next(1000);
  stop := curNum + 10;
  while curNum < stop do
  begin
    writeln('Thread ', System.Threading.Thread.CurrentThread.Name, 
      'current value is ', curNum);
    inc(curNum);
    // Randomly give up time-slice to other thread
    if rnd.Next(100) < 50 then
      Thread.Sleep(0);
  end;
end;

var
  thrd1 : Thread;
  thrd2 : Thread;
begin
  Console.Writeline('Starting static method threading example...');

  // create the thread passing the static method
  thrd1 := Thread.Create(@D4DNStaticThread.ThreadMePlease);
  thrd1.Name := 'one';

  // create another idential thread
  thrd2 := Thread.create(@D4DNStaticThread.ThreadMePlease);
  thrd2.Name := 'two';

  // start both threads
  thrd1.Start;
  thrd2.Start;

  // wait until both threads have finished
  thrd1.Join;
  thrd2.Join;

  Console.Writeline('Done');
  readln;
end.

