program threadpool;
{$APPTYPE CONSOLE}
//
// This example demonstrates how to use a thread from the thread pool
//
uses
  System.Threading;

type
  TThreadPoolMe = class
  public
    // this method will be executed on a threadpool thread
    procedure ThreadMePlease(state : System.Object);
  end;

procedure TThreadPoolMe.ThreadMePlease(state : System.Object);
var
  id : string;
begin
  id := 'n/a';
  if assigned(state) then
    id := state.ToString;

  writeln(id,') Hello from the thread pool. Thread ID is ',
    AppDomain.GetCurrentThreadID,' IsThreadPool = ',
    Thread.CurrentThread.IsThreadPoolThread);

  Thread.Sleep(2000);
end;

const
  MAX_THREADS = 10;
var
  i : integer;
  thrd : array[1..MAX_THREADS] of TThreadPoolMe;
begin
  writeln('The main thread''s id is ', AppDomain.GetCurrentThreadID);
  // queue up a bunch of threads to use the thread pool
  for i:=1 to MAX_THREADS do
  begin
    // create another instance of our class
    thrd[i] := TThreadPoolMe.Create;
    writeln('Queueing thread ', i);
    // now queue up the ThreadMePlease method, passing i in for the state
    System.Threading.ThreadPool.QueueUserWorkItem(
                @thrd[i].ThreadMePlease, System.Object(i));
  end;
  // watch the re-use of the thread id's when this application runs
  readln;
  writeln('Done');
end.