program timerthread;
{$APPTYPE CONSOLE}
//
// This example demonstrates how to use the System.Threading.Timer class.
//
uses
  System.Threading;

type
  TD4DNTimerClass = class
  public
    // Alarm will be called when the Timer fires
    procedure Alarm(state : System.Object);
  end;

procedure TD4DNTimerClass.Alarm(state : System.Object);
begin
  writeln(AppDomain.GetCurrentThreadID,' Bzzzz. Time to wake up!');
  if assigned(state) then
    writeln('You passed me: ', state.ToString);
end;

var
  tc : TD4DNTimerClass;
  t  : Timer;
begin
  // create an instance of our class
  tc := TD4DNTimerClass.Create;
  // create the timer to call Alarm only once, after delaying 1 second (1000 ms)
  t  := Timer.Create(tc.Alarm, System.Object('Some additional info'), 1000 , 0);
  writeln(AppDomain.GetCurrentThreadID,' Waiting for the timer to fire.');
  // give the timer a chance to fire
  Thread.Sleep(2000);
  writeln(AppDomain.GetCurrentThreadID,' Done!');
end.

