unit ProducerConsumerThreads;

interface

uses
  Borland.Vcl.Classes;

type
  TProducerThread = class(TThread)
  private
    FStartNo: integer;
  protected
    procedure Execute; override;
  public
    property StartNo : integer read FStartNo write FStartNo;
  end;

  TConsumerThread = class(TThread)
  protected
    procedure Execute; override;
  end;

  procedure CreateQueue(debug : boolean);
  procedure DestroyQueue;

implementation

uses
  Borland.Vcl.SysUtils, Queue;

const
  MAX_QUEUE_SIZE = 10;

type
  TMyQueuedItem = class
  public
    number : integer;
  end;

var
  TheQueue : TD4DNThreadSafeQueue;

threadvar
  testme : integer;

{ TConsumerThread }

procedure TConsumerThread.Execute;
var
  obj : TMyQueuedItem;

begin
  testme := 0;
  while not Terminated do
  begin
    inc(testme);
    writeln(AppDomain.GetCurrentThreadID(),' ',testme,' Removing from the queue..');
    obj := TMyQueuedItem(TheQueue.GetObject);
    writeln(AppDomain.GetCurrentThreadID(),' after removing the item.. number is ',obj.number);

    Sleep(2000);
  end;
end;

{ TProducerThread }

procedure TProducerThread.Execute;
var
  obj : TMyQueuedItem;

begin
  testme := 0;
  while not Terminated do
  begin
    inc(testme);
    // create an item for the queue
    writeln(AppDomain.GetCurrentThreadID(),' ',testme,' Adding number ',FStartNo,' to the queue');
    obj := TMyQueuedItem.Create;
    obj.number := FStartNo;
    // add this to the queue
    writeln(AppDomain.GetCurrentThreadID(),' Doing the add..');
    TheQueue.AddObject(obj);
    writeln(AppDomain.GetCurrentThreadID(),' Added ',FStartNo,' to queue..');
    inc(FStartNo);

    Sleep(2000);
  end;
end;

procedure CreateQueue(debug : boolean);
begin
  TheQueue := TD4DNThreadSafeQueue.Create(MAX_QUEUE_SIZE);
  TheQueue.Debug := debug;
end;

procedure DestroyQueue;
begin
  TheQueue.Free;
end;

initialization
  if not assigned(TheQueue) then
     CreateQueue(false);

end.
