program prodcons;
{$APPTYPE CONSOLE}

//
// This example demonstrates writing a thread-safe queue using a mutex
// and with events. To use the events version, define the USE_EVENTS symbols
//
// When running this application, experiment with allowing the queue to fill up
// as well as letting it get empty. 
//

{$DEFINE USE_EVENTS}  // uncomment this line to use the events version of the queue

uses
  Borland.Vcl.SysUtils,
{$IFDEF USE_EVENTS}
  QueueWithEvents,
{$ELSE}
  Queue,
{$ENDIF}
  ProducerConsumerThreads;

var
  buffer   : string;
  prodthrd : TProducerThread;
  conthrd  : TConsumerThread;

  function GetCurThreadID : integer;
  begin
    Result := AppDomain.GetCurrentThreadID();
  end;

begin
  // create producer thread which adds items to the queue
  prodthrd := TProducerThread.Create(true);
  prodthrd.StartNo := 77;

  // create a thread that removes items from the queue
  conthrd  := TConsumerThread.Create(true);


  writeln(GetCurThreadID,' starting producer thread..');
  prodthrd.Resume;

  Sleep(1000);
  // wait until we press a key before starting the consumer
  readln(buffer);

  writeln(GetCurThreadID,' Starting consumer thread..');
  conthrd.Resume;

  // terminate the producer
  prodthrd.Terminate;
  // wait before terminating the consumer
  readln(buffer);

  // terminate the consumer
  conthrd.Terminate;

  writeln(GetCurThreadID,' the main thread is done.. destroying the queue');

  DestroyQueue;
end.
