unit rwlockthreads;

interface

uses
  Borland.Vcl.Classes, System.Threading;

type
  TReadThread = class(TThread)
  private
    FRWLock   : System.Threading.ReaderWriterLock;
  protected
    procedure Execute; override;
  public
    property ReadWriteLock : System.Threading.ReaderWriterLock read FRWLock write FRWlock;
  end;

  TWriteThread = class(TThread)
  private
    FRWLock   : System.Threading.ReaderWriterLock;
    FNumToAdd : integer;
  protected
    procedure Execute; override;
  public
    property ReadWriteLock : System.Threading.ReaderWriterLock read FRWLock   write FRWlock;
    property NumberToAdd   : integer      read FNumToAdd write FNumToAdd;
  end;

implementation

uses
  Borland.Vcl.SysUtils;

const
  INFINITE = -1;

var
  GlobalNumber : integer = 50;

{ TReadThread }

procedure TReadThread.Execute;
begin
  try
    while not Terminated do
    begin
      writeln(AppDomain.GetCurrentThreadID(),' TReadThread waiting for a read lock ');
      // grab a read lock
      FRWLock.AcquireReaderLock(INFINITE);
      try
        writeln(AppDomain.GetCurrentThreadID(),' TReadThread reads the balance as ',GlobalNumber);
        Thread.Sleep(1000 * Random(3));
      finally
        FRWLock.ReleaseReaderLock;
      end;
      Thread.Sleep(1000 * Random(5));
    end;
  except
    on e : exception do
    begin
      writeln('Exception fired in ReadThread ',e.message);
    end;
  end;
end;

{ TWriteThread }

procedure TWriteThread.Execute;
begin
  try
    // grab a write lock
    writeln(AppDomain.GetCurrentThreadID(),' TWriteThread waiting for a write lock');
    FRWLock.AcquireWriterLock(INFINITE);
    try
      writeln(AppDomain.GetCurrentThreadID(),' TWriteThread grabed a write lock. Current number is ',GlobalNumber);
      writeln(AppDomain.GetCurrentThreadID(),' adding ',FNumToAdd,' to the CurrentNumber');
      GlobalNumber := GlobalNumber + FNumToAdd;
      writeln(AppDomain.GetCurrentThreadID(),' TWriteThread is done with the lock..');
    finally
      FRWLock.ReleaseWriterLock;
    end;
  except
    on e : exception do
    begin
      writeln('exception fired in WriteThread ',e.message);
    end;
  end;
end;

begin
  // Initialize the random number generator
  Randomize;
end.
