unit MainFrm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Reflection;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    TreeView1: System.Windows.Forms.TreeView;
    Button1: System.Windows.Forms.Button;
    OpenFileDialog1: System.Windows.Forms.OpenFileDialog;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
    procedure ReflectAssembly(aAssembly: Assembly);
    procedure ReflectModule(aModule: Module; aTn: TreeNode);
    procedure ReflectType(aType: System.Type; aTn: TreeNode);
  public
    constructor Create;
  end;

implementation

uses
  System.Globalization;

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.TreeView1 := System.Windows.Forms.TreeView.Create;
  Self.Button1 := System.Windows.Forms.Button.Create;
  Self.OpenFileDialog1 := System.Windows.Forms.OpenFileDialog.Create;
  Self.SuspendLayout;
  // 
  // TreeView1
  // 
  Self.TreeView1.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
      or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
      or System.Windows.Forms.AnchorStyles.Right)));
  Self.TreeView1.ImageIndex := -1;
  Self.TreeView1.Location := System.Drawing.Point.Create(0, 0);
  Self.TreeView1.Name := 'TreeView1';
  Self.TreeView1.SelectedImageIndex := -1;
  Self.TreeView1.Size := System.Drawing.Size.Create(536, 296);
  Self.TreeView1.TabIndex := 0;
  // 
  // Button1
  // 
  Self.Button1.Anchor := (System.Windows.Forms.AnchorStyles((System.Windows.Forms.AnchorStyles.Bottom 
      or System.Windows.Forms.AnchorStyles.Left)));
  Self.Button1.Location := System.Drawing.Point.Create(8, 304);
  Self.Button1.Name := 'Button1';
  Self.Button1.TabIndex := 1;
  Self.Button1.Text := 'Reflect';
  Include(Self.Button1.Click, Self.Button1_Click);
  // 
  // OpenFileDialog1
  // 
  Self.OpenFileDialog1.DefaultExt := '*.exe';
  Self.OpenFileDialog1.Filter := 'Apps (*.exe)|*.exe|Libraries (*.dll)|*.dll';
  Self.OpenFileDialog1.InitialDirectory := '.';
  Self.OpenFileDialog1.Title := 'Load Assembly';
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(536, 334);
  Self.Controls.Add(Self.Button1);
  Self.Controls.Add(Self.TreeView1);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TWinForm.Button1_Click(sender: System.Object; e: System.EventArgs);
var
  Assem: Assembly;
begin
  if (OpenFileDialog1.ShowDialog = System.Windows.Forms.DialogResult.OK) then
  begin
    Cursor.Current := Cursors.WaitCursor;
    try
      Assem := Assembly.LoadFrom(OpenFileDialog1.FileName);
      ReflectAssembly(Assem);
    finally
      Cursor.Current := Cursors.Default;
    end;
  end;
end;

procedure TWinForm.ReflectAssembly(aAssembly: Assembly);
var
  arModule: array of Module;
  i: integer;
  tn: TreeNode;
  tni: TreeNode;
  arAttrib: array of System.Object;
  arAsmName: array of AssemblyName;
  arType: array of System.Type;
begin
  // Show key information
  tn := TreeView1.Nodes.Add(aAssembly.FullName);
  tn.Nodes.Add('Location: '+aAssembly.Location);
  if aAssembly.GlobalAssemblyCache then
    tn.Nodes.Add('Global Cache: Yes')
  else
    tn.Nodes.Add('Global Cache: No');

  // Determine calling assembly
  tn.Nodes.Add('Calling Assembly: '+aAssembly.GetCallingAssembly.FullName);

  // Examine custom attributes
  tni := tn.Nodes.Add('Custom Attributes');
  arAttrib := aAssembly.GetCustomAttributes(true);
  for i := Low(arAttrib) to High(arAttrib) do
    tni.Nodes.Add(arAttrib[i].ToString);

  // Examine Referenced assemblies
  tni := tn.Nodes.Add('Referenced Assemblies');
  arAsmName := aAssembly.GetReferencedAssemblies;
  for i := Low(arAsmName) to High(arAsmName) do
    tni.Nodes.Add(arAsmName[i].FullName);

  // Examine types defined in an assembly
  tni := tn.Nodes.Add('Assembly Types');
  arType := aAssembly.GetTypes;
  for i := Low(arType) to High(arType) do
    tni.Nodes.Add(arType[i].ToString);

  // Examine and drill down into an assembly
  arModule := aAssembly.GetModules;
  tn := tn.Nodes.Add('Modules');
  for i := Low(arModule) to High(arModule) do
    ReflectModule(arModule[i], tn);
end;

procedure TWinForm.ReflectModule(aModule: Module; aTn: TreeNode);
var
  arType: array of System.Type;
  arAttrib: array of System.Object;
  arFields: array of FieldInfo;
  arMeth: array of MethodInfo;
  i: integer;
  tn: TreeNode;
  tni: TReeNode;
begin
  tn := aTn.Nodes.Add(aModule.Name);
  tn.Nodes.Add('Fully Qualified Name: '+aModule.FullyQualifiedName);
  tn.Nodes.Add('Is Resource: '+ TObject(aModule.IsResource).ToString);

  // Examine custom attributes
  tni := tn.Nodes.Add('Custom Attributes');
  arAttrib := aModule.GetCustomAttributes(true);
  for i := Low(arAttrib) to High(arAttrib) do
    tni.Nodes.Add(arAttrib[i].ToString);

  // Examine fields
  tni := tn.Nodes.Add('Fields');
  arFields := aModule.GetFields;
  for i := Low(arFields) to High(arFields) do
    tni.Nodes.Add(arFields[i].ToString);

  // Examine modules
  tni := tn.Nodes.Add('Methods');
  arMeth := aModule.GetMethods;
  for i := Low(arMeth) to High(arMeth) do
    tni.Nodes.Add(arMeth[i].ToString);

  // Examine types
  arType := aModule.GetTypes;
  tn := tn.Nodes.Add('Types');
  for i := Low(arType) to High(arType) do
    ReflectType(arType[i], tn);
end;

function GetDeclareString(st: System.Type): String;
begin
  Result := '';
  if st.IsAbstract then Result := Result + 'abstract ';
  if st.IsArray    then Result := Result + 'array ';
  if st.IsClass    then Result := Result + 'class ';
  if st.IsContextful then Result := Result + 'context ';
  if st.IsInterface  then Result := Result + 'interface ';
  if st.IsPointer    then Result := Result + 'pointer ';
  if st.IsPrimitive  then Result := Result + 'primitive ';
  if st.IsPublic     then Result := Result + 'public ';
  if st.IsSealed     then Result := Result + 'sealed ';
  if st.IsSerializable then Result := Result + 'serializable ';
  if st.IsValueType then Result := Result + 'record ';
end;

procedure TWinForm.ReflectType(aType: System.Type; aTn: TreeNode);
var
  arMembInfo: array of MemberInfo;
  arType: array of System.Type;
  i: integer;
  tn, fn: TreeNode;
begin
  tn := aTn.Nodes.Add(aType.FullName);
  tn.Nodes.Add('Base Type: '+aType.BaseType.FullName);
  tn.Nodes.Add(GetDeclareString(aType));
  arMembInfo := aType.GetMembers;

  for i := Low(arMembInfo) to High(arMembInfo) do
  begin
    fn := tn.Nodes.Add(System.String.Format('{0}: {1}',
       arMembInfo[i].MemberType, arMembInfo[i]))
  end;

  arType := aType.GetNestedTypes;
  for i := Low(arType) to High(arType) do
    ReflectType(arType[i], tn);
end;

end.



