program InvProject;

{$APPTYPE CONSOLE}

uses
  System.Reflection,
  SysUtils;

var
  Assem: Assembly;
  BFlags: BindingFlags;

  procedure InvokeType(aNameSpace: String);
  var
    obj: System.Object;
    Meth: MethodInfo;
    t: System.Type;
    ParamTypes: array of System.Type;
  begin
    t := Assem.GetType(aNameSpace+'.TClass1');
    Console.WriteLine(t.ToString);
    obj := Activator.CreateInstance(t);
    Console.WriteLine(obj.ToString);

    t.InvokeMember('WriteMessage', BFlags, nil, obj,
      ['This is the message']);

    // An alternative method is shown below.
    SetLength(ParamTypes, 1);
    ParamTypes[0] := TypeOf(System.String);
    Meth := t.GetMethod('WriteMessage', ParamTypes);
    Console.WriteLine(Meth.ToString);
    Meth.Invoke(obj, ['This is the message']);
  end;

begin
  BFlags := BindingFlags.DeclaredOnly or BindingFlags.Public or
    BindingFlags.Instance or BindingFlags.InvokeMethod;

  try
    Assem := Assembly.LoadFrom('asmRemInv1.dll');
    InvokeType('asmRemInv1');

    Assem := Assembly.LoadFrom('asmRemInv2.dll');
    InvokeType('asmRemInv2');
  except
    on E: Exception do
    Console.WriteLine('Error: '+E.Message);
  end;
  Console.ReadLine();
end.
