program EmitDemo;
{$APPTYPE CONSOLE}

uses
  System.Reflection,
  System.Reflection.Emit;

var
  appDmn:  AppDomain;
  asmName: AssemblyName;
  asmBuilder: AssemblyBuilder;
  modBuilder: ModuleBuilder;
  typBuilder: TypeBuilder;
  methBuilder: MethodBuilder;
  ilGen: ILGenerator;
  newType: System.Type;

  procedure CreateWLCall;
  var
    parms: array of System.Type;
    methInfo: MethodInfo;
    wlTypes: array of System.Type;
    SysConsoleType : System.Type;
  begin
    SetLength(Parms, 1);
    Parms[0] := typeof(System.String);

    methBuilder := typBuilder.DefineMethod('Main', MethodAttributes.Public
      or MethodAttributes.Static, typeof(integer), System.Type.EmptyTypes);

    ilGen := methBuilder.GetILGenerator;

    SetLength(wltypes, 1);
    wltypes[0] := typeof('System.String');
    methInfo := typeof(System.Console).GetMethod('WriteLine', wlTypes);

    if methInfo = nil then
      raise Exception.Create('unable to find WriteLine');

    ilGen.Emit(Opcodes.Ldstr, 'Delphi for .NET');
    ilGen.Emit(OpCodes.Call, methInfo);
    ilGen.Emit(OpCodes.Ldc_I4_0);
    ilGen.Emit(OpCodes.Ret);
  end;

begin
  asmName := AssemblyName.Create;
  asmName.Name := 'D4DNeDevGuideAsm';

  appDmn := AppDomain.CurrentDomain;
  asmBuilder := appDmn.DefineDynamicAssembly(AsmName,
    AssemblyBuilderAccess.Save);

  modBuilder := asmBuilder.DefineDynamicModule(asmName.Name,
    'd4dmasm.exe');
  typBuilder := ModBuilder.DefineType('Class1');
  CreateWLCall;

  asmBuilder.SetEntryPoint(methBuilder, PEFileKinds.ConsoleApplication);

  newType := typBuilder.CreateType();
  asmBuilder.Save('d4dmasm.exe');
  System.Console.Write('done');
end.
