unit WordAutomationU;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  TWordAutomation = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnAutomateWord: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure TWordAutomation_Load(sender: System.Object; e: System.EventArgs);
    procedure TWordAutomation_Closed(sender: System.Object; e: System.EventArgs);
    procedure btnAutomateWord_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    MSWordType: &Type;
    MSWord: TObject;
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWordAutomation))]

implementation

uses
  System.Reflection;

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWordAutomation.InitializeComponent;
begin
  Self.btnAutomateWord := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // btnAutomateWord
  // 
  Self.btnAutomateWord.Location := System.Drawing.Point.Create(8, 6);
  Self.btnAutomateWord.Name := 'btnAutomateWord';
  Self.btnAutomateWord.Size := System.Drawing.Size.Create(272, 40);
  Self.btnAutomateWord.TabIndex := 0;
  Self.btnAutomateWord.Text := 'Automate Word';
  Include(Self.btnAutomateWord.Click, Self.btnAutomateWord_Click);
  // 
  // TWordAutomation
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(288, 53);
  Self.Controls.Add(Self.btnAutomateWord);
  Self.Name := 'TWordAutomation';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'Word Automation';
  Include(Self.Load, Self.TWordAutomation_Load);
  Include(Self.Closed, Self.TWordAutomation_Closed);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWordAutomation.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWordAutomation.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TWordAutomation.TWordAutomation_Load(sender: System.Object; e: System.EventArgs);
begin
  //Instantiate Microsoft Word
  MSWordType := System.Type.GetTypeFromProgID('Word.Application', True);
  MSWord := Activator.CreateInstance(MSWordType);
end;

procedure TWordAutomation.TWordAutomation_Closed(sender: System.Object; e: System.EventArgs);
begin
  //Quit Microsoft Word
  //MSWord.Quit(False);
  MSWordType.InvokeMember(
    'Quit', BindingFlags.InvokeMethod, nil, MSWord, [False]);
  MSWord := nil;
  MSWordType := nil;
end;

procedure TWordAutomation.btnAutomateWord_Click(sender: System.Object; e: System.EventArgs);
var
  Documents, Selection: TObject;
begin
  //Set the Visible property
  //MSWord.Visible := True;
  MSWordType.InvokeMember(
    'Visible', BindingFlags.SetProperty, nil, MSWord, [True]);
  //Create a document
  //MSWord.Documents.Add
  Documents := MSWordType.InvokeMember(
    'Documents', BindingFlags.GetProperty, nil, MSWord, nil);
  MSWordType.InvokeMember(
    'Add', BindingFlags.InvokeMethod, nil, Documents, nil);
  //Write some text
  //MSWord.Selection.TypeText('Hello world! Time is: ');
  Selection := MSWordType.InvokeMember(
    'Selection', BindingFlags.GetProperty, nil, MSWord, nil);
  MSWordType.InvokeMember(
    'TypeText', BindingFlags.InvokeMethod, nil, Selection,
    ['Hello world! Time is: ']);
  //Insert date/time
  //MSWord.Selection.InsertDateTime('dddd, dd MMMM yyyy', False);
  MSWordType.InvokeMember(
    'InsertDateTime', BindingFlags.InvokeMethod, nil, Selection,
    ['dddd, dd MMMM yyyy', False]);
  //Add CR/LF
  //MSWord.Selection.TypeParagraph;
  MSWordType.InvokeMember(
    'TypeParagraph', BindingFlags.InvokeMethod, nil, Selection, nil);
end;

end.
