unit dotNetAppLateBoundU;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  TfrmLateBound = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnCallOne: System.Windows.Forms.Button;
    btnCallTwo: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnCallOne_Click(sender: System.Object; e: System.EventArgs);
    procedure btnCallTwo_Click(sender: System.Object; e: System.EventArgs);
    procedure TfrmLateBound_Load(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    ComObjType: System.Type;
    ComObj: TObject;
  public
    constructor Create;
  end;

implementation

uses
  System.Reflection;

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TfrmLateBound.InitializeComponent;
begin
  Self.btnCallOne := System.Windows.Forms.Button.Create;
  Self.btnCallTwo := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // btnCallOne
  // 
  Self.btnCallOne.Location := System.Drawing.Point.Create(8, 8);
  Self.btnCallOne.Name := 'btnCallOne';
  Self.btnCallOne.TabIndex := 0;
  Self.btnCallOne.Text := 'Call One';
  Include(Self.btnCallOne.Click, Self.btnCallOne_Click);
  // 
  // btnCallTwo
  // 
  Self.btnCallTwo.Location := System.Drawing.Point.Create(104, 8);
  Self.btnCallTwo.Name := 'btnCallTwo';
  Self.btnCallTwo.TabIndex := 1;
  Self.btnCallTwo.Text := 'Call Two';
  Include(Self.btnCallTwo.Click, Self.btnCallTwo_Click);
  // 
  // TfrmLateBound
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(192, 37);
  Self.Controls.Add(Self.btnCallTwo);
  Self.Controls.Add(Self.btnCallOne);
  Self.Name := 'TfrmLateBound';
  Self.Text := 'Late Bound Example';
  Include(Self.Load, Self.TfrmLateBound_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TfrmLateBound.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TfrmLateBound.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TfrmLateBound.TfrmLateBound_Load(sender: System.Object; e: System.EventArgs);
begin
  ComObjType := System.Type.GetTypeFromProgID('ComServer.ComObject');
  ComObj := Activator.CreateInstance(ComObjType);
end;

procedure TfrmLateBound.btnCallOne_Click(sender: System.Object; e: System.EventArgs);
begin
  //Set up a call to a method with a value parameter
  ComObjType.InvokeMember(
    'One', BindingFlags.InvokeMethod, nil, ComObj, ['Hello world']);
end;

procedure TfrmLateBound.btnCallTwo_Click(sender: System.Object; e: System.EventArgs);
var
  TwoArgs: array[0..1] of TObject;
  MethodResult: TObject;
  ParamModifiers: array[0..0] of ParameterModifier;
  RefParam: Integer;
const
  ValParam = 45;
begin
  //Set up a method call with a value parameter and a reference parameter
  TwoArgs[0] := TObject(Integer(ValParam)); //pass by value
  RefParam := 0;
  TwoArgs[1] := TObject(RefParam); //pass by reference
  //the modifier has items for each parameter
  ParamModifiers[0] := ParameterModifier.Create(2);
  ParamModifiers[0][0] := False; //1st arg is by value
  ParamModifiers[0][1] := True;  //2nd arg is by reference
  MethodResult := ComObjType.InvokeMember(
    'Two', BindingFlags.InvokeMethod, nil, ComObj,
    TwoArgs, ParamModifiers, nil, nil);
  if Boolean(MethodResult) then
    MessageBox.Show(System.String.Format('Twice {0} is {1}', TwoArgs));
end;

end.
