unit SpeechAPIExample2U;

interface

uses
  SpeechLib,
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  TMainForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnSay: System.Windows.Forms.Button;
    txtWords: System.Windows.Forms.TextBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnSay_Click(sender: System.Object; e: System.EventArgs);
    procedure TMainForm_Load(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    Voice: SpVoice;
    procedure VoiceEndStream(StreamNumber: Integer; StreamPosition: TObject);
    procedure VoiceWord(StreamNumber: Integer; StreamPosition: TObject;
      CharacterPosition, Length: Integer);
  public
    constructor Create;
  end;

implementation

uses
  System.Diagnostics;

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TMainForm.InitializeComponent;
begin
  Self.btnSay := System.Windows.Forms.Button.Create;
  Self.txtWords := System.Windows.Forms.TextBox.Create;
  Self.SuspendLayout;
  // 
  // btnSay
  // 
  Self.btnSay.Location := System.Drawing.Point.Create(109, 8);
  Self.btnSay.Name := 'btnSay';
  Self.btnSay.TabIndex := 0;
  Self.btnSay.Text := '&Speak';
  Include(Self.btnSay.Click, Self.btnSay_Click);
  // 
  // txtWords
  // 
  Self.txtWords.HideSelection := False;
  Self.txtWords.Location := System.Drawing.Point.Create(8, 40);
  Self.txtWords.Multiline := True;
  Self.txtWords.Name := 'txtWords';
  Self.txtWords.Size := System.Drawing.Size.Create(272, 64);
  Self.txtWords.TabIndex := 1;
  Self.txtWords.Text := 'This application reads words out loud for you.';
  // 
  // TMainForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(292, 109);
  Self.Controls.Add(Self.txtWords);
  Self.Controls.Add(Self.btnSay);
  Self.MaximizeBox := False;
  Self.MinimizeBox := False;
  Self.Name := 'TMainForm';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'Speech Example';
  Include(Self.Load, Self.TMainForm_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TMainForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TMainForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TMainForm.TMainForm_Load(sender: System.Object; e: System.EventArgs);
begin
  Voice := SpVoiceClass.Create;
  Voice.EventInterests :=
    SpeechVoiceEvents.SVEWordBoundary or SpeechVoiceEvents.SVEEndInputStream;
  Include(Voice.Word, VoiceWord);
  Include(Voice.EndStream, VoiceEndStream);
end;

procedure TMainForm.btnSay_Click(sender: System.Object; e: System.EventArgs);
begin
  //Speak asynchronously so the events can fire
  Voice.Speak(txtWords.Text, SpeechVoiceSpeakFlags.SVSFlagsAsync);
end;

procedure TMainForm.VoiceEndStream(StreamNumber: Integer;
  StreamPosition: TObject);
begin
  //When speech stream ends, remove the highlight from the text box
  txtWords.SelectionLength := 0;
  txtWords.SelectionStart := Length(txtWords.Text);
end;

procedure TMainForm.VoiceWord(StreamNumber: Integer;
  StreamPosition: TObject; CharacterPosition, Length: Integer);
begin
  //As each word is encountered, highlight it in the text box
  txtWords.SelectionStart := CharacterPosition;
  txtWords.SelectionLength := Length; //highlight word
end;

end.
