unit PInvokeExampleU;

interface

uses
  Windows,
  System.Runtime.InteropServices,
  System.Security,
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  frmPInvoke = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnDoPInvoke: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnDoPInvoke_Click(sender: System.Object; e: System.EventArgs);
    procedure frmPInvoke_Load(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

function QueryPerformanceCounter(out lpPerformanceCount: TLargeInteger): BOOL;
function QueryPerformanceFrequency(out lpFrequency: TLargeInteger): BOOL;

implementation

const
  kernel32 = 'kernel32.dll';

[DllImport(kernel32), SuppressUnmanagedCodeSecurity]
function QueryPerformanceCounter; external;
[DllImport(kernel32), SuppressUnmanagedCodeSecurity]
function QueryPerformanceFrequency; external;

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure frmPInvoke.InitializeComponent;
begin
  Self.btnDoPInvoke := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // btnDoPInvoke
  // 
  Self.btnDoPInvoke.Location := System.Drawing.Point.Create(14, 16);
  Self.btnDoPInvoke.Name := 'btnDoPInvoke';
  Self.btnDoPInvoke.Size := System.Drawing.Size.Create(264, 23);
  Self.btnDoPInvoke.TabIndex := 0;
  Self.btnDoPInvoke.Text := 'Call P/Invoke routines';
  Include(Self.btnDoPInvoke.Click, Self.btnDoPInvoke_Click);
  // 
  // frmPInvoke
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(292, 69);
  Self.Controls.Add(Self.btnDoPInvoke);
  Self.Name := 'frmPInvoke';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'P/Invoke performance example';
  Include(Self.Load, Self.frmPInvoke_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure frmPInvoke.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor frmPInvoke.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure frmPInvoke.frmPInvoke_Load(sender: System.Object; e: System.EventArgs);
begin
{$define PRELINK_ALL}
{$ifdef PRELINK_ALL}
  Marshal.PrelinkAll(GetType.Module.GetType('PInvokeExampleU.Unit'));
{$else}
  Marshal.Prelink(GetType.Module.GetType('PInvokeExampleU.Unit').GetMethod(
    'QueryPerformanceFrequency'));
  Marshal.Prelink(GetType.Module.GetType('PInvokeExampleU.Unit').GetMethod(
    'QueryPerformanceCounter'));
{$endif}
end;

procedure frmPInvoke.btnDoPInvoke_Click(sender: System.Object;
  e: System.EventArgs);
var
  StartTime, EndTime, TimerFrequency: Int64;
  TimeDiff, SqrRoot: Double;
  I: Integer;
const
  NumIterations = 50000000;

  procedure TimerError;
  begin
    raise Exception.Create('High accuracy timing not supported')
  end;

begin
  if not QueryPerformanceFrequency(TimerFrequency) then
    TimerError;
  if not QueryPerformanceCounter(StartTime) then
    TimerError;
  for I := 1 to NumIterations do
    SqrRoot := Sqrt(2);
  if not QueryPerformanceCounter(EndTime) then
    TimerError;
  TimeDiff := (EndTime - StartTime) / TimerFrequency;
  MessageBox.Show(System.String.Format(
    '{0} square roots takes {1:f02} seconds', [NumIterations, TimeDiff]),
    'Timing Results', MessageBoxButtons.OK, MessageBoxIcon.Information)
end;

end.
