library dotNetAssembly;

{$UNSAFECODE ON}
{.$DEFINE USE_DELPHI_STRING_INDEXING}

{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Windows.Forms.dll'}

uses
  System.Text,
  System.Runtime.InteropServices,
  System.Windows.Forms;

//BufferLen is the length of the unmanaged buffer,
//not counting the null terminator, i.e. the number of characters
function GetDotNETVersion(Buffer: PWideChar; BufferLen: Integer): Integer; unsafe;
var
  I: Integer;
  VersionStr: String;
  MinLen: Integer;
begin
  VersionStr := System.String.Format(
    '.NET version {0}', Environment.Version.ToString);
  MinLen := Math.Min(VersionStr.Length, BufferLen);
{$ifdef USE_DELPHI_STRING_INDEXING}
  for I := 0 to MinLen-1 do
    Buffer[I] := VersionStr[I+1];
{$else}
  for I := 0 to MinLen-1 do
    Buffer[I] := VersionStr.Chars[I];
{$endif}
  Buffer[MinLen] := #0;
  Result := VersionStr.Length
end;

//With P/Invoke, String defaults to marshalling as UnmanagedType.LPStr
//So In D7 we would need to use a PChar. However, for consistency with the
//other routine exported from here we'll make it go out as PWideChar
procedure ShowAMessage([MarshalAs(UnmanagedType.LPWStr)]Msg: String);
begin
  MessageBox.Show(Msg)
end;

exports
  GetDotNETVersion,
  ShowAMessage;

begin
end.
