program mappings;

{$APPTYPE CONSOLE}

{%DelphiDotNetAssemblyCompiler 'c:\windows\microsoft.net\framework\v1.1.4322\System.Data.dll'}

uses
  System.Data,
  System.Data.SqlClient,
  System.Data.Common,
  System.Collections;

const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel_emp = 'select * from Employees; select * from Customers;';
var
  sqlDA: SqlDataAdapter;
  nwDS: DataSet;
  dt: DataTable;
  dtEnum: IEnumerator;
  coEnum: IEnumerator;
  dc: DataColumn;

  tmEnum: IEnumerator;
  dtm: DataTableMapping;

  cmEnum: IEnumerator;
  dcm: DataColumnMapping;
begin
  sqlDA := SQLDataAdapter.Create(c_sel_emp, c_cnstr);
  nwDS := DataSet.Create;

  // Map the tables

  // Uncommment here to perform mapping
  dtm := sqlDA.TableMappings.Add('Table', 'Employees');
  dtm.ColumnMappings.Add('EmployeeID', 'EmpID');
  dtm := sqlDA.TableMappings.Add('Table1', 'Customers');
  dtm.ColumnMappings.Add('CustomerID', 'CustID');

  sqlDA.Fill(nwDS);

  tmEnum := sqlDA.TableMappings.GetEnumerator;

  while tmEnum.MoveNext do
  begin
    dtm := tmEnum.Current as DataTableMapping;
    Console.WriteLine('DataSet Table: {0}, Data source table: {1}',
     [dtm.DataSetTable, dtm.SourceTable]);

    cmEnum := dtm.ColumnMappings.GetEnumerator;
    while cmEnum.MoveNext do
    begin
      dcm := cmEnum.Current as DataColumnMapping;
      Console.WriteLine('  DataSet Column: {0}, Data source column: {1}',
        dcm.DataSetColumn, dcm.SourceColumn);
    end;
  end;

  // Write out the tables.
  dtEnum := nwDS.Tables.GetEnumerator;
  while dtEnum.MoveNext do
  begin
    dt := dtEnum.Current as DataTable;
    Console.WriteLine(dt.TableName);

    coEnum := dt.Columns.GetEnumerator;

    while coEnum.MoveNext do
    begin
      dc := coEnum.Current as DataColumn;
      Console.WriteLine('  '+dc.ColumnName);
    end;
    Console.WriteLine('=================');
  end;

  Console.ReadLine;
end.
