unit MainWinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Globalization, System.Data.SqlClient;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    SqlConnection1: System.Data.SqlClient.SqlConnection;
    DataSet1: System.Data.DataSet;
    sqlSelectCommand1: System.Data.SqlClient.SqlCommand;
    sqlUpdateCommand1: System.Data.SqlClient.SqlCommand;
    sqlDeleteCommand1: System.Data.SqlClient.SqlCommand;
    SqlDataAdapter1: System.Data.SqlClient.SqlDataAdapter;
    SqlCommand1: System.Data.SqlClient.SqlCommand;
    TreeView1: System.Windows.Forms.TreeView;
    DataGrid1: System.Windows.Forms.DataGrid;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  public
    constructor Create;
  end;

implementation

{.$R 'MainWinForm.TWinForm.resources'}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.SqlConnection1 := System.Data.SqlClient.SqlConnection.Create;
  Self.DataSet1 := System.Data.DataSet.Create;
  Self.sqlSelectCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.sqlUpdateCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.sqlDeleteCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.SqlDataAdapter1 := System.Data.SqlClient.SqlDataAdapter.Create;
  Self.SqlCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.TreeView1 := System.Windows.Forms.TreeView.Create;
  Self.DataGrid1 := System.Windows.Forms.DataGrid.Create;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).BeginInit;
  Self.SuspendLayout;
  // 
  // DataSet1
  // 
  Self.DataSet1.DataSetName := 'NewDataSet';
  Self.DataSet1.Locale := System.Globalization.CultureInfo.Create('en-US');
  // 
  // SqlDataAdapter1
  // 
  Self.SqlDataAdapter1.DeleteCommand := Self.sqlDeleteCommand1;
  Self.SqlDataAdapter1.InsertCommand := Self.SqlCommand1;
  Self.SqlDataAdapter1.SelectCommand := Self.sqlSelectCommand1;
  Self.SqlDataAdapter1.UpdateCommand := Self.sqlUpdateCommand1;
  // 
  // SqlCommand1
  // 
  Self.SqlCommand1.Connection := Self.SqlConnection1;
  // 
  // TreeView1
  // 
  Self.TreeView1.Anchor := (System.Windows.Forms.AnchorStyles(((System.Windows.Forms.AnchorStyles.Top 
      or System.Windows.Forms.AnchorStyles.Left) or System.Windows.Forms.AnchorStyles.Right)));
  Self.TreeView1.ImageIndex := -1;
  Self.TreeView1.Location := System.Drawing.Point.Create(8, 8);
  Self.TreeView1.Name := 'TreeView1';
  Self.TreeView1.SelectedImageIndex := -1;
  Self.TreeView1.Size := System.Drawing.Size.Create(376, 160);
  Self.TreeView1.TabIndex := 0;
  // 
  // DataGrid1
  // 
  Self.DataGrid1.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
      or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
      or System.Windows.Forms.AnchorStyles.Right)));
  Self.DataGrid1.DataMember := '';
  Self.DataGrid1.DataSource := Self.DataSet1;
  Self.DataGrid1.HeaderForeColor := System.Drawing.SystemColors.ControlText;
  Self.DataGrid1.Location := System.Drawing.Point.Create(8, 184);
  Self.DataGrid1.Name := 'DataGrid1';
  Self.DataGrid1.Size := System.Drawing.Size.Create(376, 192);
  Self.DataGrid1.TabIndex := 1;
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(392, 398);
  Self.Controls.Add(Self.DataGrid1);
  Self.Controls.Add(Self.TreeView1);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).EndInit;
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel = 'select * from suppliers; select * from products;';
var
  pEnum: IEnumerator;
  pDr: DataRow;
  pCol: DataColumn;
  cCol: DataColumn;
  dr: DataRelation;
  tn: TreeNode;
  drAry: array of DataRow;
  i: integer;

begin
  inherited Create;
  InitializeComponent;

  SqlConnection1.ConnectionString := c_cnstr;
  SqlCommand1.CommandText := c_sel;
  SqlCommand1.Connection := SqlConnection1;
  SqlDataAdapter1.SelectCommand := SqlCommand1;
  SqlDataAdapter1.TableMappings.Add('Table', 'Suppliers');
  SqlDataAdapter1.TableMappings.Add('Table1', 'Products');
  SqlDataAdapter1.Fill(DataSet1);

  pCol := DataSet1.Tables['Suppliers'].Columns['SupplierID'];
  cCol := DataSet1.Tables['Products'].Columns['SupplierID'];

  dr := DataRelation.Create('Sup_Prod', pCol, cCol);
  DataSet1.Relations.Add(dr);

  // Create expression columns.
  DataSet1.Tables['Products'].Columns.Add('ContactName', TypeOf(String),
    'Parent(Sup_Prod).ContactName');

  DataSet1.Tables['Suppliers'].Columns.Add('AvgPrice', TypeOf(Decimal),
    'AVG(Child(Sup_Prod).UnitPrice)');

  pEnum := DataSet1.Tables['Suppliers'].Rows.GetEnumerator;
  while pEnum.MoveNext do
  begin
    pDr := pEnum.Current as DataRow;
    tn := TreeView1.Nodes.Add(pDr['CompanyName'].ToString);
    drAry := pDr.GetChildRows(dr);
    for i := Low(drAry) to High(drAry) do
      tn.Nodes.Add(drAry[i]['ProductName'].ToString)
  end;
end;


end.
