program DataRowOps;

{$APPTYPE CONSOLE}

{%DelphiDotNetAssemblyCompiler 'c:\windows\microsoft.net\framework\v1.1.4322\System.Data.dll'}

uses
  System.Data,
  System.Data.SqlClient;

const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel = 'select * from Customers;';

var
  cnNW: SqlConnection;
  cmNW: SqlCommand;
  daNW: SqlDataAdapter;
  dsNW: DataSet;
  dtCust: DataTable;
  drCust: DataRow;

begin
  cnNW := SqlConnection.Create(c_cnstr);
  cmNW := SqlCommand.Create(c_sel, cnNW);
  daNW := SqlDataAdapter.Create(cmNW);
  daNW.TableMappings.Add('Table', 'Customers');
  dsNW := DataSet.Create;
  daNW.Fill(dsNW);
  dtCust := dsNW.Tables['Customers'];
  drCust := dtCust.Rows[0];

  // Add a new Row
  drCust := dtCust.NewRow;
  drCust['CustomerID'] := 'XAWPA';
  drCust['CompanyName'] := 'Xapware';
  drCust['ContactName'] := 'Xavier Pacheco';
  drCust['ContactTitle'] := 'Author';
  dtCust.Rows.Add(drCust);

  Console.WriteLine('Row Added --- ');
  Console.WriteLine('     {0} : {1} : {2} : {3} : {4}', [drCust['CustomerID'],
    drCust['CompanyName'], drCust['ContactName'], drCust['ContactTitle'],
    drCust.RowState]);

  // Edit A Row
  drCust := dtCust.Rows[0];
  drCust['ContactName'] := 'Mickey Mouse';

  Console.WriteLine('Row Edited --- ');
  Console.WriteLine('     {0} : {1} : {2} : {3} : {4}', [drCust['CustomerID'],
    drCust['CompanyName'], drCust['ContactName'], drCust['ContactTitle'],
    drCust.RowState]);

  // Delete a row
  dtCust.Rows[0].Delete;
  drCust := dtCust.Rows[0];
  Console.WriteLine('Row Deleted  --- ');
  if drCust.RowState <>  DataRowState.Deleted then
    Console.WriteLine('     {0} : {1} : {2} : {3} : {4}', [drCust['CustomerID'],
      drCust['CompanyName'], drCust['ContactName'], drCust['ContactTitle'],
      drCust.RowState])
  else
    Console.WriteLine('Data Row not accessible due to deletion');

  // Accept Changes
  drCust.AcceptChanges;
  drCust := dtCust.Rows[0];
  Console.WriteLine('Row Changed Accepted  --- ');
  Console.WriteLine('     {0} : {1} : {2} : {3} : {4}', [drCust['CustomerID'],
    drCust['CompanyName'], drCust['ContactName'], drCust['ContactTitle'],
    drCust.RowState]);

  Console.ReadLine;


end.
