unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Data.SqlClient, System.Globalization;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    SqlConnection1: System.Data.SqlClient.SqlConnection;
    sqlSelectCommand1: System.Data.SqlClient.SqlCommand;
    sqlInsertCommand1: System.Data.SqlClient.SqlCommand;
    sqlUpdateCommand1: System.Data.SqlClient.SqlCommand;
    sqlDeleteCommand1: System.Data.SqlClient.SqlCommand;
    SqlDataAdapter1: System.Data.SqlClient.SqlDataAdapter;
    DataSet1: System.Data.DataSet;
    SqlCommand1: System.Data.SqlClient.SqlCommand;
    dgrdCustomers: System.Windows.Forms.DataGrid;
    dgrdOrders: System.Windows.Forms.DataGrid;
    lblFilter: System.Windows.Forms.Label;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
    procedure Currency_PositionChanged(sender: System.Object;
      e: System.EventArgs);
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.SqlConnection1 := System.Data.SqlClient.SqlConnection.Create;
  Self.sqlSelectCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.sqlInsertCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.sqlUpdateCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.sqlDeleteCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.SqlDataAdapter1 := System.Data.SqlClient.SqlDataAdapter.Create;
  Self.DataSet1 := System.Data.DataSet.Create;
  Self.SqlCommand1 := System.Data.SqlClient.SqlCommand.Create;
  Self.dgrdCustomers := System.Windows.Forms.DataGrid.Create;
  Self.dgrdOrders := System.Windows.Forms.DataGrid.Create;
  Self.lblFilter := System.Windows.Forms.Label.Create;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.dgrdCustomers)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.dgrdOrders)).BeginInit;
  Self.SuspendLayout;
  // 
  // SqlDataAdapter1
  // 
  Self.SqlDataAdapter1.DeleteCommand := Self.sqlDeleteCommand1;
  Self.SqlDataAdapter1.InsertCommand := Self.sqlInsertCommand1;
  Self.SqlDataAdapter1.SelectCommand := Self.sqlSelectCommand1;
  Self.SqlDataAdapter1.UpdateCommand := Self.sqlUpdateCommand1;
  // 
  // DataSet1
  // 
  Self.DataSet1.DataSetName := 'NewDataSet';
  Self.DataSet1.Locale := System.Globalization.CultureInfo.Create('en-US');
  // 
  // dgrdCustomers
  // 
  Self.dgrdCustomers.DataMember := '';
  Self.dgrdCustomers.HeaderForeColor := System.Drawing.SystemColors.ControlText;
  Self.dgrdCustomers.Location := System.Drawing.Point.Create(8, 8);
  Self.dgrdCustomers.Name := 'dgrdCustomers';
  Self.dgrdCustomers.Size := System.Drawing.Size.Create(416, 160);
  Self.dgrdCustomers.TabIndex := 0;
  // 
  // dgrdOrders
  // 
  Self.dgrdOrders.DataMember := '';
  Self.dgrdOrders.HeaderForeColor := System.Drawing.SystemColors.ControlText;
  Self.dgrdOrders.Location := System.Drawing.Point.Create(8, 208);
  Self.dgrdOrders.Name := 'dgrdOrders';
  Self.dgrdOrders.Size := System.Drawing.Size.Create(416, 184);
  Self.dgrdOrders.TabIndex := 1;
  // 
  // lblFilter
  // 
  Self.lblFilter.Location := System.Drawing.Point.Create(16, 400);
  Self.lblFilter.Name := 'lblFilter';
  Self.lblFilter.Size := System.Drawing.Size.Create(384, 23);
  Self.lblFilter.TabIndex := 2;
  Self.lblFilter.Text := 'Filter = ';
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(440, 446);
  Self.Controls.Add(Self.lblFilter);
  Self.Controls.Add(Self.dgrdOrders);
  Self.Controls.Add(Self.dgrdCustomers);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.dgrdCustomers)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.dgrdOrders)).EndInit;
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel = 'SELECT * FROM Customers; select * from Orders';

constructor TWinForm.Create;
begin
  inherited Create;
  InitializeComponent;
  SqlConnection1.ConnectionString := c_cnstr;
  SqlCommand1.Connection := SqlConnection1;
  SqlCommand1.CommandText := c_sel;
  SqlConnection1.Open;
  try
    SqlDataAdapter1.SelectCommand := SqlCommand1;

    SqlDataAdapter1.TableMappings.Add('Table', 'Customers');
    SqlDataAdapter1.TableMappings.Add('Table1', 'Orders');

    SqlDataAdapter1.Fill(DataSet1);
    dgrdCustomers.DataSource := DataSet1.Tables['Customers'].DefaultView;
    dgrdOrders.DataSource := DataSet1.Tables['Orders'].DefaultView;
    Include(BindingContext[dgrdCustomers.DataSource].PositionChanged,
      Currency_PositionChanged);
  finally
    SqlConnection1.Close;
  end;
end;

procedure TWinForm.Currency_PositionChanged(sender: TObject;
  e: System.EventArgs);
var
  MastRow: DataRowView;
begin
  MastRow := BindingContext[dgrdCustomers.DataSource].Current as
    DataRowView;
  lblFilter.Text := System.String.Format('CustomerID = ''{0}''',
    [MastRow['CustomerID'].ToString]);
  DataSet1.Tables['Orders'].DefaultView.RowFilter := lblFilter.Text;
end;

end.
