program SqllCmdDemo;

{$APPTYPE CONSOLE}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Data.dll'}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.dll'}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.XML.dll'}

uses
  SysUtils,
  System.Data,
  System.Data.SqlClient,
  System.IO,
  System.Collections;

var
  sqlCn: SqlConnection;
  sqlDA: SqlDataAdapter;
  dsNorthWind: DataSet;
  tblProduct: DataTable;
  dr: DataRow;
const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel_cst = 'SELECT * FROM Products';

function GetCommand(aFileName: String): String;
var
  sr: StreamReader;
begin
  if System.IO.File.Exists(aFileName) then
  begin
    sr := StreamReader.Create(System.IO.File.OpenRead(aFileName));
    try
      Result := sr.ReadToEnd;
    finally
      sr.Close;
    end;
  end;
end;

procedure SubmitAddedRow(aRow: DataRow);
var
  sqlCmd: SqlCommand;
begin
  // Create the Command
  sqlCmd := SqlCommand.Create(GetCommand('c_ins.sql'), sqlCn);
  sqlCmd.Parameters.Add('@ProductName', SqlDbType.NVarChar, 40);
  sqlCmd.Parameters.Add('@SupplierID', SqlDbType.Int);
  SqlCmd.Parameters.Add('@CategoryID', SqlDbType.Int);
  SqlCmd.Parameters.Add('@QuantityPerUnit', SqlDbType.NVarChar, 20);
  SqlCmd.Parameters.Add('@UnitPrice', SqlDbType.Money);
  SqlCmd.Parameters.Add('@UnitsInStock', SqlDbType.SmallInt);
  SqlCmd.Parameters.Add('@UnitsOnOrder', SqlDbType.SmallInt);
  SqlCmd.Parameters.Add('@ReorderLevel', SqlDbType.SmallInt);
  SqlCmd.Parameters.Add('@Discontinued', SqlDbType.Bit);

  // Add Values to the Command

  sqlCmd.Parameters['@ProductName'].Value := aRow['ProductName'];
  sqlCmd.Parameters['@SupplierID'].Value := aRow['SupplierID'];
  sqlCmd.Parameters['@CategoryID'].Value := aRow['CategoryID'];
  sqlCmd.Parameters['@QuantityPerUnit'].Value := aRow['QuantityPerUnit'];
  sqlCmd.Parameters['@UnitPrice'].Value := aRow['UnitPrice'];
  sqlCmd.Parameters['@UnitsInStock'].Value := aRow['UnitsInStock'];
  sqlCmd.Parameters['@UnitsOnOrder'].Value := aRow['UnitsOnOrder'];
  sqlCmd.Parameters['@ReorderLevel'].Value := aRow['ReorderLevel'];
  sqlCmd.Parameters['@Discontinued'].Value := aRow['Discontinued'];

  sqlCmd.ExecuteNonQuery;
end;

procedure SubmitModifiedRow(aRow: DataRow);
var
  sqlCmd: SqlCommand;
begin
  sqlCmd := sqlCommand.Create(GetCommand('c_upd.sql'), sqlCn);
  sqlCmd.Parameters.Add('@C_ProductName', SqlDbType.NVarChar, 40);
  sqlCmd.Parameters.Add('@C_SupplierID', SqlDbType.Int);
  sqlCmd.Parameters.Add('@C_CategoryID', SqlDbType.Int);
  sqlCmd.Parameters.Add('@C_QuantityPerUnit', SqlDbType.NVarChar, 20);
  sqlCmd.Parameters.Add('@C_UnitPrice', SqlDbType.Money);
  sqlCmd.Parameters.Add('@C_UnitsInStock', SqlDbType.SmallInt);
  sqlCmd.Parameters.Add('@C_UnitsOnOrder', SqlDbType.SmallInt);
  sqlCmd.Parameters.Add('@C_ReorderLevel', SqlDbType.SmallInt);
  sqlCmd.Parameters.Add('@C_Discontinued', SqlDbType.Bit);

  sqlCmd.Parameters.Add('@O_ProductID', SqlDbType.Int);
  sqlCmd.Parameters.Add('@O_ProductName', SqlDbType.NVarChar, 40);
  sqlCmd.Parameters.Add('@O_SupplierID', SqlDbType.Int);
  sqlCmd.Parameters.Add('@O_CategoryID', SqlDbType.Int);
  sqlCmd.Parameters.Add('@O_QuantityPerUnit', SqlDbType.NVarChar, 20);
  sqlCmd.Parameters.Add('@O_UnitPrice', SqlDbType.Money);
  sqlCmd.Parameters.Add('@O_UnitsInStock', SqlDbType.SmallInt);
  sqlCmd.Parameters.Add('@O_UnitsOnOrder', SqlDbType.SmallInt);
  sqlCmd.Parameters.Add('@O_ReorderLevel', SqlDbType.SmallInt);
  sqlCmd.Parameters.Add('@O_Discontinued', SqlDbType.Bit);

  // Add Values to the Command

  sqlCmd.Parameters['@C_ProductName'].Value := aRow['ProductName'];
  sqlCmd.Parameters['@C_SupplierID'].Value := aRow['SupplierID'];
  sqlCmd.Parameters['@C_CategoryID'].Value := aRow['CategoryID'];
  sqlCmd.Parameters['@C_QuantityPerUnit'].Value := aRow['QuantityPerUnit'];
  sqlCmd.Parameters['@C_UnitPrice'].Value := aRow['UnitPrice'];
  sqlCmd.Parameters['@C_UnitsInStock'].Value := aRow['UnitsInStock'];
  sqlCmd.Parameters['@C_UnitsOnOrder'].Value := aRow['UnitsOnOrder'];
  sqlCmd.Parameters['@C_ReorderLevel'].Value := aRow['ReorderLevel'];
  sqlCmd.Parameters['@C_Discontinued'].Value := aRow['Discontinued'];

  sqlCmd.Parameters['@O_ProductID'].Value :=
    aRow['ProductID', DataRowVersion.Original];
  sqlCmd.Parameters['@O_ProductName'].Value :=
    aRow['ProductName', DataRowVersion.Original];
  sqlCmd.Parameters['@O_SupplierID'].Value :=
    aRow['SupplierID', DataRowVersion.Original];
  sqlCmd.Parameters['@O_CategoryID'].Value :=
    aRow['CategoryID', DataRowVersion.Original];
  sqlCmd.Parameters['@O_QuantityPerUnit'].Value :=
    aRow['QuantityPerUnit', DataRowVersion.Original];
  sqlCmd.Parameters['@O_UnitPrice'].Value :=
    aRow['UnitPrice', DataRowVersion.Original];
  sqlCmd.Parameters['@O_UnitsInStock'].Value :=
    aRow['UnitsInStock', DataRowVersion.Original];
  sqlCmd.Parameters['@O_UnitsOnOrder'].Value :=
    aRow['UnitsOnOrder', DataRowVersion.Original];
  sqlCmd.Parameters['@O_ReorderLevel'].Value :=
    aRow['ReorderLevel', DataRowVersion.Original];
  sqlCmd.Parameters['@O_Discontinued'].Value :=
    aRow['Discontinued', DataRowVersion.Original];

  sqlCmd.ExecuteNonQuery;
end;

procedure SubmitDeletedRow(aRow: DataRow);
var
  sqlCmd: SqlCommand;
begin
  // Create the Command
  sqlCmd := SqlCommand.Create(GetCommand('c_del.sql'), sqlCn);
  sqlCmd.Parameters.Add('@ProductID', SqlDbType.Int);
  sqlCmd.Parameters.Add('@ProductName', SqlDbType.NVarChar, 40);
  sqlCmd.Parameters.Add('@SupplierID', SqlDbType.Int);
  SqlCmd.Parameters.Add('@CategoryID', SqlDbType.Int);
  SqlCmd.Parameters.Add('@QuantityPerUnit', SqlDbType.NVarChar, 20);
  SqlCmd.Parameters.Add('@UnitPrice', SqlDbType.Money);
  SqlCmd.Parameters.Add('@UnitsInStock', SqlDbType.SmallInt);
  SqlCmd.Parameters.Add('@UnitsOnOrder', SqlDbType.SmallInt);
  SqlCmd.Parameters.Add('@ReorderLevel', SqlDbType.SmallInt);
  SqlCmd.Parameters.Add('@Discontinued', SqlDbType.Bit);

  // Add Values to the Command

  sqlCmd.Parameters['@ProductID'].Value :=
    aRow['ProductID', DataRowVersion.Original];
  sqlCmd.Parameters['@ProductName'].Value :=
    aRow['ProductName', DataRowVersion.Original];
  sqlCmd.Parameters['@SupplierID'].Value :=
    aRow['SupplierID', DataRowVersion.Original];
  sqlCmd.Parameters['@CategoryID'].Value :=
    aRow['CategoryID', DataRowVersion.Original];
  sqlCmd.Parameters['@QuantityPerUnit'].Value :=
    aRow['QuantityPerUnit', DataRowVersion.Original];
  sqlCmd.Parameters['@UnitPrice'].Value :=
    aRow['UnitPrice', DataRowVersion.Original];
  sqlCmd.Parameters['@UnitsInStock'].Value :=
    aRow['UnitsInStock', DataRowVersion.Original];
  sqlCmd.Parameters['@UnitsOnOrder'].Value :=
    aRow['UnitsOnOrder', DataRowVersion.Original];
  sqlCmd.Parameters['@ReorderLevel'].Value :=
    aRow['ReorderLevel', DataRowVersion.Original];
  sqlCmd.Parameters['@Discontinued'].Value :=
    aRow['Discontinued', DataRowVersion.Original];

  sqlCmd.ExecuteNonQuery;
end;

procedure SubmitUpdates;
var
  rowEnum: IEnumerator;
  CurrRow: DataRow;
begin
  sqlCn.Open;
  try
    rowEnum := tblProduct.Rows.GetEnumerator;
    while rowEnum.MoveNext do
    begin
      CurrRow := (rowEnum.Current as DataRow);
      case CurrRow.RowState of
        DataRowState.Modified:  SubmitModifiedRow(CurrRow);
        DataRowState.Added:     SubmitAddedRow(CurrRow);
        DataRowState.Deleted:   SubmitDeletedRow(CurrRow);
      end; // case
    end;
  finally
    sqlCn.Close;
  end;
end;

begin
  sqlCn := SqlConnection.Create(c_cnstr);
  sqlDA := SqlDataAdapter.Create(c_sel_cst, sqlCn);
  dsNorthWind := DataSet.Create('NorthWind');
  sqlDA.TableMappings.Add('Table', 'Products');
  sqlDA.Fill(dsNorthWind);
  tblProduct := dsNorthWind.Tables['Products'];

  // Insert a Row
  dr := tblProduct.NewRow;
  dr['ProductName'] := 'Second Burn Hot Sauce';
  dr['SupplierID']  := System.Object(2);
  dr['CategoryID']  := System.Object(2);
  dr['QuantityPerUnit'] := '48 - 6 oz jars';
  dr['UnitPrice'] := System.Object(23.00);
  dr['UnitsInStock'] := System.Object(50);
  dr['UnitsOnOrder'] := System.Object(0);
  dr['ReorderLevel'] := System.Object(15);
  dr['Discontinued'] := System.Object(0);
  tblProduct.Rows.Add(dr);

  //Modify a Row
  dr := tblProduct.Rows[5];
  dr['UnitsInStock'] := System.Object(10);

  tblProduct.Rows[0].Delete;

  SubmitUpdates;
end.
