program SqlDAProc;

{$APPTYPE CONSOLE}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Data.dll'}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.dll'}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.XML.dll'}

uses
  System.Data,
  System.Data.SqlClient,
  System.IO,
  System.Collections;

var
  sqlCn: SqlConnection;
  sqlDA: SqlDataAdapter;
  dsNorthWind: DataSet;
  tblProduct: DataTable;
  dr: DataRow;
const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel_cst = 'SELECT * FROM Products';

function GetDataAdapterInsertCommand: SqlCommand;
var
  sqlCmd: SqlCommand;
begin
  sqlCmd := SqlCommand.Create('InsertProduct', sqlCn);
  sqlCmd.CommandType := CommandType.StoredProcedure;

  sqlCmd.Parameters.Add('@ProductID',    SqlDbType.Int, 0,
    'ProductID');
  sqlCmd.Parameters.Add('@ProductName',  SqlDbType.NVarChar, 40,
    'ProductName');
  sqlCmd.Parameters.Add('@SupplierID',   SqlDbType.Int, 0,
    'SupplierID');
  sqlCmd.Parameters.Add('@CategoryID',      SqlDbType.Int, 0,
    'CategoryID');
  sqlCmd.Parameters.Add('@QuantityPerUnit', SqlDbType.NVarChar, 20,
    'QuantityPerUnit');
  sqlCmd.Parameters.Add('@UnitPrice',       SqlDbType.Money, 0,
    'UnitPrice');
  sqlCmd.Parameters.Add('@UnitsInStock',    SqlDbType.SmallInt, 0,
    'UnitsInStock');
  sqlCmd.Parameters.Add('@UnitsOnOrder',    SqlDbType.SmallInt, 0,
    'UnitsOnOrder');
  sqlCmd.Parameters.Add('@ReorderLevel',    SqlDbType.SmallInt, 0,
    'ReorderLevel');
  sqlCmd.Parameters.Add('@Discontinued',    SqlDbType.Bit, 0,
    'Discontinued');

  sqlCmd.Parameters['@ProductID'].Direction :=
    ParameterDirection.Output;
  sqlCmd.Parameters['@ProductID'].SourceVersion :=
    DataRowVersion.Original;

  Result := sqlCmd;
end;

function GetDataAdapterUpdateCommand: SqlCommand;
var
  sqlCmd: SqlCommand;
begin
  sqlCmd := SqlCommand.Create('UpdateProduct', sqlCn);
  sqlCmd.CommandType := CommandType.StoredProcedure;

  sqlCmd.Parameters.Add('@ProductID', SqlDbType.Int, 0,
    'ProductID');
  sqlCmd.Parameters.Add('@ProductName', SqlDbType.NVarChar, 40,
    'ProductName');
  sqlCmd.Parameters.Add('@SupplierID', SqlDbType.Int, 0,
    'SupplierID');
  sqlCmd.Parameters.Add('@CategoryID', SqlDbType.Int, 0,
    'CategoryID');
  sqlCmd.Parameters.Add('@QuantityPerUnit', SqlDbType.NVarChar, 20,
    'QuantityPerUnit');
  sqlCmd.Parameters.Add('@UnitPrice', SqlDbType.Money, 0,
    'UnitPrice');
  sqlCmd.Parameters.Add('@UnitsInStock', SqlDbType.SmallInt, 0,
    'UnitsInStock');
  sqlCmd.Parameters.Add('@UnitsOnOrder', SqlDbType.SmallInt, 0,
    'UnitsOnOrder');
  sqlCmd.Parameters.Add('@ReorderLevel', SqlDbType.SmallInt, 0,
    'ReorderLevel');
  sqlCmd.Parameters.Add('@Discontinued', SqlDbType.Bit, 0,
    'Discontinued');

  sqlCmd.Parameters['@ProductID'].SourceVersion :=
    DataRowVersion.Original;

  Result := sqlCmd;
end;

function GetDataAdapterDeleteCommand: SqlCommand;
var
  sqlCmd: SqlCommand;
begin
  sqlCmd := SqlCommand.Create('DeleteProduct', sqlCn);
  sqlCmd.CommandType := CommandType.StoredProcedure;

  sqlCmd.Parameters.Add('@ProductID', SqlDbType.Int, 0, 'ProductID');

  sqlCmd.Parameters['@ProductID'].SourceVersion :=
     DataRowVersion.Original;

  Result := sqlCmd;
end;

begin
  sqlCn := SqlConnection.Create(c_cnstr);
  sqlDA := SqlDataAdapter.Create('SelectProduct', sqlCn);
  sqlDA.SelectCommand.CommandType := CommandType.StoredProcedure;
  sqlDA.InsertCommand := GetDataAdapterInsertCommand;
  sqlDA.UpdateCommand := GetDataAdapterUpdateCommand;
  sqlDA.DeleteCommand := GetDataAdapterDeleteCommand;

  dsNorthWind := DataSet.Create('NorthWind');
  sqlDA.Fill(dsNorthWind, 'Products');
  sqlDA.TableMappings.Add('Table', 'Products');
  tblProduct := dsNorthWind.Tables['Products'];

  // Insert a Row
  dr := tblProduct.NewRow;
  dr['ProductName'] := 'Second Burn Hot Sauce';
  dr['SupplierID']  := System.Object(2);
  dr['CategoryID']  := System.Object(2);
  dr['QuantityPerUnit'] := '48 - 6 oz jars';
  dr['UnitPrice'] := System.Object(23.00);
  dr['UnitsInStock'] := System.Object(50);
  dr['UnitsOnOrder'] := System.Object(0);
  dr['ReorderLevel'] := System.Object(15);
  dr['Discontinued'] := System.Object(0);
  tblProduct.Rows.Add(dr);

  //Modify a Row
  dr := tblProduct.Rows[5];
  dr['UnitsInStock'] := System.Object(10);

  // Delete a row
  dr := tblProduct.Rows[tblProduct.Rows.Count-1];
  dr.Delete;

  sqlDA.Update(tblProduct);
end.
