CREATE PROCEDURE InsertProduct
  @ProductID		int output,
  @ProductName		nvarchar(40),
  @SupplierID		int,
  @CategoryID		int,
  @QuantityPerUnit	nvarchar(20),
  @UnitPrice		money,
  @UnitsInStock		smallint,
  @UnitsOnOrder		smallint,
  @ReorderLevel		smallint,
  @Discontinued		bit
AS
  SET NOCOUNT ON
  INSERT INTO Products (
    ProductName,
    SupplierID,
    CategoryID,
    QuantityPerUnit,
    UnitPrice,
    UnitsInStock,
    UnitsOnOrder,
    ReorderLevel,
    Discontinued)
  VALUES (
    @ProductName,
    @SupplierID,
    @CategoryID,
    @QuantityPerUnit,
    @UnitPrice,
    @UnitsInStock,
    @UnitsOnOrder,
    @ReorderLevel,
    @Discontinued)

  IF @@rowcount = 0
    return 0

  SET @ProductID = Scope_Identity()

  SELECT @ProductID ProductID

  return

GO

