CREATE PROCEDURE UpdateProduct
  @ProductID		    int,
  @ProductName	    nvarchar(40),
  @SupplierID		    int,
  @CategoryID		    int,
  @QuantityPerUnit	nvarchar(20),
  @UnitPrice		    money,
  @UnitsInStock		  smallint,
  @UnitsOnOrder		  smallint,
  @ReorderLevel		  smallint,
  @Discontinued		  bit
AS
  SET NOCOUNT ON
  UPDATE Products
  SET
    ProductName     = @ProductName,
    SupplierID      = @SupplierID,
    CategoryID      = @CategoryID,
    QuantityPerUnit = @QuantityPerUnit,
    UnitPrice       = @UnitPrice,
    UnitsInStock    = @UnitsInStock,
    UnitsOnOrder    = @UnitsOnOrder,
    ReorderLevel    = @ReorderLevel,
    Discontinued    = @Discontinued
  WHERE
    ProductID       = @ProductID

  IF @@rowcount = 0
    return 0

  return

GO
