program ConcurrencyDemo;

{$APPTYPE CONSOLE}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Data.dll'}

uses
  SysUtils,
  System.Data,
  System.Data.SqlClient,
  System.IO;
var
  sqlCn: SqlConnection;
  sqlDA: SqlDataAdapter;
  dsCompany: DataSet;
  tblcontact: DataTable;
  dr: DataRow;

const
  c_cnstr = 'server=XWING;database=ddn_company;Trusted_Connection=Yes';
  c_sel_cst = 'SELECT * FROM contact';

 // handler for RowUpdated event
procedure OnRowUpdated(sender: System.Object; e: SqlRowUpdatedEventArgs);
begin
  Console.WriteLine('Command: '+e.Command.ToString);
  Console.WriteLine('CommandType: '+Enum(e.StatementType).ToString);
  Console.WriteLine('RecordsAffected: '+e.RecordsAffected.ToString);
  Console.WriteLine('Status: '+Enum(e.Status).ToString);

  if e.Status = UpdateStatus.ErrorsOccurred then
  begin
    Console.WriteLine('Error Type: '+e.Errors.GetType.ToString);
    Console.WriteLine('Error Message: '+e.Errors.Message);
    Console.WriteLine('On contact_id: '+E.Row['contact_id'].ToString);
  end;
  Console.WriteLine('--');
end;


function GetCommand(aFileName: String): String;
var
  sr: StreamReader;
begin
  if System.IO.File.Exists(aFileName) then
  begin
    sr := StreamReader.Create(System.IO.File.OpenRead(aFileName));
    try
      Result := sr.ReadToEnd;
    finally
      sr.Close;
    end;
  end;
end;

function GetDAUpdateCommand: SqlCommand;
var
  sqlCmd: SqlCommand;
begin
  sqlCmd := sqlCommand.Create(GetCommand('c_upd.sql'), sqlCn);

  sqlCmd.Parameters.Add('@first_name',  SqlDbType.NVarChar, 40,
    'first_name');
  sqlCmd.Parameters.Add('@last_name',   SqlDbType.NVarChar, 40,
    'last_name');
  sqlCmd.Parameters.Add('@mi',          SqlDbType.NVarChar, 1,
    'mi');
  sqlCmd.Parameters.Add('@department',  SqlDbType.NVarChar, 40,
    'department');
  sqlCmd.Parameters.Add('@position',    SqlDbType.NVarChar, 40,
    'position');
  sqlCmd.Parameters.Add('@work_phone',  SqlDbType.NVarChar, 20,
    'work_phone');
  sqlCmd.Parameters.Add('@home_phone',  SqlDbType.NVarChar, 20,
    'home_phone');
  sqlCmd.Parameters.Add('@fax',         SqlDbType.NVarChar, 20,
    'fax');
  sqlCmd.Parameters.Add('@cell_phone',  SqlDbType.NVarChar, 20,
    'cell_phone');
  sqlCmd.Parameters.Add('@email',       SqlDbType.NVarChar, 50,
    'email');
  sqlCmd.Parameters.Add('@contact_id',  SqlDbType.Int, 0,
    'contact_id');
  sqlCmd.Parameters.Add('@row_version', SqlDbType.TimeStamp, 0,
    'row_version');
  sqlCmd.Parameters['@row_version'].SourceVersion :=
    DataRowVersion.Original;

  Result := sqlCmd;
end;

begin
  sqlCn := SqlConnection.Create(c_cnstr);
  sqlDA := SqlDataAdapter.Create(c_sel_cst, sqlCn);
  dsCompany := DataSet.Create('ddn_company');

  sqlDA.TableMappings.Add('Table', 'contact');
  sqlDA.Fill(dsCompany);
  
  sqlDA.ContinueUpdateOnError := True;
  Include(sqlDA.RowUpdated, OnRowUpdated);
  sqlDA.UpdateCommand := GetDAUpdateCommand;

  tblcontact := dsCompany.Tables['contact'];
  //Modify two rows
  dr := tblcontact.Rows[0];
  dr['cell_phone'] := '111-111-1122';
  dr := tblcontact.Rows[1];
  dr['cell_phone'] := '555-555-5556';

  Console.WriteLine('Press enter when you are ready to update.');
  Console.ReadLine;

  sqlDA.Update(tblcontact);
end.
