program RefreshDemo2;

{$APPTYPE CONSOLE}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Data.dll'}

uses
  System.Data,
  System.Data.SqlClient,
  System.IO;

var
  sqlCn: SqlConnection;
  sqlDA: SqlDataAdapter;
  dsCompany: DataSet;
  tblcontact: DataTable;
  dr: DataRow;

type
  TByteArray = array of byte;

const
  c_cnstr = 'server=XWING;database=ddn_company;Trusted_Connection=Yes';
  c_sel_cst = 'SELECT * FROM contact';

// handler for RowUpdated event
procedure OnRowUpdated(sender: System.Object; e: SqlRowUpdatedEventArgs);
var
  sqlCmdID: SqlCommand;
begin
  if (e.Status = UpdateStatus.Continue) and
     (e.StatementType = StatementType.Insert) then
  begin
    sqlCmdID := SqlCommand.Create('SELECT @@IDENTITY', sqlCn);
    e.Row['contact_id'] := sqlCmdID.ExecuteScalar;
    e.Row.AcceptChanges;
  end;
end;

function GetCommand(aFileName: String): String;
var
  sr: StreamReader;
begin
  if System.IO.File.Exists(aFileName) then
  begin
    sr := StreamReader.Create(System.IO.File.OpenRead(aFileName));
    try
      Result := sr.ReadToEnd;
    finally
      sr.Close;
    end;
  end;
end;

function GetDAInsertCommand: SqlCommand;
var
  sqlCmd: SqlCommand;
begin
  sqlCmd := sqlCommand.Create(GetCommand('c_ins.sql'), sqlCn);

  sqlCmd.Parameters.Add('@first_name',  SqlDbType.NVarChar, 40,
    'first_name');
  sqlCmd.Parameters.Add('@last_name',   SqlDbType.NVarChar, 40,
    'last_name');
  sqlCmd.Parameters.Add('@mi',          SqlDbType.NVarChar, 1,
    'mi');
  sqlCmd.Parameters.Add('@department',  SqlDbType.NVarChar, 40,
    'department');
  sqlCmd.Parameters.Add('@position',    SqlDbType.NVarChar, 40,
    'position');
  sqlCmd.Parameters.Add('@work_phone',  SqlDbType.NVarChar, 20,
    'work_phone');
  sqlCmd.Parameters.Add('@home_phone',  SqlDbType.NVarChar, 20,
    'home_phone');
  sqlCmd.Parameters.Add('@fax',         SqlDbType.NVarChar, 20,
    'fax');
  sqlCmd.Parameters.Add('@cell_phone',  SqlDbType.NVarChar, 20,
    'cell_phone');
  sqlCmd.Parameters.Add('@email',       SqlDbType.NVarChar, 50,
    'email');
  sqlCmd.Parameters.Add('@company_id',  SqlDbType.Int, 0,
    'company_id');
  sqlCmd.Parameters.Add('@contact_id',  SqlDbType.Int, 0,
    'contact_id');
  sqlCmd.Parameters.Add('@row_version', SqlDbType.TimeStamp, 0,
    'row_version');

  Result := sqlCmd;
end;

procedure printRow(aDR: DataRow);

  procedure PrintByteArray(aBA: array of Byte);
  var
    i: integer;
    b: Byte;
  begin
    for i := Low(aBA) to High(aBA) do
    begin
      b := aBA[i];
      Console.Write(b.ToString);
    end;
    Console.WriteLine;
  end;

begin
  Console.WriteLine(aDR['contact_id']);
  Console.WriteLine(aDR['first_name']);
  Console.WriteLine(aDR['last_name']);
  Console.WriteLine(aDR['mi']);
  Console.WriteLine(aDR['department']);
  Console.WriteLine(aDR['position']);
  Console.WriteLine(aDR['work_phone']);
  Console.WriteLine(aDR['home_phone']);
  Console.WriteLine(aDR['fax']);
  Console.WriteLine(aDR['cell_phone']);
  Console.WriteLine(aDR['email']);
  PrintByteArray(TByteArray(aDR['row_version']));
  Console.WriteLine;
end;

begin
  sqlCn := SqlConnection.Create(c_cnstr);
  sqlDA := SqlDataAdapter.Create(c_sel_cst, sqlCn);
  dsCompany := DataSet.Create('ddn_company');
  sqlDA.TableMappings.Add('Table', 'contact');
  sqlDA.Fill(dsCompany);
  sqlDA.InsertCommand := GetDAInsertCommand;
  // Add Event Handler
  Include(sqlDA.RowUpdated, OnRowUpdated);
  tblcontact := dsCompany.Tables['contact'];

  // Insert a row
  dr := tblcontact.NewRow;
  dr['first_name'] := 'Xavier';
  dr['last_name']  := 'Pacheco';
  dr['mi']         := 'G';
  dr['department'] := 'Dept 1';
  dr['position']   := 'Worker bee';
  dr['work_phone'] := '123-123-1234';
  dr['home_phone'] := '234-234-2344';
  dr['fax']        := '456-456-4566';
  dr['cell_phone'] := '345-345-3654';
  dr['email']      := 'xavier@somewhere.com';
  dr['company_id'] := System.Object(1);

  tblcontact.Rows.Add(dr);
  PrintRow(tblcontact.Rows[tblcontact.Rows.Count-1]);
  Console.WriteLine('--After Insertion--');
  sqlDA.Update(tblcontact);
  PrintRow(tblcontact.Rows[tblcontact.Rows.Count-1]);
  Console.WriteLine('press any key to quit');
  Console.ReadLine;
end.
