unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.IO;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    { Public Declarations }
  end;

  TChangeCaseFilter = class(MemoryStream)
  private
    mStream: Stream;
  public
    constructor Create(aStream: Stream); override;
    procedure Write(bfr: array of byte; offset: integer;
      count: Integer); override;
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  Response.Filter := TChangeCaseFilter.Create(Response.Filter);
  Response.Write('Hello Delphi for .NET');
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  InitializeComponent;
  inherited OnInit(e);
end;


{ TChangeCaseFilter }

constructor TChangeCaseFilter.Create(aStream: Stream);
begin
  inherited Create;
  mStream := aStream;
end;

procedure TChangeCaseFilter.Write(bfr: array of byte; offset,
  count: Integer);
var
  data: array of byte;
  i: integer;
  diff: Integer;
begin
  inherited;
  Borland.Delphi.System.SetLength(data, count);
  Buffer.BlockCopy(bfr, offset, data, 0, count);

  diff := ord('a')-ord('A');

  for i := 0 to count-1 do
  begin
    if (data[i] >= ord('a')) and (data[i] <= ord('z')) then
      data[i] := data[i] - diff
    else if (data[i] >= ord('A')) and (data[i] <= ord('Z')) then
      data[i] := data[i] + diff;
  end;

  mStream.Write(data, 0, count);

end;

end.

