
unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure btnAddCookie_Click(sender: System.Object; e: System.EventArgs);
    procedure btnDeleteCookie_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    Label1: System.Web.UI.WebControls.Label;
    Label2: System.Web.UI.WebControls.Label;
    TextBox1: System.Web.UI.WebControls.TextBox;
    btnAddCookie: System.Web.UI.WebControls.Button;
    btnDeleteCookie: System.Web.UI.WebControls.Button;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    { Public Declarations }
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.btnAddCookie.Click, Self.btnAddCookie_Click);
  Include(Self.btnDeleteCookie.Click, Self.btnDeleteCookie_Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  if IsPostback and (TextBox1.Text <> '') then
  begin
    Label1.Visible := True;
    Label1.Text := System.String.Format('Hello {0}', TextBox1.Text);
  end
  else begin // is not a postback - initial visit
    if Request.Cookies['Name'] = nil then
      Label1.Visible := False
    else
      Label1.Text := System.String.Format('Hello {0}',
        Request.Cookies['Name'].Value);
  end;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

procedure TWebForm1.btnDeleteCookie_Click(sender: System.Object;
  e: System.EventArgs);
var
  emptyCookie: HttpCookie;
begin
  EmptyCookie := Request.Cookies['Name'];
  EmptyCookie.Values.Clear;
  Response.Cookies.Add(emptyCookie);
  Label1.Visible := False;
end;

procedure TWebForm1.btnAddCookie_Click(sender: System.Object;
  e: System.EventArgs);
var
  hc: HttpCookie;
begin
  hc := HttpCookie.Create('Name', TextBox1.Text);
  hc.Expires := DateTime.Now.AddMonths(1);
  Response.Cookies.Add(hc);
end;

end.

