
unit DwnLdForm;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.IO, System.Web.Mail;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
{$REGION 'Controls'}
    Label1: System.Web.UI.WebControls.Label;
    Label4: System.Web.UI.WebControls.Label;
    Label5: System.Web.UI.WebControls.Label;
    Label6: System.Web.UI.WebControls.Label;
    Label7: System.Web.UI.WebControls.Label;
    Label8: System.Web.UI.WebControls.Label;
    Label9: System.Web.UI.WebControls.Label;
    Label10: System.Web.UI.WebControls.Label;
    Label11: System.Web.UI.WebControls.Label;
    Label12: System.Web.UI.WebControls.Label;
    Label13: System.Web.UI.WebControls.Label;
    Label14: System.Web.UI.WebControls.Label;
    Label15: System.Web.UI.WebControls.Label;
    Label16: System.Web.UI.WebControls.Label;
    Label17: System.Web.UI.WebControls.Label;
    tbxLastName: System.Web.UI.WebControls.TextBox;
    tbxTitle: System.Web.UI.WebControls.TextBox;
    tbxEmail: System.Web.UI.WebControls.TextBox;
    tbxCompany: System.Web.UI.WebControls.TextBox;
    tbxAddress1: System.Web.UI.WebControls.TextBox;
    tbxAddress2: System.Web.UI.WebControls.TextBox;
    tbxCity: System.Web.UI.WebControls.TextBox;
    tbxPostalCode: System.Web.UI.WebControls.TextBox;
    tbxTelephone: System.Web.UI.WebControls.TextBox;
    tbxFax: System.Web.UI.WebControls.TextBox;
    tbxURL: System.Web.UI.WebControls.TextBox;
    ddlCountry: System.Web.UI.WebControls.DropDownList;
    ddlState: System.Web.UI.WebControls.DropDownList;
    cbxFreeStuff: System.Web.UI.WebControls.CheckBox;
    RequiredFieldValidator1: System.Web.UI.WebControls.RequiredFieldValidator;
    RequiredFieldValidator2: System.Web.UI.WebControls.RequiredFieldValidator;
    RegularExpressionValidator1: System.Web.UI.WebControls.RegularExpressionValidator;
    tbxFirstName: System.Web.UI.WebControls.TextBox;
    RequiredFieldValidator3: System.Web.UI.WebControls.RequiredFieldValidator;
    btnSubmit: System.Web.UI.WebControls.Button;
{$ENDREGION}
    procedure OnInit(e: EventArgs); override;
    procedure SendEmail(aEmail: String);
  private
    { Private Declarations }
    procedure SaveUserInfo;
    procedure PopulateDdlFromFile(aDDL: DropDownList; aFileName: String);
  public
    { Public Declarations }
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  if IsPostBack then
  begin
    SaveUserInfo;
    SendEMail(tbxEmail.Text);
    Response.Redirect('ThankYouForm.aspx');
  end;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  InitializeComponent;
  inherited OnInit(e);
  PopulateDdlFromFile(ddlCountry,
    Request.PhysicalApplicationPath+'countries.txt');
  ddlCountry.Items.FindByText('United States').Selected := True;
  PopulateDdlFromFile(ddlState,
    Request.PhysicalApplicationPath+'states.txt');
end;

procedure TWebForm1.SaveUserInfo;
const
  fname = '.\files\dld_{0}.txt';
var
  fs: FileStream;
  sw: StreamWriter;
begin
  fs := FileStream.Create(Server.MapPath(System.String.Format(fname,
    [System.Guid.NewGuid.ToString])), FileMode.Append,
     FileAccess.Write);
  try
    sw := StreamWriter.Create(fs);
    try
      sw.WriteLine(System.String.Format('{0}={1}', [tbxFirstName.ID,
        tbxFirstName.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxLastName.ID,
        tbxLastName.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxTitle.ID,
        tbxTitle.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxEmail.ID,
        tbxEmail.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxCompany.ID,
        tbxCompany.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxAddress1.ID,
        tbxAddress1.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxAddress2.ID,
        tbxAddress2.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxCity.ID,
        tbxCity.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxPostalCode.ID,
        tbxPostalCode.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxTelephone.ID,
        tbxTelephone.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxFax.ID,
        tbxFax.Text]));
      sw.WriteLine(System.String.Format('{0}={1}', [tbxURL.ID,
        tbxURL.Text]));
      if ddlCountry.SelectedIndex >= 0 then
        sw.WriteLine(System.String.Format('{0}={1}', [ddlCountry.ID,
          ddlCountry.Items[ddlCountry.SelectedIndex]]));
      if ddlState.SelectedIndex >= 0 then
        sw.WriteLine(System.String.Format('{0}={1}', [ddlState.ID,
          ddlState.Items[ddlState.SelectedIndex]]));
      sw.WriteLine(System.String.Format('{0}={1}', [cbxFreeStuff.ID,
        cbxFreeStuff.Checked.ToString]));
    finally
      sw.Close;
    end;
  finally
    fs.Close;
  end;
end;

procedure TWebForm1.PopulateDdlFromFile(aDDL: DropDownList;
aFileName: String);
var
  sr: StreamReader;
  FileLine: array of String;
  NameStr: String;
  ValueStr: String;
begin
  if System.IO.File.Exists(aFileName) then
  begin
    sr := StreamReader.Create(System.IO.File.OpenRead(aFileName));
    try
      while sr.Peek > -1 do
      begin
        FileLine := sr.ReadLine.Split(['=']);
        NameStr   := FileLine[0];
        ValueStr  := FileLine[1];
        aDDL.Items.Add(ListItem.Create(ValueStr, NameStr));
      end;
    finally
      sr.Close;
    end;
  end;
end;

procedure TWebForm1.SendEmail(aEmail: &String);
var
  MailMsg: MailMessage;
  sr: StreamReader;
begin
  MailMsg := MailMessage.Create;
  MailMsg.From    := 'info@xapware.com';
  MailMsg.&To      := aEmail;
  MailMsg.Bcc     := 'sales@somehwere.com';
  MailMsg.Subject := 'Your request to download XYZ Product';
  MailMsg.BodyFormat := MailFormat.HTML;

  sr := StreamReader.Create(System.IO.File.OpenRead(
    Request.PhysicalApplicationPath+'dnloadmail.htm'));
  try
    MailMsg.Body := sr.ReadToEnd;
  finally
    sr.Close;
  end;

  SmtpMail.SmtpServer := 'localhost';
  SmtpMail.Send(MailMsg);
end;

end.

