
unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.IO, System.Drawing.Imaging;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure ImageButton1_Click(sender: System.Object; e: System.Web.UI.ImageClickEventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    Panel1: System.Web.UI.WebControls.Panel;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
    procedure GenerateThumbs;
  public
    { Public Declarations }
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object;
  e: System.EventArgs);
begin
  GenerateThumbs;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

procedure TWebForm1.ImageButton1_Click(sender: System.Object;
  e: System.Web.UI.ImageClickEventArgs);
var
  fName: String;
begin
  with sender as ImageButton do
  begin
    fName := ImageUrl;
    fName := System.IO.Path.GetFileName(fName);
    fName := fName.Remove(0, 3);
    Response.Redirect(fName);
  end;
end;

procedure TWebForm1.GenerateThumbs;
var
  fArray: array of String;
  i: integer;
  bm: Bitmap;
  tni: System.Drawing.Image;
  im: System.Drawing.Image;
  fName: String;
  fs: FileStream;
  ib: ImageButton;
begin
  fArray := Directory.GetFiles(Request.PhysicalApplicationPath, '*.jpg');
  for i := Low(fArray) to High(fArray) do
  begin
    fName := System.IO.Path.GetFileName(fArray[i]);
    fName := 'tn_'+fName;
    fName := Request.PhysicalApplicationPath+'thumbs\'+fName;
    if not System.IO.File.Exists(fName) then
    begin
      im := System.Drawing.Image.FromFile(fArray[i]);
      tni := im.GetThumbNailImage(96, 112, nil, IntPtr.Zero);
      bm := Bitmap.Create(tni);
      fs := FileStream.Create(fName, FileMode.OpenOrCreate,
        FileAccess.Write);
      try
        bm.Save(fs, ImageFormat.Jpeg);
      finally
        fs.Close;
      end;
    end;
    ib := ImageButton.Create;
    ib.ImageUrl := fName;
    ib.Attributes['runat'] := '"server"';
    Include(ib.Click, ImageButton1_Click);
    Panel1.Controls.Add(ib);
  end;
end;

end.

