
unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Data.SqlClient;

type

  TRowMove = (rmFirst, rmPrev, rmNext, rmLast);

  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure btnFirst_Click(sender: System.Object; e: System.EventArgs);
    procedure btnPrev_Click(sender: System.Object; e: System.EventArgs);
    procedure btnNext_Click(sender: System.Object; e: System.EventArgs);
    procedure btnLast_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    Label1: System.Web.UI.WebControls.Label;
    Label2: System.Web.UI.WebControls.Label;
    Label3: System.Web.UI.WebControls.Label;
    btnFirst: System.Web.UI.WebControls.Button;
    btnNext: System.Web.UI.WebControls.Button;
    btnPrev: System.Web.UI.WebControls.Button;
    btnLast: System.Web.UI.WebControls.Button;
    txbxFirstName: System.Web.UI.WebControls.TextBox;
    txbxLastName: System.Web.UI.WebControls.TextBox;
    txbxTitle: System.Web.UI.WebControls.TextBox;
    Label4: System.Web.UI.WebControls.Label;
    Label5: System.Web.UI.WebControls.Label;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
    procedure ReBind;
    function GetField(aFieldName: String): String;
    procedure SetRowNum(aRowMove: TRowMove);
  public
    { Public Declarations }
    function GetFirstName: String;
    function GetLastName: String;
    function GetTitle: String;
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.btnFirst.Click, Self.btnFirst_Click);
  Include(Self.btnNext.Click, Self.btnNext_Click);
  Include(Self.btnPrev.Click, Self.btnPrev_Click);
  Include(Self.btnLast.Click, Self.btnLast_Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object;
  e: System.EventArgs);
begin
  ReBind;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  InitializeComponent;
  inherited OnInit(e);
end;

function TWebForm1.GetFirstName: String;
begin
  Result := GetField('FirstName');
end;

function TWebForm1.GetLastName: String;
begin
  Result := GetField('LastName');
end;

function TWebForm1.GetTitle: String;
begin
  Result := GetField('Title');
end;

procedure TWebForm1.btnLast_Click(sender: System.Object;
  e: System.EventArgs);
begin
  SetRowNum(rmLast);
end;

procedure TWebForm1.btnNext_Click(sender: System.Object;
  e: System.EventArgs);
begin
  SetRowNum(rmNext);
end;

procedure TWebForm1.btnPrev_Click(sender: System.Object;
  e: System.EventArgs);
begin
  SetRowNum(rmPrev);
end;

procedure TWebForm1.btnFirst_Click(sender: System.Object;
  e: System.EventArgs);
begin
  SetRowNum(rmFirst);
end;

function TWebForm1.GetField(aFieldName: &String): String;
var
  dt: DataTable;
  rowNum: System.Int32;
begin
  dt := Session['Employees'] as DataTable;
  rowNum := Session['RowNum'] as System.Int32;
  result := dt.Rows[RowNum][aFieldName].ToString;
end;

procedure TWebForm1.ReBind;
var
  rowNum:  System.Int32;
  numRows: System.Int32;
begin
  txbxFirstName.DataBind;
  txbxLastName.DataBind;
  txbxTitle.DataBind;

  rowNum := Session['RowNum'] as System.Int32;
  numRows := Session['NumRows'] as System.Int32;

  btnPrev.Enabled  := rowNum > 1;
  btnFirst.Enabled := rowNum > 1;
  btnNext.Enabled  := rowNum < numRows;
  btnLast.Enabled  := rowNum < numRows;

  Label4.Text := 'Number of rows: '+numRows.ToString;
  Label5.Text := 'Row number: '+rowNum.ToString;

end;

procedure TWebForm1.SetRowNum(aRowMove: TRowMove);
var
  rowNum: System.Int32;
  numRows: System.Int32;
begin
  rowNum  := Session['RowNum'] as System.Int32;
  numRows := Session['NumRows'] as System.Int32;

  case aRowMove of
    rmFirst : rowNum := 1;
    rmPrev  : rowNum := rowNum - 1;
    rmNext  : rowNum := rowNum + 1;
    rmLast  : rowNum := numRows;
  end; // case

  Session.Add('RowNum', System.Object(RowNum));
  ReBind;
end;

end.

