
unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Data.SqlClient, System.IO;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure DataList1_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure btnUnselect_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    DataList1: System.Web.UI.WebControls.DataList;
    Label1: System.Web.UI.WebControls.Label;
    Image1: System.Web.UI.WebControls.Image;
    btnUnselect: System.Web.UI.WebControls.Button;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    { Public Declarations }
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.DataList1.SelectedIndexChanged, Self.DataList1_SelectedIndexChanged);
  Include(Self.btnUnselect.Click, Self.btnUnselect_Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}


procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel   = 'SELECT * FROM employees';
var
  sqlcn: SqlConnection;
  sqlDA: SqlDataAdapter;
  ds: DataSet;
  dt: DataTable;
begin
  Session.Add('EmpID', System.Object(-1));
  Image1.Visible := False;
  sqlcn := SqlConnection.Create(c_cnstr);
  sqlDA := SqlDataAdapter.Create(c_sel, sqlcn);
  ds := DataSet.Create;
  sqlDA.Fill(ds, 'Employees');
  dt := ds.Tables['Employees'];

  DataList1.DataSource := dt.DefaultView;
  DataBind;
  sqlcn.Close;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

procedure TWebForm1.btnUnselect_Click(sender: System.Object;
  e: System.EventArgs);
begin
  DataList1.SelectedIndex := -1;
  Label1.Text := '';
end;

procedure TWebForm1.DataList1_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel   = 'SELECT FirstName, LastName, Title, TitleOfCourtesy, Notes '+
  ' FROM employees WHERE employeeid = {0}';
var
  sqlcn: SqlConnection;
  sqlCmd: SqlCommand;
  sqlRdr: SqlDataReader;
  selStr: String;
  EmpID: Integer;
  Line: String;
begin
  Label1.Text := '';
  Image1.Visible := True;
  EmpID := Integer(DataList1.DataKeys[DataList1.SelectedIndex]);
  sqlcn := SqlConnection.Create(c_cnstr);
  selStr := System.String.Format(c_sel, [EmpID]);
  sqlCmd := SqlCommand.Create(selStr, sqlcn);

  sqlcn.Open;
  try
    sqlRdr := sqlCmd.ExecuteReader;
    sqlRdr.Read;
    Line := System.String.Format('<b>{0} {1} {2}</b><br>',
      [sqlRdr['TitleOfCourtesy'], sqlRdr['FirstName'], sqlRdr['LastName']]);
    Label1.Text := Label1.Text+Line;
    Label1.Text := Label1.Text + sqlRdr['Title'].ToString+'<hr>';
    Label1.Text := Label1.Text + sqlRdr['Notes'].ToString;
    Session.Add('EmpID', System.Object(EmpID));
  finally
    sqlcn.Close;;
  end;
end;
end.


