unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Data.SqlClient;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure DataGrid1_PageIndexChanged(source: System.Object; e: System.Web.UI.WebControls.DataGridPageChangedEventArgs);
    procedure DataGrid1_EditCommand(source: System.Object; e: System.Web.UI.WebControls.DataGridCommandEventArgs);
    procedure DataGrid1_UpdateCommand(source: System.Object; e: System.Web.UI.WebControls.DataGridCommandEventArgs);
    procedure DataGrid1_CancelCommand(source: System.Object; e: System.Web.UI.WebControls.DataGridCommandEventArgs);
    procedure DataGrid1_SortCommand(source: System.Object; e: System.Web.UI.WebControls.DataGridSortCommandEventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    Label1: System.Web.UI.WebControls.Label;
    DataGrid1: System.Web.UI.WebControls.DataGrid;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
    procedure GetData;
  public
    { Public Declarations }
    htSupplierNames: HashTable;
    htSupplierIDs: HashTable;
    function GetSupplierName(aSupplierID: Integer): String;
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.DataGrid1.PageIndexChanged, Self.DataGrid1_PageIndexChanged);
  Include(Self.DataGrid1.CancelCommand, Self.DataGrid1_CancelCommand);
  Include(Self.DataGrid1.EditCommand, Self.DataGrid1_EditCommand);
  Include(Self.DataGrid1.SortCommand, Self.DataGrid1_SortCommand);
  Include(Self.DataGrid1.UpdateCommand, Self.DataGrid1_UpdateCommand);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel_prod   = 'SELECT * FROM products';
  c_sel_sup    = 'SELECT companyname, supplierid FROM suppliers';

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
var
  SelStr: String;
begin
  if not IsPostBack then
  begin
    SelStr := c_sel_prod;
    Session.Add('SelStr', SelStr);
    GetData;
  end;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  InitializeComponent;
  inherited OnInit(e);
  Include(Self.DataGrid1.PageIndexChanged, Self.DataGrid1_PageIndexChanged);
  Include(Self.DataGrid1.CancelCommand, Self.DataGrid1_CancelCommand);
  Include(Self.DataGrid1.EditCommand, Self.DataGrid1_EditCommand);
  Include(Self.DataGrid1.SortCommand, Self.DataGrid1_SortCommand);
  Include(Self.DataGrid1.UpdateCommand, Self.DataGrid1_UpdateCommand);
end;

procedure TWebForm1.DataGrid1_CancelCommand(source: System.Object;
  e: System.Web.UI.WebControls.DataGridCommandEventArgs);
begin
  DataGrid1.EditItemIndex := -1;
  GetData;
end;

procedure TWebForm1.DataGrid1_UpdateCommand(source: System.Object;
  e: System.Web.UI.WebControls.DataGridCommandEventArgs);
var
  tb: TextBox;
  cb: CheckBox;
  ddl: DropDownList;
  ddlStr: String;
begin
  GetData;

  tb := e.Item.Cells[1].Controls[0] as TextBox;
  Label1.Text := tb.Text+'<br>';
  tb := e.Item.Cells[2].Controls[0] as TextBox;
  Label1.Text := Label1.Text + tb.Text+'<br>';
  tb := e.Item.Cells[3].Controls[0] as TextBox;
  Label1.Text := Label1.Text + tb.Text+'<br>';
  cb := e.Item.FindControl('CheckBox1') as CheckBox;
  Label1.Text := Label1.Text + Convert.ToString(cb.Checked)+'<br>';
  ddl := e.Item.FindControl('DropDownList1') as DropDownList;
  ddlStr := ddl.Items[ddl.SelectedIndex].Value;
  Label1.Text := Label1.Text + ddlStr +
  ': '+ htSupplierIDs[ddlStr].ToString;

  // Write Updates to the Data source
  DataGrid1.EditItemIndex := -1;
  DataGrid1.DataBind;
end;

procedure TWebForm1.DataGrid1_EditCommand(source: System.Object;
  e: System.Web.UI.WebControls.DataGridCommandEventArgs);
begin
  DataGrid1.EditItemIndex := e.Item.ItemIndex;
  GetData;
end;

procedure TWebForm1.DataGrid1_PageIndexChanged(source: System.Object;
  e: System.Web.UI.WebControls.DataGridPageChangedEventArgs);
begin
 DataGrid1.CurrentPageIndex := e.NewPageIndex;
 GetData;
end;

function TWebForm1.GetSupplierName(aSupplierID: Integer): String;
begin
  Result := htSupplierNames[aSupplierID.ToString] as System.String;
end;

procedure TWebForm1.DataGrid1_SortCommand(source: System.Object;
  e: System.Web.UI.WebControls.DataGridSortCommandEventArgs);
var
  SelStr: String;
begin
  SelStr := c_sel_prod + ' ' + e.SortExpression;
  Session.Add('SelStr', SelStr);
  GetData;
end;

procedure TWebForm1.GetData;
var
  sqlcn: SqlConnection;
  sqlDA: SqlDataAdapter;
  sqlCmd: SqlCommand;
  sqlRdr: SqlDataReader;
  ds: DataSet;
  dt: DataTable;
  SelStr: String;
begin

  SelStr := Session['SelStr'] as System.String;
  sqlcn := SqlConnection.Create(c_cnstr);
  sqlDA := SqlDataAdapter.Create(SelStr, sqlcn);
  ds := DataSet.Create;
  sqlDA.Fill(ds, 'products');

  htSupplierNames := HashTable.Create;
  htSupplierIDs   := HashTable.Create;

  sqlCmd := SqlCommand.Create(c_sel_sup, sqlcn);
  sqlcn.Open;
  try
    sqlRdr := sqlCmd.ExecuteReader;
    while sqlRdr.Read do
    begin
      htSupplierIDs.Add(sqlRdr['CompanyName'].ToString,
        sqlRdr['SupplierID'].ToString);
      htSupplierNames.Add(sqlRdr['SupplierID'].ToString,
        sqlRdr['CompanyName']);
    end;
  finally
    sqlcn.Close;
  end;

  DataGrid1.DataKeyField := 'ProductID';
  dt := ds.Tables['Products'];
  DataGrid1.DataSource := dt.DefaultView;
  DataBind;

end;

end.

