unit DwnLdForm;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.IO, System.Web.Mail, System.Data.SqlClient, Borland.Vcl.Classes;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
{$REGION 'Controls'}
    Label1: System.Web.UI.WebControls.Label;
    Label2: System.Web.UI.WebControls.Label;
    Label3: System.Web.UI.WebControls.Label;
    Label4: System.Web.UI.WebControls.Label;
    Label5: System.Web.UI.WebControls.Label;
    Label6: System.Web.UI.WebControls.Label;
    Label7: System.Web.UI.WebControls.Label;
    Label8: System.Web.UI.WebControls.Label;
    Label9: System.Web.UI.WebControls.Label;
    Label10: System.Web.UI.WebControls.Label;
    Label11: System.Web.UI.WebControls.Label;
    Label12: System.Web.UI.WebControls.Label;
    Label13: System.Web.UI.WebControls.Label;
    Label14: System.Web.UI.WebControls.Label;
    Label15: System.Web.UI.WebControls.Label;
    Label16: System.Web.UI.WebControls.Label;
    Label17: System.Web.UI.WebControls.Label;
    tbxLastName: System.Web.UI.WebControls.TextBox;
    tbxTitle: System.Web.UI.WebControls.TextBox;
    tbxEmail: System.Web.UI.WebControls.TextBox;
    tbxCompany: System.Web.UI.WebControls.TextBox;
    tbxAddress1: System.Web.UI.WebControls.TextBox;
    tbxAddress2: System.Web.UI.WebControls.TextBox;
    tbxCity: System.Web.UI.WebControls.TextBox;
    tbxPostalCode: System.Web.UI.WebControls.TextBox;
    tbxTelephone: System.Web.UI.WebControls.TextBox;
    tbxFax: System.Web.UI.WebControls.TextBox;
    tbxURL: System.Web.UI.WebControls.TextBox;
    ddlCountry: System.Web.UI.WebControls.DropDownList;
    ddlState: System.Web.UI.WebControls.DropDownList;
    cbxFreeStuff: System.Web.UI.WebControls.CheckBox;
    Button1: System.Web.UI.WebControls.Button;
    RequiredFieldValidator1: System.Web.UI.WebControls.RequiredFieldValidator;
    RequiredFieldValidator2: System.Web.UI.WebControls.RequiredFieldValidator;
    RegularExpressionValidator1: System.Web.UI.WebControls.RegularExpressionValidator;
    tbxFirstName: System.Web.UI.WebControls.TextBox;
    RequiredFieldValidator3: System.Web.UI.WebControls.RequiredFieldValidator;
    Label18: System.Web.UI.WebControls.Label;
{$ENDREGION}
    procedure OnInit(e: EventArgs); override;
    procedure SendEmail(aEmail: String);
  private
    { Private Declarations }

    procedure GetData;
    procedure SaveUserInfo;
  public
    aryCountryName: array of String;
    aryCountryAbbr: array of String;
    aryStateName: array of String;
    aryStateAbbr: array of String;
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

const
  c_cnstr = 'server=XWING;database=ddg_download;Trusted_Connection=Yes';

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  if IsPostBack then
  begin
    SaveUserInfo;
    SendEMail(tbxEmail.Text);
    Response.Redirect('ThankYouForm.aspx');
  end
  else GetData;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  InitializeComponent;
  inherited OnInit(e);
end;

function GetCommand(aFileName: String): String;
var
  sr: StreamReader;
begin
  if System.IO.File.Exists(aFileName) then
  begin
    sr := StreamReader.Create(System.IO.File.OpenRead(aFileName));
    try
      Result := sr.ReadToEnd;
    finally
      sr.Close;
    end;
  end;
end;

procedure TWebForm1.SaveUserInfo;
var
  sqlCmd: SqlCommand;
  sqlcn: SqlConnection;
  idx: Integer;
begin
  GetData;
  sqlcn := SqlConnection.Create(c_cnstr);
  sqlCmd := SqlCommand.Create(GetCommand(
    Request.PhysicalApplicationPath+'c_ins.sql'), sqlCn);

  sqlcn.Open;
  try
    sqlCmd.Parameters.Add('@first_name',  SqlDbType.NVarChar, 20);
    sqlCmd.Parameters.Add('@last_name',   SqlDbType.NVarChar, 20);
    SqlCmd.Parameters.Add('@title',       SqlDbType.NVarChar, 40);
    SqlCmd.Parameters.Add('@email',       SqlDbType.NVarChar, 50);
    SqlCmd.Parameters.Add('@company',     SqlDbType.NVarChar, 100);
    SqlCmd.Parameters.Add('@address_1',   SqlDbType.NVarChar, 100);
    SqlCmd.Parameters.Add('@address_2',   SqlDbType.NVarChar, 100);
    SqlCmd.Parameters.Add('@city',        SqlDbType.NVarChar, 50);
    SqlCmd.Parameters.Add('@postal_code', SqlDbType.NVarChar, 15);
    SqlCmd.Parameters.Add('@telephone',   SqlDbType.NVarChar, 20);
    SqlCmd.Parameters.Add('@fax',         SqlDbType.NVarChar, 20);
    SqlCmd.Parameters.Add('@url',         SqlDbType.NVarChar, 50);
    SqlCmd.Parameters.Add('@send_free',   SqlDbType.Bit);
    SqlCmd.Parameters.Add('@country_id',  SqlDbType.Char, 2);
    SqlCmd.Parameters.Add('@state_id',    SqlDbType.Char, 2);
    SqlCmd.Parameters.Add('@date_downloaded', SqlDbType.DateTime);

    // Add Values to the Command

    sqlCmd.Parameters['@first_name'].Value  := tbxFirstName.Text;
    sqlCmd.Parameters['@last_name'].Value   := tbxLastName.Text;
    sqlCmd.Parameters['@title'].Value       := tbxTitle.Text;
    sqlCmd.Parameters['@email'].Value       := tbxEmail.Text;
    sqlCmd.Parameters['@company'].Value     := tbxCompany.Text;
    sqlCmd.Parameters['@address_1'].Value   := tbxAddress1.Text;
    sqlCmd.Parameters['@address_2'].Value   := tbxAddress2.Text;
    sqlCmd.Parameters['@city'].Value        := tbxCity.Text;
    sqlCmd.Parameters['@postal_code'].Value := tbxPostalCode.Text;
    sqlCmd.Parameters['@telephone'].Value   := tbxTelephone.Text;
    sqlCmd.Parameters['@fax'].Value         := tbxFax.Text;
    sqlCmd.Parameters['@url'].Value         := tbxUrl.Text;
    sqlCmd.Parameters['@send_free'].Value   :=
      System.Object(cbxFreeStuff.Checked);

    idx := System.Array.IndexOf(aryCountryName,
      ddlCountry.Items[ddlCountry.SelectedIndex].Text);
    sqlCmd.Parameters['@country_id'].Value  := aryCountryAbbr[idx];

    idx := System.Array.IndexOf(aryStateName,
      ddlState.Items[ddlState.SelectedIndex].Text);
    sqlCmd.Parameters['@state_id'].Value    := aryStateAbbr[idx];

    sqlCmd.Parameters['@date_downloaded'].Value := System.DateTime.Now;
    sqlCmd.ExecuteNonQuery;
  finally
    sqlcn.Close;
  end;
end;

procedure TWebForm1.SendEmail(aEmail: &String);
var
  MailMsg: MailMessage;
  sr: StreamReader;
begin
  MailMsg := MailMessage.Create;
  MailMsg.From    := 'info@xapware.com';
  MailMsg.&To      := aEmail;
  MailMsg.Bcc     := 'sales@somehwere.com';
  MailMsg.Subject := 'Your request to download XYZ Product';
  MailMsg.BodyFormat := MailFormat.HTML;

  sr := StreamReader.Create(System.IO.File.OpenRead(
    Request.PhysicalApplicationPath+'dnloadmail.htm'));
  try
    MailMsg.Body := sr.ReadToEnd;
  finally
    sr.Close;
  end;

  SmtpMail.SmtpServer := 'localhost';
  SmtpMail.Send(MailMsg);
end;

procedure TWebForm1.GetData;
const
  c_sel_ccount = 'SELECT count(*) as count from lu_country';
  c_sel_scount = 'SELECT count(*) as count from lu_state';
  c_sel_country = 'SELECT * FROM lu_country';
  c_sel_state = 'SELECT * FROM lu_state;';
var
  sqlcn: SqlConnection;
  sqlCmd: SqlCommand;
  sqlRdr: SqlDataReader;
  count: integer;
  idx: Integer;
begin
  sqlcn := SqlConnection.Create(c_cnstr);

  sqlcn.Open;
  try
    sqlCmd := SqlCommand.Create(c_sel_ccount, sqlcn);
    count := Integer(sqlCmd.ExecuteScalar);
    SetLength(aryCountryName, count);
    SetLength(aryCountryAbbr, count);

    sqlCmd := SqlCommand.Create(c_sel_scount, sqlcn);
    count := Integer(sqlCmd.ExecuteScalar);
    SetLength(aryStateName, count);
    SetLength(aryStateAbbr, count);
  finally
    sqlcn.Close;
  end;

  sqlcn.Open;
  try
    sqlCmd := SqlCommand.Create(c_sel_country, sqlcn);
    sqlRdr := sqlCmd.ExecuteReader;
    idx := 0;
    while sqlRdr.Read do
    begin
      aryCountryAbbr[idx] := sqlRdr['country_id'].ToString;
      aryCountryName[idx] := sqlRdr['country_name'].ToString;
      inc(idx);
    end;
  finally
    sqlcn.Close;
  end;

  sqlcn.Open;
  try
    sqlCmd := SqlCommand.Create(c_sel_state, sqlcn);
    sqlRdr := sqlCmd.ExecuteReader;
    idx := 0;
    while sqlRdr.Read do
    begin
      aryStateAbbr[idx] := sqlRdr['state_id'].ToString;
      aryStateName[idx] := sqlRdr['state_name'].ToString;
      inc(idx);
    end;
  finally
    sqlcn.Close;
  end;

  DataBind;
end;

end.

