unit WebService1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Diagnostics, System.Web,
  System.Web.Services, System.Web.Services.Protocols,
  System.Security.Cryptography, System.Text;

type

  TAuth = class(SoapHeader)
    UserName: String;
    Password: String;
  end;

  TWebService1 = class(System.Web.Services.WebService)
  {$REGION 'Designer Managed Code'}
  strict private
    components: IContainer;
    procedure InitializeComponent;
  {$ENDREGION}
  strict protected
    procedure Dispose(disposing: boolean); override;
  private
    function Authenticate(aUserName, aPassword: String): Boolean;
  public
    Auth: TAuth;
    constructor Create;
    [WebMethod(), SoapHeader('Auth')]
    function HelloWorld: string;
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebService1.InitializeComponent;
begin

end;
{$ENDREGION}

constructor TWebService1.Create;
begin
  inherited;
  InitializeComponent;
end;

procedure TWebService1.Dispose(disposing: boolean);
begin
  if disposing and (components <> nil) then
    components.Dispose;
  inherited Dispose(disposing);
end;

function TWebService1.HelloWorld: string;
begin
  if Auth = nil then
    raise Exception.Create('Invalid Login');

  if Authenticate(Auth.UserName, Auth.Password)  then
    Result := 'You are logged in.'
  else
    Result := 'Incorrect username/password combo';
end;

function TWebService1.Authenticate(aUserName, aPassword: String): Boolean;
var
  PasswordInDB: array of byte;
  encoder: UTF8Encoding;
  md5Hasher: MD5CryptoServiceProvider;
  HashedBytes: array of byte;
  dbPWStr: String;
  aPWStr: String;
  i: integer;
begin
  try
    encoder := UTF8Encoding.Create;
    md5Hasher := MD5CryptoServiceProvider.Create;
    // Pretend you've gotten the hashed password from teh Database
    PasswordInDB :=
      md5Hasher.ComputeHash(encoder.GetBytes('ZacharyCamaro'));

    aPWStr := aUserName + APassword;
    // Hash the password passed in.
    HashedBytes := md5Hasher.ComputeHash(encoder.GetBytes(aPWStr));
    aPWStr := '';

    // Convert to regular strings
    for i := Low(PasswordInDB) to High(PasswordInDB) do
      dbPWStr :=   dbPWStr + Convert.ToString(PasswordInDB[i], 16);

    for i := Low(HashedBytes) to High(HashedBytes) do
      aPWStr :=   aPWStr + Convert.ToString(HashedBytes[i], 16);

    // Compare
    Result := System.String.Compare(dbPWStr, aPWStr) = 0;

  except
    Result := False;
  end;
end;

end.

