unit BankShared;

interface

type
  { TAccount }
  [Serializable]
  TAccount = class
  private
    fNumber : integer;
    fBalance: double;
    fName: string;

  public
    constructor Create(const aNumber : integer;
                       const aName : string;
                       const aBalance : double);

    property Number : integer read fNumber;
    property Name : string read fName;
    property Balance : double read fBalance write fBalance;
  end;

  { IBankManager }
  TAccountNumberArray = array of integer;

  IBankManager = interface
    function GetAccountNumbers : TAccountNumberArray;
    function GetAccount(const AccountNumber : integer) : TAccount;
    procedure TransferMoney(const Origin, Destination : integer;
                            const Amount : double);
  end;

implementation

{ TAccount }

constructor TAccount.Create(const aNumber : integer;
                       const aName : string;
                       const aBalance : double);
begin
  inherited Create;

  fNumber := aNumber;
  fName := aName;
  fBalance := aBalance;
end;

end.
