unit SimpleServer_Impl;

interface

uses
  SharedInterfaces;

type
  { TSimpleServer }
  TSimpleServer = class(MarshalByRefObject, ISimpleServer)
  private
    fValue : integer;

  protected
    function GetValue: Integer;
    procedure SetValue(Value: Integer);

  public
    constructor Create; overload;
    constructor Create(Value : integer); overload;
  end;

implementation

{ TSimpleServer }

constructor TSimpleServer.Create;
begin
  inherited;

  Console.WriteLine('Creating TSimpleServer with empty constructor');
end;

constructor TSimpleServer.Create(Value: integer);
begin
  inherited Create;

  fValue := Value;
                   
  Console.WriteLine('Creating TSimpleServer with value '+Int32(Value).ToString);
end;

function TSimpleServer.GetValue: Integer;
begin
  result := fValue;

  Console.WriteLine('Getting value '+Int32(result).ToString);
end;

procedure TSimpleServer.SetValue(Value: Integer);
begin
  fValue := Value;

  Console.WriteLine('Setting value '+Int32(Value).ToString);
end;

end.
