program Client;

{$APPTYPE CONSOLE}

{%DelphiDotNetAssemblyCompiler 'c:\program files\common files\borland shared\bds\shared assemblies\2.0\Borland.Delphi.dll'}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Runtime.Remoting.dll'}
{%DelphiDotNetAssemblyCompiler 'SharedPackage.dll'}

uses
  SysUtils,
  SharedInterfaces,
  System.Runtime.Remoting,
  System.Runtime.Remoting.Channels,
  System.Runtime.Remoting.Channels.HTTP;

var SimpleFactory : ISimpleFactory;
    SimpleSrv1,
    SimpleSrv2 : ISimpleServer;
    Channel : HttpChannel;
begin
  Channel := HttpChannel.Create(0);
  ChannelServices.RegisterChannel(Channel);

  SimpleFactory := Activator.GetObject(
    typeof(ISimpleServer),
    'http://localhost:8099/SimpleFactory.soap');

  SimpleSrv1 := SimpleFactory.NewInstanceWithValue(5);
  SimpleSrv2 := SimpleFactory.NewInstance;

  Writeln('SimpleServer1''s value is '+IntToStr(SimpleSrv1.Value));
  Writeln('SimpleServer2''s value is '+IntToStr(SimpleSrv2.Value));
  Writeln('Setting simpleServer2''s value to 2');
  SimpleSrv2.Value := 2;

  Writeln;
  Writeln('It''s now '+TimeToStr(Now)+'. Press enter to continue reading the values');
  Readln;
  Writeln('It''s now '+TimeToStr(Now)+'. Attempting to read the values');

  Writeln;
  try
    Writeln('SimpleServer2''s value is '+IntToStr(SimpleSrv2.Value));
    Writeln('SimpleServer1''s value is '+IntToStr(SimpleSrv1.Value));
    Writeln;
    Writeln('All went fine! Press enter to terminate');
  except
    on E:Exception do begin
      Writeln;
      Writeln('An exception has been raised. The message was "'+
              E.Message+'" .Press enter to terminate');
    end;
  end;

  Readln;
end.
