program Client;

{$APPTYPE CONSOLE}

{%DelphiDotNetAssemblyCompiler 'c:\program files\common files\borland shared\bds\shared assemblies\2.0\Borland.Delphi.dll'}
{%DelphiDotNetAssemblyCompiler '$(SystemRoot)\microsoft.net\framework\v1.1.4322\System.Runtime.Remoting.dll'}
{%DelphiDotNetAssemblyCompiler 'SharedPackage.dll'}

uses
  SharedInterfaces,
  System.Runtime.Remoting,
  System.Runtime.Remoting.Channels,
  System.Runtime.Remoting.Channels.HTTP,
  RemotingHelper in 'RemotingHelper.pas';

var SimpleFactory : ISimpleFactory;
    SimpleSrv1,
    SimpleSrv2 : ISimpleServer;
    RemotingHelper : TRemotingHelper;
var args : System.Array;
    filename : string = 'Client.Config.xml';
begin
  // Reads the command line arguments
  args := Environment.GetCommandLineArgs;
  if args.Length>1 then
    filename := args.GetValue(1).ToString+filename;

  // Configures the remoting infrastructure
  Console.WriteLine('Initializing the client by reading the file '+filename);
  RemotingConfiguration.Configure(filename);

  RemotingHelper := TRemotingHelper.Create;

  SimpleFactory := RemotingHelper.GetRemoteObjectRef(
    typeof(SharedInterfaces.ISimpleFactory));

  SimpleSrv1 := SimpleFactory.NewInstanceWithValue(5);
  SimpleSrv2 := SimpleFactory.NewInstance;

  Console.WriteLine('SimpleServer1''s value is '+Int32(SimpleSrv1.Value).ToString);
  Console.WriteLine('SimpleServer2''s value is '+Int32(SimpleSrv2.Value).ToString);
  Console.WriteLine('Setting simpleServer2''s value to 2');
  SimpleSrv2.Value := 2;
  Console.WriteLine('SimpleServer2''s value is '+Int32(SimpleSrv2.Value).ToString);
  Console.WriteLine('SimpleServer1''s value is '+Int32(SimpleSrv1.Value).ToString);
  Console.WriteLine('Press enter to terminate');
  Console.ReadLine;
end.
