unit RemotingHelper;

interface

uses
  System.Collections,
  System.Runtime.Remoting;

type
  { TRemotingHelper }
  TRemotingHelper = class
  private
    fIsInitialized : boolean;
    fWellKnownTypes : IDictionary;

    procedure InitTypeCache; 
  public
    function GetRemoteObjectRef(aType : system.type) : TObject;
  end;


implementation

{ TRemotingHelper }

function TRemotingHelper.GetRemoteObjectRef(aType: system.type): TObject;
var entry : WellKnownClientTypeEntry;
begin
  if not fIsInitialized
    then InitTypeCache;

  entry := fWellKnownTypes[aType] as WellKnownClientTypeEntry;

  if (entry=NIL)
    then raise Exception.Create('Type not found!');

  result := Activator.GetObject(entry.ObjectType,entry.ObjectUrl);
end;

procedure TRemotingHelper.InitTypeCache;
var i : integer;
    arr : array of WellKnownClientTypeEntry;
    entry : WellKnownClientTypeEntry;
begin
  fWellKnownTypes := Hashtable.Create;

  arr := RemotingConfiguration.GetRegisteredWellKnownClientTypes;
  for i := 0 to Length(arr)-1 do begin
    entry := arr[i];
    fWellKnownTypes.Add(entry.ObjectType, entry);
  end;

  fIsInitialized := TRUE;
end;

end.
