unit SimpleServer_Factory;

interface

uses
  SharedInterfaces,
  SimpleServer_Impl;

type
  TSimpleFactory = class(MarshalByRefObject, ISimpleFactory)
  protected
    function NewInstance: ISimpleServer;
    function NewInstanceWithValue(Value: Integer): ISimpleServer;

  end;


implementation

[assembly: RuntimeRequiredAttribute(TypeOf(TSimpleFactory))]

{ TSimpleFactory }

function TSimpleFactory.NewInstance: ISimpleServer;
begin
  result := TSimpleServer.Create;
end;

function TSimpleFactory.NewInstanceWithValue(
  Value: Integer): ISimpleServer;
begin
  result := TSimpleServer.Create(Value);
end;

end.
