
unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Data.SqlClient, System.Web.Caching;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure DataGrid1_PageIndexChanged(source: System.Object; e: System.Web.UI.WebControls.DataGridPageChangedEventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    Label1: System.Web.UI.WebControls.Label;
    DataGrid1: System.Web.UI.WebControls.DataGrid;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
    procedure GetData;
  public
    { Public Declarations }
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.DataGrid1.PageIndexChanged, Self.DataGrid1_PageIndexChanged);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}


const
  c_cnstr = 'server=XWING;database=Northwind;Trusted_Connection=Yes';
  c_sel   = 'select * from employees';

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  if not IsPostBack then
    GetData;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;


procedure TWebForm1.GetData;
var
  sqlcn: SqlConnection;
  sqlDa: SqlDataAdapter;
  Ds: DataSet;
  dtView: DataView;
begin
  dtView := Cache['dvEmp'] as DataView;
  if dtView = nil then
  begin
    sqlcn := SqlConnection.Create(c_cnstr);
    sqlDA := SqlDataAdapter.Create(c_sel, sqlcn);
    Ds := DataSet.Create;
    sqlDA.Fill(Ds);
    try
      dtView := DataView.Create(Ds.Tables['Table']);
      Cache.Insert('dvEmp', dtView,
        CacheDependency.Create(MapPath('cache.txt')));
      Label1.Text := 'From Database';
    finally
      sqlcn.Close;
    end;
  end
  else
    Label1.Text := 'From Cache';
  DataGrid1.DataSource := dtView;
  DataBind;
end;

procedure TWebForm1.DataGrid1_PageIndexChanged(source: System.Object;
  e: System.Web.UI.WebControls.DataGridPageChangedEventArgs);
begin
   GetData;
   DataGrid1.CurrentPageIndex := e.NewPageIndex;
   DataGrid1.DataBind;
end;

end.


