
unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Web.Caching;
type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure btnGetLog_Click(sender: System.Object; e: System.EventArgs);
    procedure btnRemove_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    DataGrid1: System.Web.UI.WebControls.DataGrid;
    btnGetLog: System.Web.UI.WebControls.Button;
    btnRemove: System.Web.UI.WebControls.Button;
    Label1: System.Web.UI.WebControls.Label;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
    FItemArray: ArrayList;
    procedure CacheItemRemoved(Key: String; Value: System.Object; Reason:
      CacheItemRemovedReason);

  public
    { Public Declarations }
  end;

implementation

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.btnGetLog.Click, Self.btnGetLog_Click);
  Include(Self.btnRemove.Click, Self.btnRemove_Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
var
  keyAry: array[0..0] of String;
begin
  if not IsPostBack then
  begin
    Cache.Insert('Item1', 'Item 1', nil,
      System.DateTime.Now.AddSeconds(10), Cache.NoSlidingExpiration,
      CacheItemPriority.Default, CacheItemRemoved);
    Cache.Insert('Item2', 'Item 2', nil,
      System.DateTime.Now.AddSeconds(10), Cache.NoSlidingExpiration,
      CacheItemPriority.Default, CacheItemRemoved);
    keyAry[0] := 'Item2';
    Cache.Insert('Item3', 'Item 3', CacheDependency.Create(nil, keyAry),
      System.DateTime.Now.AddSeconds(10), Cache.NoSlidingExpiration,
      CacheItemPriority.Default, CacheItemRemoved);
    FItemArray := ArrayList.Create;
  end;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  InitializeComponent;
  inherited OnInit(e);
end;

procedure TWebForm1.CacheItemRemoved(Key: System.String; Value: TObject;
  Reason: CacheItemRemovedReason);
begin
  FItemArray := Application['Log'] as ArrayList;
  if FItemArray = nil then
  begin
    FItemArray := ArrayList.Create;
    Application['Log'] := FItemArray;
  end;
  FItemArray.Add(Key+': '+Enum(Reason).ToString());
end;

procedure TWebForm1.btnRemove_Click(sender: System.Object;
  e: System.EventArgs);
begin
  Cache.Remove('Item2');
  btnGetLog_Click(nil, nil);
end;

procedure TWebForm1.btnGetLog_Click(sender: System.Object;
  e: System.EventArgs);
begin
  if Application['Log'] <> nil then
  begin
    DataGrid1.DataSource := Application['Log'];
    DataGrid1.DataBind;
    DataBind;
  end;
  Label1.Text := 'Items cached: '+Cache.Count.ToString
end;

end.

