unit uPersistentTextControl;

interface

uses
       System.Web
     , System.Web.UI
     , System.ComponentModel
     ;

type
  [DefaultProperty('DisplayText')]
  TPersistentTextControl = class(System.Web.UI.Control)
  strict protected
    procedure Render(Writer: HtmlTextWriter); override;
  public
    constructor Create;
  published
    function GetDisplayText: string;
    procedure SetDisplayText(const Value: &string);
  published
    [
     DefaultValue(''),
     Description('The text that will be displayed in the control.'),
     Category('Appearance'),
     Bindable(True)
    ]
    property DisplayText: string read GetDisplayText write SetDisplayText;
  end;

implementation

constructor TPersistentTextControl.Create;
begin
  inherited Create;
  ViewState['DisplayText'] := '';
end;

function TPersistentTextControl.GetDisplayText: string;
var
  O: TObject;
begin
  O := ViewState['DisplayText'];
  if O <> nil then
  begin
    Result := ViewState['DisplayText'].ToString;
  end else
  begin
    Result := '';
  end;
end;

procedure TPersistentTextControl.Render(Writer: HtmlTextWriter);
begin
  Writer.Write(DisplayText);
end;

procedure TPersistentTextControl.SetDisplayText(const Value: &string);
begin
  ViewState['DisplayText'] := Value;
end;

end.
