unit uSimpleTextControl;

interface

uses
       System.Web
     , System.Web.UI
     , System.ComponentModel
     ;

type
  [DefaultProperty('DisplayText')]
  TSimpleTextControl = class(System.Web.UI.Control)
  strict private
    FDisplayText: string;
  strict protected
    procedure Render(Writer: HtmlTextWriter); override;
  public
    constructor Create;
  published
    function GetDisplayText: string;
    procedure SetDisplayText(const Value: &string);
  published
    [
     DefaultValue(''),
     Description('The text that will be displayed in the control.'),
     Category('Appearance'),
     Bindable(True)
    ]
    property DisplayText: string read GetDisplayText write SetDisplayText;
  end;

implementation

constructor TSimpleTextControl.Create;
begin
  inherited Create;
end;


function TSimpleTextControl.GetDisplayText: string;
begin
  Result := FDisplayText;
end;

procedure TSimpleTextControl.Render(Writer: HtmlTextWriter);
begin
  Writer.Write(DisplayText);
end;

procedure TSimpleTextControl.SetDisplayText(const Value: &string);
begin
  if FDisplayText <> Value then
  begin
    FDisplayText := Value;
  end;
end;

end.
