unit uSimpleWebControl;

interface

uses
       System.Web
     , System.Web.UI
     , System.Web.UI.WebControls
     , System.ComponentModel
     ;

type
  [DefaultProperty('DisplayText')]
  TSimpleWebControl = class(System.Web.UI.WebControls.WebControl)
  strict protected
    procedure RenderContents(Writer: HtmlTextWriter); override;
  public
    constructor Create;
  published
    function GetDisplayText: string;
    procedure SetDisplayText(const Value: &string);
  published
    [
     DefaultValue(''),
     Description('The text that will be displayed in the control'),
     Category('Appearance'),
     Bindable(True)
    ]
    property DisplayText: string read GetDisplayText write SetDisplayText;
  end;

implementation

constructor TSimpleWebControl.Create;
begin
  inherited Create;
  ViewState['DisplayText'] := '';
end;

function TSimpleWebControl.GetDisplayText: string;
var
  Obj: TObject;
begin
  Obj := ViewState['DisplayText'];
  if Obj <> nil then
  begin
    Result := ViewState['DisplayText'].ToString;
  end else
  begin
    Result := '';
  end;
end;

procedure TSimpleWebControl.RenderContents(Writer: HtmlTextWriter);
begin
  Writer.Write(DisplayText);
end;

procedure TSimpleWebControl.SetDisplayText(const Value: &string);
begin
  ViewState['DisplayText'] := Value;
end;

end.
